2008-10-13  Zoltan Varga  <vargaz@gmail.com>

	Backport of r115632.
	
	* mini-amd64.c (mono_arch_output_basic_block): Fix the changes to
	OP_X86_PUSH_OBJ. Fixes #434620.

	* objects.cs: Add a test.

2008-10-12  Zoltan Varga  <vargaz@gmail.com>

	Backport of r115495.
	
	* tramp-amd64.c (mono_arch_create_rgctx_lazy_fetch_trampoline_full): Increase
	the max length to 64.

2008-10-11  Zoltan Varga  <vargaz@gmail.com>

	Backport of r113918.
	
	* inssel.brg (mini_emit_castclass): Avoid the szarray!=array checks for
	arrays of arrays. Fixes #428406.

	Backport of r111722. Fixes #434544.

	2008-08-27  Bill Holmes  <billholmes54 at gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block) : Fix the OP_X86_PUSH_OBJ
	  case to keep the stack aligned to 8.

	Contributed under MIT/X11 license.

Wed Oct 8 16:35:43 CEST 2008 Paolo Molaro <lupus@ximian.com>

	* mini.c: add a workaround for a common screwup that ends up blamed
	to mono (other processes blocking signal delivery).

2008-10-07  Zoltan Varga  <vargaz@gmail.com>

	Backport of r115144.
	
	* mini.c (mono_method_to_ir): Clear ins_flag on all code paths
	in the LDFLD/STFLD opcodes. Fixes #432673.

2008-10-07  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_wrappers): Fix Delegate/MulticastDelegate classes
	when adding delegate-invoke wrappers.

2008-10-06  Zoltan Varga  <vargaz@gmail.com>

	Backport of r114307.
	
	* driver.c (mono_main): Add a workaround for shutdown crashes seen on
	amd64, where the libc stack unwinder encounters stack frames referring to
	native code in unmapped memory.
	
	Backport of r114416.
	
	* mini-ia64.c (emit_move_return_value): Convert float return values to
	double.

	* objects.cs: Add a new test.
	
	Backport of r114401.
	
	* mini-ia64.c (mono_arch_allocate_vars): Disable fp elimination for
	VARARG methods to fix an assert later.

	Backport of r114973.
	
	* aot-compiler.c (add_wrappers): Add delegate-invoke wrappers.
	
	Backport of r114617.
	
	* aot-compiler.c (emit_globals): Avoid invalid characters in
	the static linking symbol.
	
	Backport of r114713.
	
	* aot-compiler.c (emit_exception_debug_info): Use jinfo->used_regs instead of
	cfg->used_int_regs, since the two are different on arm.

	Backport of r114299.
	
	* mini-arm.h driver.c: Print the fp model when using --version on arm. Also,
	add a check that one of the ARM_FPU_ constants is defined.
	
	* mini.c cfold.c graph.c ssa.c aot-runtime.c local-propagation.c
	driver.c mini-codegen.c mini-amd64.c mini-arm.c: Add support for removing
	the JIT using the --enable-minimal=jit configure option.

	* inssel-sparc.brg: Remove an incorrect reg: CEE_LDIND_I8 (OP_REGVAR) rule.
	Fixes #426264.

2008-09-26  Zoltan Varga  <vargaz@gmail.com>

	Backport of r114163.
	
	* mini-trampolines.c (mono_delegate_trampoline): Add wrappers even if
	delegate->method_ptr is set. Fixes #428054.

2008-09-08  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_wrapper_info): Omit the klass name from
	runtime-invoke wrappers to work around the problem of them getting
	assigned to a random class.

	* aot-runtime.c (mono_aot_get_method): Ditto.

2008-09-06  Zoltan Varga  <vargaz@gmail.com>
	
	* mini.h (MONO_AOT_FILE_VERSION): Bump this because of the arm AOT
	changes.

	* mini.c (mono_spill_call): Handle pinvoke+soft float on arm.

	* aot-runtime.c (mono_aot_get_method): Add another cache mapping wrapper
	methods to their code to avoid computing the full name of wrappers and
	doing a lookup in a string hash table.

2008-09-05  Zoltan Varga  <vargaz@gmail.com>

	* tramp-arm.c (mono_arch_nullify_class_init_trampoline): Implement this.
	(mono_arch_patch_plt_entry): Fix the calculation of the jump_entry.
	(mono_arch_get_nullified_class_init_trampoline): Return 'code' instead of
	'buf'.

	* aot-compiler.c (emit_plt): Fix the arm plt entries, previously they all 
	jumped to the same entry in plt_jump_table.

2008-09-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (initialize_array_data): Handle field with RVA from
	dynamic images.
	(Ported from trunk)

2008-08-29  Geoff Norton  <gnorton@novell.com>

	* aot-compiler.c: The Mach/ARM compiler doesn't understand the bss
	segment, and doesn't properly handle .space as .text.  Fixes
	AOT Mach/ARM

2008-08-29  Geoff Norton  <gnorton@novell.com>

	* mini.c: Disable the mach exception handler when running on 
	ARM

2008-08-29  Geoff Norton  <gnorton@novell.com>

	* aot-compiler.c: Patch from Renaldas Zioma to properly register 
	globals on Darwin/ARM

2008-08-28  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Avoid not initializing the runtime when doing AOT compilation, 
	since too many things depend on it. Instead, call 
	mono_runtime_set_no_exec ().
	
	* aot-compiler.c: Add an 'asm-only' AOT option.

	* mini.c: Avoid initializing the runtime when doing AOT compilation.
	(mini_method_compile): Don't add the method to the jit_info table when
	during AOT compilation.

2008-08-27  Bill Holmes  <billholmes54@gmail.com>

	Backport of r111724.

	* mini-amd64.h : Fix a compiler warning.

	* exceptions-amd64.c (mono_arch_unwindinfo_install_unwind_info) :
	  Changed to use a callback function to retrieve the unwind info.
	  This avoids problems observed when code blocks were removed by
	  unloading an app domain.

	* mini-amd64.c (mono_arch_cpu_optimizazions) : Removing the peephole 
	  and branch excludes for Winx64.  The fix in exceptions-amd64.c allows them
	  to work properly.

	Contributed under MIT/X11 license.

2008-08-27  Bill Holmes  <billholmes54@gmail.com>

	Backport of r111722.

	* mini-amd64.c (mono_arch_output_basic_block) : Fix the OP_X86_PUSH_OBJ
	  case to keep the stack aligned to 8.

	Contributed under MIT/X11 license.

2008-08-26  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_method): Add a cache for wrapper names to
	avoid repeated linear searches.

2008-08-25  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_method): Avoid adding a method twice.
	(add_wrappers): Add runtime invoke wrappers for all methods.

	* mini.c (mono_method_to_ir): Handle the !aot case in CEE_MONO_ICALL_ADDR.

2008-08-24  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir2): Rethrow the correct exception in
	CEE_RETHROW. Fixes #419634.

	* exceptions.cs: Add a new test.
	
	* generic-sharing.c (mini_type_stack_size): Always pass TRUE as allow_open
	to mono_type_stack_size_internal () since some callers might not pass in
	an rgctx.

	* mini-x86.c (mono_arch_emit_prolog): Store the rgctx before calling
	instrument_prolog. Fixes #419878.

2008-08-22  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Fix the STELEM_ANY+null value optimization.
	Fixes #419273.

2008-08-20  Bill Holmes  <billholmes54@gmail.com>

	Backport of r111197

	* exceptions-amd64.c (seh_handler):  For Winx64 adding missing copy 
	  of nonvolatile registers back from MonoContext to CONTEXT.

	Contributed under MIT/X11 license.

2008-08-20  Bill Holmes  <billholmes54@gmail.com>

	Backport of r111194

	* mini-amd64.c (mono_arch_get_delegate_invoke_impl):  When shifting the
	  arguments on Winx64 there are only 4 argument registers.  For this
	  logic to work the last argument must be pulled from the stack.  

	Contributed under MIT/X11 license.

2008-08-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_output_basic_block): Add OP_FCONV_TO_I.
	Fixes #418381.

2008-08-16  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_resolve_patch_target): For PATCH_INFO_METHOD_JUMP, move the
	insertion into jump_table_hash into mono_codegen (), also implement proper
	locking.

2008-08-14  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Abort aot compilation for generic
	methods if generic sharing is disabled.
	
	* mini.c (mono_method_to_ir): Disable AOT for virtual calls requiring
	an mrgctx.

2008-08-13  Bill Holmes  <billholmes54@gmail.com>

	* mini-amd64.c (mono_arch_cpu_optimizazions):  Remove peephole and branch
	  from default optimizaton list on Winx64.

	* mini-amd64.c (emit_tls_get):  Added Winx64 specific implementation for GetTLS.

	* mini-amd64.c (mono_arch_emit_prolog):  Adding an offset on Winx64 to get
	  the LMF from the MonoJitTlsData structure.

	* mini-amd64.c (mono_arch_setup_jit_tls_data):  Added Winx64 implementation.

	Contributed under MIT/X11 license.

2008-08-12  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (main_thread_handler): Allow AOT compilation of multiple 
	assemblies in one run.

	* aot-compiler.c (mono_compile_assembly): Only print out a count of
	skipped methods if it is not 0.

2008-08-12  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (emit_call_body): Use image->aot_module instead of 
	assembly->aot_module.

	* aot-runtime.c: Use image->aot_module instead of searching in the aot_modules
	hash table. This simplifies and speeds up a lot of code, and fixes support
	for .netmodules.

2008-08-12  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (SIG_HANDLER_SIGNATURE): Avoid crashes if the thread is not registered
	with the runtime.

	* mini-exceptions.c: Ditto.

2008-08-11  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_method): Avoid doing all the loading inside
	the aot lock, to avoid deadlocks when mono_aot_get_class_from_name () is
	called while holding the loader lock. Fixes #415608.
	(mono_aot_get_method_from_token_inner): Ditto.

2008-08-08  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_aot_parse_options): Disable no-dlsym option for now.
	
	* mini.c (mono_resolve_patch_target): Don't error out on missing icalls
	while aot compiling.
	
	* mini.c driver.c aot-compiler.c: Update after
	mono_marshal_get_native_wrapper () signature changes.

	* mini.c (mono_resolve_patch_target): Error out if an icall is not found.
	(mono_method_to_ir): Handle new CEE_MONO_ICALL_ADDR opcode.

2008-08-07  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_named_code): Pass the sofile to find_symbol, not the
	MonoAotModule.

	* exceptions-arm.c (mono_arch_get_throw_exception_generic): Add aot
	support.

	* aot-runtime.c (load_named_code): Handle 'mono_arm_throw_exception'.

	* mini-arm.c (mono_arch_register_lowlevel_calls): Register 
	mono_arm_throw_exception as a jit icall.

2008-08-06  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_compile_assembly): Correct the computation of 
	acfg->nmethods.
	(add_wrappers): Don't emit jit icall wrappers etc. into every image.

2008-08-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (add_valuetype): Only reserve half parameter slot for each member of
	a float HFA. Fixes #413621.

2008-07-31  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Add a declaration for mono_aot_register_module ().

	* aot-compiler.c aot-runtime.c: Merge some mach changes from Renaldas Zioma.

	* debug-debugger.c (MONO_DEBUGGER__debugger_info): Fix a warning.

	* aot-compiler.c aot-runtime.c: Add a 'static' option to generate aot files
	which can be statically linked into an executable.

2008-07-31  Bill Holmes  <billholmes54@gmail.com>

	* aot-compiler.c : Backport of r108759.  Fix win32 build.

	Contributed under MIT/X11 license.

2008-07-29  Massimiliano Mantione  <massi@ximian.com>
	* mini.c (sigprof_signal_handler): call the new "runtime initialized"
	profiler hook.

	Backported from trunk (r108631).

2008-07-27  Zoltan Varga  <vargaz@gmail.com>

	* debug-mini.c (mono_debug_close_method): Avoid a crash if jit->this_var
	is not set.

2008-07-25  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c
	(debugger_get_boxed_object): GC-protect the last 16 objects.
	(debugger_runtime_invoke): Likewise.

2008-07-24  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c aot-compiler.c: Merge with the version in HEAD.
	
2008-07-24  Mark Probst  <mark.probst@gmail.com>

	* mini-exceptions.c: Free a MonoType with
	mono_metadata_free_type() instead of g_free().

	* aot-runtime.c: Free a MonoType.

	Backported from trunk.

2008-07-24  Bill Holmes  <billholmes54@gmail.com>

	* mini-amd64.c (mono_arch_call_opcode) : Winx64 fix.  Use the size
	  variable computed above as the copy length for arguments of storage
	  type ArgValuetypeAddrInIReg.

	Contributed under MIT/X11 license.

2008-07-24  Bill Holmes  <billholmes54@gmail.com>

	* mini-amd64.c (mono_arch_emit_prolog) : Winx64 fix.  When omitting the
	  frame pointer the stack adjustment value must be saved to the unwind 
	  info structure.

	Contributed under MIT/X11 license.

2008-07-23  Martin Baulig  <martin@ximian.com>

	* debug-mini.c (mono_debug_close_method): Check
	`MONO_INST_IS_DEAD' for `this'.

2008-07-22  Bill Holmes  <billholmes54@gmail.com>

	* inssel-amd64.brg :  Adding rules for OP_VTARG_ADDR that are used for
	  Winx64 struct arguments.

	* mini-amd64.c (mono_arch_allocate_vars) : Implementing the ArgValuetypeAddrInIReg
	  argument case.  Setting the argument op to OP_VTARG_ADDR (OP_REGOFFSET)).

	* mini-amd64.c (mono_arch_emit_prolog, emit_load_volatile_arguments) :
 	  Implementing the ArgValuetypeAddrInIReg argument case.  When the address
 	  of a struct is passed in a register it must be saved with the other
 	  volatile argument on the stack.

	Contributed under MIT/X11 license.

2008-07-21  Bill Holmes  <billholmes54@gmail.com>

	* mini-amd64.c (get_call_info): Winx64 fix for passing floats.
	  The float param registers and other param registers must be the 
	  same index on Windows x64.

	Contributed under MIT/X11 license.

2008-07-21  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c: Make the previous fix GC safe.
	Backported from trunk.

2008-07-21  Bill Holmes  <billholmes54@gmail.com>

	Back port from trunk.  r108343

	* mini-amd64.c (get_call_info): Correcting the case for MONO_TYPE_TYPEDBYREF
	  on Winx64.  This type will not be passed on the stack (ArgOnStack), but 
	  ArgValuetypeAddrInIReg instead.

	Contributed under MIT/X11 license.

2008-07-21  Raja R Harinath  <harinath@hurrynot.org>

	* Makefile.am (version.h): Allow a trailing '/' in the repository URL.

2008-07-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c: Use mono_runtime_class_init_full to avoid leaking memory
	for types which the initialization fails. Raises the provided exception
	at the right stop after cleanup. Backported from trunk.

2008-07-14  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Disable aot for code using CCASTCLASS on x86 as 
	it has too much register pressure.

2008-07-13  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg (CEE_CASTCLASS): Remove some dead code.

2008-07-12  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.h aot-compiler.c aot-runtime.c: Store the plt info offset inline
	on x86.

	* mini-amd64.h aot-compiler.c aot-runtime.c: Store the plt info offset inline
	on amd64 similar to the way it is done on arm.

	* mini.h (MONO_AOT_FILE_VERSION): Bump AOT file format version.

	* aot-runtime.c (load_aot_module): Rename 'info' to 'amodule' for 
	consistency, normalize error messages, avoid loading aot-only modules in
	normal mode.

	* driver.c (mono_main): Rename --aot-only command line option to --full-aot
	for consistency.

	* aot-compiler.c aot-runtime.c tramp-arm.c: Implement aot-only support.

2008-07-11  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h
	(MonoDebuggerInfo): Add `interruption_request'.

2008-07-12  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_plt): Remove some dead code.

	* exceptions-arm.c (mono_arch_get_call_filter_full): Initialize ji.

	* aot-runtime.c (mono_aot_get_plt_info_offset): New helper function to
	return the plt info offset belonging to a given plt entry.

	* mini-trampolines.c (mono_aot_plt_trampoline): Use 
	mono_aot_get_plt_info_offset.
	
	* aot-runtime.c aot-compiler.c tramp-arm.c: Change the arm plt code to be
	similar to the amd64 code by makeing jumps through a separate jump table 
	instead of embedding the jump addresses into the code.

2008-07-11  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Disable aot for calling ldtoken in a generic
	method.

2008-07-10  Martin Baulig  <martin@ximian.com>

	* mini.c (mini_method_compile): Disable generics sharing when
	running in the debugger.

2008-07-10  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Create the got var in CEE_REFANYVAL.

	* inssel.brg (CEE_CASTCLASS): Avoid reusing temporary registers to prevent
	the local register allocator from running out of registers on x86 when 
	using aot.

2008-07-10  Bill Holmes  <billholmes54@gmail.com>

	* inssel-long.brg For OP_LCONV_TO_OVF_I4 an int cast is needed when 
	expressing IntMin for the VS Compiler.  See Compiler Warning (level 2) 
	C4146.

	Contributed under MIT/X11 license.

2008-07-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Get rid of whitespace in the generated assembly file to
	speed up the assembler.

2008-07-09  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.h tramp-arm.c exceptions-arm.c aot-compiler.c: Beginnings of aot-only
	support.

	* mini.c: Move the soft float handling macros a bit earlier, add 
	NEW_TEMPSTORE_SOFT_FLOAT macro, fix warnings, add soft-float support in one
	place.

	* mini.h: Add prototype for mono_arch_fixup_jinfo.

	* mini.c (mini_init): In aot-only mode, set the root domain code manager to
	read-only to help catch code allocation requests.
	
	* mini.c inssel.brg aot-compiler.c: Make the use of IMT runtime configurable,
	and turn it off when using --aot-only or when compiling with --aot=full.

	* mini.c (mono_resolve_patch_target): In aot-only mode, allocate the
	jump table for switches from the normal domain mempool, not the code
	manager.

	* mini-trampolines.c (get_unbox_trampoline): New function to return an
	unbox trampoline which handles aot-only mode too.

	* aot-runtime.c (mono_aot_get_unbox_trampoline): New function to lookup
	an AOTed unbox trampoline.

	* aot-compiler.c (emit_trampolines): Emit unbox trampolines.

2008-07-09  Bill Holmes  <billholmes54@gmail.com>

	* wapihandles.c: Fixing MSVC builds.  Include statement changed from <> to
	""

	Contributed under MIT/X11 license.

2008-07-09  Bill Holmes  <billholmes54@gmail.com>

	* mini.c (mono_codegen):  Allocate space at the end of the code block and store
	  the unwind information for the method at the end of the allocated block.
	  
	* mini-amd64.h: Added declarations for the unwind routines and adding field to 
	  MonoCompileArch to hold the unwind info for SEH on Winx64
	
	* mini-amd64.c (mono_arch_emit_prolog): Calls to the unwind routines added to store
	  frame pointer info for the method being compiled.
	  
	* exceptions-amd64.c (mono_arch_get_throw_corlib_exception): Added a stack adjustment before
	  the call to mono_exception_from_token.
	  
	* exceptions-amd64.c: Added mono_arch_unwindinfo* implementations.  This code is responsible
	  storing the method prolog information in a format that the Winx64 SEH can understand.  This
	  information is stored a the end of the method block because it is all 32-bit offset based.

	Contributed under MIT/X11 license.

2008-07-09  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Remove duplicate definitions of the mini_wapi_ functions.

	* wapihandles.c: Fix warnings.

	* aot-runtime.c (load_aot_module): Add a missing error message in aot-only
	mode.

	* mini-trampolines.c (mono_create_jit_trampoline_in_domain): Avoid calling 
	mono_jit_compile_method in aot-only mode since that calls the type 
	initializer.
	
	* mini-trampolines.c (mono_create_delegate_trampoline): Avoid calling
	get_delegate_invoke_impl in aot-only mode.

	* mini.c (mono_global_codeman_reserve): Reenable the aot-only check.

2008-07-08  Zoltan Varga  <vargaz@gmail.com>

	* trace.c (mono_trace_enter_method): Fix printing of Type instances.

	* aot-compiler.c (compile_method): Disable the check for GSHARED since it
	is on by default.

	* inssel-long.brg (reg): Add a rule for LCALL_REG (OP_I8CONST).

	* tramp-amd64.c (mono_arch_nullify_plt_entry): Read the nullified class
	init trampoline from the AOT file as well.

	* mini-amd64.c (mono_arch_register_lowlevel_calls): Register
	mono_amd64_throw_exception as a jit icall since it is needed by the aot-only
	code.

	* mini.c (mini_init): Move the call to mono_exceptions_init () after 
	mono_init.

	* exceptions-amd64.c: Add _full variants for the remaining exception code
	creation functions as well, allow emission of relocatable code, remove
	caching since that is now done by the caller.

	* mini-exceptions.c: Add _full variants for the remaining exception code
	creation functions as well, add aot-only support.

	* aot-compiler.c (compile_method): Allow calls to methods of constructed types
	if we can determine a proper token for them.
	(add_wrappers): Add a few more wrappers.
	(emit_method_code): Remove some dead code.
	(emit_trampolines): Emit exception code too.

	* mini.c (mono_method_to_ir): Call mono_array_new_2 if possible.

	* jit-icalls.c (mono_array_new_2): New jit icall, specialized version of
	mono_array_new_va which avoids varargs.

	* mini-exceptions.c (mono_exceptions_init): Fix the ppc build.

	* mini-trampolines.c: Call mono_create_specific_trampoline () instead of
	mono_arch_create_specific_trampoline () in all places.

	* aot-compiler.c aot-runtime.c: Refactor the trampoline emitting/loading code
	a bit so it can be used for other things as well.
	
	* mini-exceptions.c (mono_exceptions_init): Initialize throw_exception_by_name
	on demand as well.

	* exceptions-amd64.c: Rename the caching from the exception code creation
	functions, it is done by the caller instead.
	
	* exceptions-amd64.c: Change the signature of the exception code creation 
	functions to allow the creation of relocatable code later.

	* mini-exceptions.c: Add a set of functions to query the various 
	runtime-generated exception functions.

	* mini.c mini-exceptions.c: Use the newly added functions instead of the
	mono_arch_.. () functions.
	
2008-07-07  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_aot_get_trampoline_code): Removed, no longer used.

	* aot-runtime.c aot-compiler.c: AOT the generic trampolines in aot-only mode.

	* mini.c (mini_get_imt_trampoline): Call mono_create_specific_trampoline ().
	(mini_get_vtable_trampoline): Ditto.

	* tramp-amd64.c (mono_arch_create_trampoline_code_full): Create relocatable
	code in the AOT case by returning the code size and a list of relocations to
	the caller.

	* mini-trampolines.c (mono_create_specific_trampoline): New helper function.

2008-07-07  Bill Holmes  <billholmes54@gmail.com>

	* mini-amd64.c:  On Winx64 the calling convention always requires the caller to 
	  clean the stack.

	Contributed under MIT/X11 license.

2008-07-07  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_exception_debug_info): Serialize the debug info first
	so the buffer size can be computed correctly. Fixes #404735.

	* debug-mini.c (mono_debug_serialize_debug_info): Lookup the debug info
	normally as cfg->debug_info is already freed.

2008-07-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c: For calls returning vtypes in registers, don't store
	the return address on the stack, instead allocate a separate local for
	it. Fixes #404729.

2008-07-05  Mark Probst  <mark.probst@gmail.com>

	* mini-trampolines.c, mini.h: Add an argument to
	mono_create_jit_trampoline_in_domain() for turning off the adding
	of the sync wrapper.

	* mini.c: Use the JIT trampoline without sync instead of
	ldftn_nosync in static RGCTX invoke wrappers so that the call can
	be patched.

2008-07-04  Mark Probst  <mark.probst@gmail.com>

	* driver.c: Turn on GSHARED optimization by default.

2008-07-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c mini.c mini.h tramp-<ARCH>.c: Rename MONO_TRAMPOLINE_GENERIC
	to MONO_TRAMPOLINE_JIT since it better reflects what it does.

	* mini-trampolines.c (mono_get_aot_trampoline_code): New internal function to
	create a variant of the generic trampoline code callable from AOTed trampolines.

	* tramp-amd64.c (mono_arch_create_trampoline_code_full): Add support for generic
	trampoline code callable from AOTed trampolines.

	* aot-compiler.c aot-runtime.c: Add support for AOTing trampolines.

2008-07-04  Mark Probst  <mark.probst@gmail.com>

	* inssel.brg, mini-ops.h: New opcode for doing CHECK_THIS in a
	pass-through manner.

	* mini.c: Generic method sharing.  Pass MRGCTX to generic methods
	and don't fail sharing for them anymore.

	* mini-exceptions.c: Handle exceptions in shared generic methods.

	* generic-sharing.c: When checking the context of a generic
	method, also check its class's context.  Don't treat wrappers as
	sharable.

	* mini-trampolines.c: Some code factored out to
	metadata/generic-sharing.c.  Handle the MRGCTX case.

	* jit-icalls.c, jit-icalls.h: ldvirtfn icall for generic sharing -
	we must deal with the method being of another instantiation of the
	class.  Add static rgctx invoke wrappers to generic methods.

2008-07-04  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Provide all jit infos of generic shared methods with a
	generic jit info.

	* mini-exceptions.c: Handle the new situation that a generic info
	might be available, but not info about the this/vtable/mrgctx
	variable.

2008-07-03  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Don't accept ldftn and ldvirtftn with uninstantiated
	generic methods.

2008-07-03  Zoltan Varga  <vargaz@gmail.com>

	* dominators.c (check_dominance_frontier): Fix a warning.

	* mini.h: Add some missing prototypes.

	* ssa.c local-propagation.c debug-debuger.c: Fix warnings.

	* driver.c (mono_jit_init_version): Correct the comments since the first
	argument should be the name of the root domain, not a filename.

	* aot-runtime.c (make_writable): Error out if this is called while running
	with --aot-only.
	(load_aot_module): Ditto.

	* aot-compiler.c: Really fix the computation of method indexes.

	* mini-amd64.c (mono_arch_get_delegate_invoke_impl): Remove the previous 
	optimizations as this is no longer called frequently.

	* mini-trampolines.c (mono_create_delegate_trampoline): Precompute the invoke
	method and the invoke impl code and pass it to the delegate trampoline instead of
	just the delegate class.

2008-07-02  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Fixup the computation of method indexes.
	(add_wrappers): Create the base methods of the runtime invoke wrappers using
	the method builder infrastructure.

	* aot-runtime.c (decode_exception_debug_info): Don't crash if the method
	has no header.

	* mini-trampolines.c (mono_create_jit_trampoline_in_domain): In aot-only
	mode, load the method right away instead of creating a trampoline.

	* mini-x86.c (mono_arch_get_delegate_invoke_impl): Eliminate locking.

	* mini-amd64.c (mono_arch_get_delegate_invoke_impl): Eliminate locking, speed up
	some checks a bit.

2008-07-01  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (decode_patch_info): Don't create trampolines in aot_only mode.
	(mono_aot_load_method): Use method_index instead of method->token.

	* mini.c (mono_jit_compile_method_inner): Move the aot_only check down, so it
	can handle icalls etc. properly.

	* mini.h (MONO_AOT_FILE_VERSION): Bump AOT file format version.

	* aot-compiler.c aot-runtime.c: Allow AOTing many wrapper types.

	* mini.c (mono_resolve_patch_target): Handle JIT_ICALL_ADDR.
	(mono_codegen): Convert calls made by JIT icall wrappers to the icalls into
	JIT_ICALL_ADDR patch type.

	* patch-info.h: Add JIT_ICALL_ADDR patch type.

	* mini.c (mono_method_to_ir): Allow AOTing methods which access the interruption
	request flag.
	(mono_resolve_patch_target): Handle INTERRUPTION_REQUEST_FLAG.

	* patch-info.h: Add INTERRUPTION_REQUEST_FLAG.

2008-06-30  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Use domain->jit_code_hash_lock for controlling access to
	domain->jit_code_hash.

2008-06-29  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_parse_debug_options): Add 'dont-free-domains' option.

2008-06-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_delegate_trampoline): Don't pass a gsctx to
	get_this_arg_from_call, let it compute it when needed.

	* mini-amd64.c (mono_arch_get_this_arg_reg): Add a 'code' argument, compute
	gsctx from code only when needed.

	* mini-trampolines.c (get_generic_context): Rename this to 
	mono_get_generic_context_from_code (), and move it to generic-sharing.c, where
	it can be called by the arch backends.

	* mini-exceptions.c (mono_print_thread_dump): Allow the argument to be NULL.

2008-06-26  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_main): Add experimental --aot-only command line option.

	* mini.c: Error out when creating trampolines or JIT compiling if --aot-only is
	set.

2008-06-26  Kornél Pál  <kornelpal@gmail.com>

	* driver.c (DllMain): Remove mono_module_handle.

	Contributed under MIT/X11 license.

2008-06-25  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Add not-yet-usable 'full' option. Add some infrastructure code
	for emitting methods which are not in the source assembly. Detect and report
	failure of assembling+linking.
	
	* aot-compiler.c (emit_klass_info): Call mono_class_setup_vtable ().

	* aot-compiler.c: Move the contents of the has_glot_slots array to MonoCompile.

2008-06-24  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c: Check if stats is enabled so we don't allocate memory when not needed.

2008-06-24  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Remove some obsolete prototypes.

	* mini.c: Avoid storing MonoMethod pointers in the JIT stats, store their string format instead.

2008-06-24  Mark Probst  <mark.probst@gmail.com>

	* mini.c (get_object_generic_inst): Variable-sized arrays are not
	supported by Visual Studio, so use alloca().

2008-06-23  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (add_valuetype): Increase *gr too when passing a HFA to be in sync with the ABi.
	Fixes #402585.

2008-06-23  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Fail sharing of a generic method if it contains an open
	catch clause (because we don't pass MRGCTXs yet).

2008-06-23  Mark Probst  <mark.probst@gmail.com>

	* mini.c: When compiling a method with generic sharing, insert the
	method instantiated with an all-Object generic context into the
	jit info table, instead of the context of the first instantiation
	of the method we happen to compile.

2008-06-18  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h (MonoDebuggerInfo): Replaced `version' with
	`major_version' and `minor_version'.

2008-06-17  Mark Probst  <mark.probst@gmail.com>

	* generic-sharing.c, mini.c, mini.h, aot-runtime.c:
	mono_method_is_generic_sharable_impl() takes an additional
	argument specifying whether to treat type variables as reference
	types.

2008-06-17  Mark Probst  <mark.probst@gmail.com>

	* mini.h: Removed obsolete prototypes.

2008-06-17  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Don't fail generic sharing for initobj and sizeof - we
	already handle them.

2008-06-17  Mark Probst  <mark.probst@gmail.com>

	* mini.h, mini-trampolines.c, tramp-alpha.c, tramp-amd64.c,
	tramp-arm.c, tramp-hppa.c, tramp-ia64.c, tramp-mips.c,
	tramp-ppc.c, tramp-s390.c, tramp-s390x.c, tramp-sparc.c,
	tramp-x86.c: Added a MonoGenericContext* argument to
	mono_arch_get_unbox_trampoline() so that it can call other
	functions which require it.

2008-06-17  Mark Probst  <mark.probst@gmail.com>

	* mini.h, mini-trampolines.c, mini-amd64.c, mini-x86.c,
	mini-alpha.c, mini-arm.c, mini-ia64.c, mini-ppc.c:
	mono_arch_get_this_arg_from_call() takes a
	MonoGenericSharingContext* as well.

2008-06-17  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Factor out code for emitting unbox into emit_unbox() and
	implement generic sharing of unbox.

2008-06-17  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Don't compute the vtable to determine whether a field is
	special static, because it might not work for open types.

2008-06-17  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Removed the unused token_type and token_source arguments
	from get_runtime_generic_context_ptr().

2008-06-17  Marek Habersack  <mhabersack@novell.com>

	* mini.c (ADD_BINOP): fix the build

2008-06-16  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (ADD_BINOP): When operating on a native int and an int32, insert
	a widening op.

2008-06-16  Mark Probst  <mark.probst@gmail.com>

	* mini.h: Removed class relations enum that's not used anymore.

2008-06-16  Mark Probst  <mark.probst@gmail.com>

	* tramp-x86.c, tramp-amd64.c: Slot access code for MRGCTXs.

	* mini-trampolines.c: Distinguish between RGCTXs and MRGCTXs in
	the lazy fetch trampoline access code.

2008-06-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_local_regalloc): Add some micro optimizations.

2008-06-14  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Fix some soft-float bugs. Fixes #378735 and #398348.

	* mini.h (MONO_INST_LIST_ENTRY): Fix warnings on arm.

	* mini.c (mono_method_to_ir): Check call signature for NEWOBJ as well.

2008-06-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c inssel-x86.brg cpu-x86.md: Implement unsigned min/max
	intrinsics.

	* mini-ops.h: Add MIN/MAX_UN opcodes.

	* mini-amd64.c inssel-amd64.brg cpu-amd64.md: Implement unsigned min/max
	intrinsics.

	* basic-math.cs: Add more min/max tests.

	* inssel.brg: Remove the OP_MIN/OP_MAX rules. Fix a warning.

2008-06-13  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Small fix in the prologue of emit_castclass.

2008-06-13  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg: Remove the OP_MIN/OP_MAX rules. Fix a warning.

	* mini.c (mini_get_inst_for_method): Remove the Min/Max intrinsics, they
	do not work even for unsigned types. Fixes #400014.

	* basic-math.cs: Add regression tests for unsigned Min/Max.

2008-06-13  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Added additional context_used argument to several
	functions, which will be needed for sharing generic methods.  Use
	GET_RGCTX macro wherever appropriate.  Declare only one
	context_used in mono_method_to_ir().

2008-06-13  Mark Probst  <mark.probst@gmail.com>

	* mini.c, generic-sharing.c: Removed generic class relations.

	* mini.c, tramp-amd64.c, tramp-x86.c: Additional arguments to
	functions due to MRGCTX changes.

2008-06-13  Mark Probst  <mark.probst@gmail.com>

	* inssel.brg, inssel-long.brg, inssel-long32.brg, mini-ops.h,
	graph.c, local-propagation.c, aliasing.c: New opcodes for calls
	with calculated IMT.

	* mini.c: Generic sharing of calls via generic interfaces.

	* jit-icalls.c, jit-icalls.h: Helper function for compiling a
	generic method with non-constant MonoGenericContext*.  Instead,
	the context is taken out of the method itself.

2008-06-13  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Generic sharing of ldvirtftn.

2008-06-13  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Generic sharing of ldftn.

2008-06-13  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Do pass VTable/RGCTX argument to static generic methods.

2008-06-13  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Generic sharing of the special case of ldtoken followed
	by a call to GetTypeFromHandle.

2008-06-13  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Generic sharing of box for nullable types.

2008-06-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-s390x.c (add_stackParm): Fix computation of offsets when arguments
	are passed on the stack. Fixes #324807.

2008-06-12  Bill Holmes  <billholmes54@gmail.com>

	* mini-amd64.c:add_valuetype: Adding Winx64 code to fill the ArgInfo
	for the ArgValuetypeAddrInIReg case.

	* mini-amd64.c:mono_arch_allocate_vars:  Adding a case for 
	ArgValuetypeAddrInIReg to avoid asserts.  Code needs to be added here.

	* mini-amd64.c: mono_arch_call_opcode:  Adding Winx64 code for an ArgInfo of 
	type ArgValuetypeAddrInIReg.  The code emitted will copy the argument to a 
	local variable and pass the local variable by reference to the called method.
	  
	* mini-amd64.c: mono_arch_emit_prolog:  Adjust the stack for calls to
	mono_jit_thread_attach and mono_get_lmf_addr for Winx64.

	Contributed under MIT/X11 license.

2008-06-10  Rodrigo Kumpera  <rkumpera@novell.com>

	* debug-mini.c (mono_debug_free_method_jit_info): Moved to metadata/mono-debug.c.

	* debug-mini.c (mono_debug_print_vars): Release memory after printing
	everything.

2008-06-10  Martin Baulig  <martin@ximian.com>

	* debug-mini.c
	(mono_debug_close_method): Check whether `cfg->epilogue_begin != NULL'.

2008-06-09  Kornél Pál  <kornelpal@gmail.com>

	* main.c: Add and set argv [argc] to NULL to match C specification that fixes
	possible error when no arguments are passed.

	Contributed under MIT/X11 license.

2008-06-09  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-exceptions.c (ves_icall_get_trace): Skip source locations
	where the file name is NULL.

2008-06-09  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Fix s390 build.

2008-06-08  Zoltan Varga  <vargaz@gmail.com>

	* trace.c (mono_trace_parse_options): Fix warnings.

	* mini-amd64.c: Revert most of the last patch for now as it breaks the build.

2008-06-07  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (remove_block_if_useless): Avoid printing the method name.
	
	* mini.c: Remove needless setting of ins->cil_code which is now done by 
	MONO_INST_NEW.

	* mini-amd64.c: Add some code to avoid saving callee saved registers in the
	LMF. Not yet used.

	* tramp-amd64.c (mono_arch_patch_callsite): Tell valgrind to discard the
	translated code after it has been patched.

2008-06-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (emit_call_body): Align the call displacement to 4 bytes to
	avoid problems during code patching on SMP systems.
	(emit_call): Avoid adding a patch info which is already added by 
	emit_call_body.
	(mono_arch_emit_exceptions): Ditto.

2008-06-05  Zoltan Varga  <vargaz@gmail.com>

	* tramp-*.c (mono_arch_get_unbox_trampoline): No need to check for ret->byref,
	MONO_TYPE_ISSTRUCT already checks for it.

2008-06-05  Bill Holmes  <billholmes54@gmail.com>

	* mini-amd64.c:merge_argument_class_from_type: When marshaling 
	  structs with floats on Winx64 the float registers are not used.  
	  The integer registers are always used..
	* mini-amd64.c:add_valuetype:  When marshaling structs on Winx64 
	  only one register will be used and only if the size of the struct 
	  is 1,2,4, or 8 bytes.

	* tramp-amd64.c :  Adjusting size used for mono_global_codeman_reserve
	  to work for Winx64.

	Contributed under MIT/X11 license.

2008-06-05  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c (debugger_lookup_class): Also call
	mono_class_setup_methods() here; we're only called from RTI.

2008-06-05  Andreas Färber  <andreas.faerber@web.de>

	* mini.c (mini_init): Add DTrace probes ves-init-{begin,end}.
	(mini_method_compile) Add DTrace probes method-compile-{begin,end}.
	* Makefile.am (libmono_la_LIBADD,libmono_static_la_LIBADD,mono_LDADD):
	Post-process object files and add dtrace-generated object, if necessary.

	Contributed under MIT/X11 license.

2008-06-04  Mark Probst  <mark.probst@gmail.com>

	* inssel.brg, mini-ops.h: Added opcode for unboxcast with computed
	element class.

	* mini.c: Generic sharing for unbox.any and castclass.

2008-06-04  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Ignore tailcall prefix in shared generic code and when
	doing calls which require a vtable/rgctx argument.

2008-06-04  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Don't free the JIT info.

	* driver.c: Changes in the JIT info table testing code.

2008-06-03  Zoltan Varga  <vargaz@gmail.com>

	* tramp-arm.c (mono_arch_create_trampoline_code): Check for thread 
	interruption. Fix some warnings.

	* tramp-*.c (mono_arch_create_trampoline_code): Call the _force_ variant of
	interruption_checkpoint.

Tue Jun 3 13:07:03 CEST 2008 Paolo Molaro <lupus@ximian.com>

	* jit.h, mini.h, trace.c, driver.c: introduce an API to enable tracing
	from embedding applications.

2008-06-02  William Holmes  <billholmes54@gmail.com>

	* mini-amd64.c :  Correcting some of the issues for Winx64 dealing with
	  reserving 32 bytes on the stack when making calls. 

	Contributed under MIT/X11 license.

2008-06-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_output_basic_block): Merge some small fixes from
	the linear IL branch.

	* driver.c: Print out more information for --version on arm.

2008-05-30  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_prolog): Increase max_offset when processing
	bb_exit instead, since out of line bblocks might not actually be emitted
	out-of-line.
	
	* mini-amd64.c (mono_arch_emit_prolog): Increase bb->max_offset by the
	maximum epilog size for out of line bblocks if tracing is enabled.

	* iltests.il.in: Merge tests/long-shift.regalloc.il into this file.

2008-05-28  Rodrigo Kumpera  <rkumpera@novell.com>

	* arrays.cs: Regression tests for allocating arrays with negative sizes.

2008-05-28  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.h mini-x86.c inssel-x86.brg cpu-x86.md: Add support for
	CAS instrinsics. Optimize the implementation of the ATOMIC_EXCHANGE 
	opcodes.

2008-05-27  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_get_inst_for_method): Add support for CAS instrinsics when
	the 'value' to store is a constant.

	* mini-ops.h: Add OP_ATOMIC_CAS_IMM opcodes.

	* mini-amd64.c (mono_arch_output_basic_block): Optimize the the implementation
	of ATOMIC_EXCHANGE opcodes, add support for the CAS opcodes.

2008-05-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.c generic-sharing.c jit-icalls.c aot-compiler.c: Use accessor functions
	for accessing method->generic_container.

2008-05-24  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_check_inlining): Avoid creating vtables if possible.
	
	* mini.c (SIG_HANDLER_SIGNATURE): Fix sparc build too.

	* mini.c (SIG_HANDLER_SIGNATURE): Fix IA64 build.

	* mini.c (mono_jit_compile_method_inner): Avoid a crash if mono_class_vtable ()
	fails.

2008-05-23  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_main): Set mono_setup_vtable_in_class_init to FALSE.

	* mini.c: Handle the case when mono_class_vtable () fails.

2008-05-23  Massimiliano Mantione  <massi@ximian.com>
	* mini.c (sigprof_signal_handler): Support call chains (backtrace) in
	the stat profiler.

2008-05-22  Mark Probst  <mark.probst@gmail.com>

	* mini.c, jit-icalls.c, jit-icalls.h: Make generic sharing work
	together with domain sharing.

2008-05-22  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Treat callvirts to final methods like non-virtual calls
	when doing generic sharing, i.e. look them up in the runtime
	generic context.

2008-05-22  Mark Probst  <mark.probst@gmail.com>

	* inssel.brg, mini-ops.h: Added opcodes for mkrefany and refanyval
	with computed types (for generic sharing).

	* mini.c: Generic sharing for mkrefany and refanyval.

2008-05-22  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg (mini_emit_virtual_call): Avoid constructing a generic vtable if
	possible.

	* mini-trampolines.c (mono_magic_trampoline): Avoid calling setup_methods () in
	the generic sharing code.
	
	* mini-trampolines.c (mono_magic_trampoline): Call mono_class_setup_methods ()
	when needed.

2008-05-21  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Remove the declaration of mono_aot_init_vtable ().

2008-05-21  C.J. Adams-collier <cjac@colliertech.org>

	* driver.c: updated copyright date

2008-05-21  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c mini.c: Remove the AOT init_vtable stuff as it is no longer
	needed.

2008-05-19  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h (MonoDebuggerInfo): Add `using_mono_debugger'
	pointing to the new `_mono_debug_using_mono_debugger' variable.

	* driver.c
	(mono_main): Check mono_debug_using_mono_debugger() rather than
	the `MONO_INSIDE_MDB' environment variable to check whether we're
	inside the debugger.

2008-05-19  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Use cfg->args [0] for accessing the this
	argument.

2008-05-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* declsec.h: Move MONO_SECMAN_FLAG to metadata/metadata-internals.h.

	* mini.c: Added mini_assembly_can_skip_verification. This
	function checks if the assembly requested to skip verification.	
	Fixes part of #387274.

2008-05-07  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_get_method): Disable the check for open generic classes when
	using generic sharing.

	* generics.cs: Add a test #387034.

	* mini.c (mini_get_method): Check whenever the method class is an open generic
	type, and return NULL in that case, causing a verification error. Fixes
	#384123.

2008-05-06  Rodrigo Kumpera  <rkumpera@novell.com>

	* driver.c (mono_main): Revert r102623. The right
	thing to do is to enable the verifier under verifiable
	unless a --security flag was passed.

	We need this non-trivial behavior for --verify-all otherwise
	mcs-compileall won't be able to use it. As it needs everything to
	be verified under validil.

2008-05-06  Martin Baulig  <martin@ximian.com>

	Fix #383749.

	* debug-mini.c (mono_debugger_thread_created): Add proper locking.
	(mono_debugger_thread_cleanup): Likewise.
	(mono_debugger_extended_notification): Likewise.

2008-05-06  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mono_method_to_ir): Verify visibility of call related opcodes
	against both inflated and non-inflated methods. We need to check against the
	generic definition for cases where the instantiated method is not visible.
	We need to check against the inflated types for cases where the instantiation
	changes any super type. This fixes #382986.

	Note that this doesn't need to be applied to other parts of mono_method_to_ir
	that check for visibiliy as generic params only appears as the type subject
	of tokens on call opcodes. Field manipulation and ldftn must always
	target an exact type.

2008-05-06  Rodrigo Kumpera  <rkumpera@novell.com>

	* driver.c (mono_main): Using --verify-all enables the verifier under validil mode
	if no related --security flag is passed.

2008-05-05  Andreas Färber  <andreas.faerber@web.de>

	* mini-arch.h: Prepare support for ppc64.

	Contributed under MIT/X11 license.

2008-05-05  Andreas Färber  <andreas.faerber@web.de>

	* aot-runtime.c: Prepare support for ppc64.

	Contributed under MIT/X11 license.

2008-05-05  Andreas Färber  <andreas.faerber@web.de>

	* mini-ops.h: Prepare support for ppc64.

	Contributed under MIT/X11 license.

2008-05-04  Andreas Färber  <andreas.faerber@web.de>

	* helpers.c: Add support for OSX/ppc64 and Linux/ppc64 (dis)assemblers.

	Contributed under MIT/X11 license.

2008-05-03  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_aot_module): Avoid trying to load aot code for dynamic
	assemblies, since aot_name is not a full path, causing us to load MS.NET 
	assemblies on windows.

﻿2008-04-28  Kornél Pál  <kornelpal@gmail.com>

	* mini.c (mono_jit_compile_method_inner): Use g_warning instead of g_error
	for unsupported METHOD_IMPL_ATTRIBUTE_NATIVE.
	* main.c: Use UTF-8 encoded command line instead of Windows default code
	page on Windows to support Unicode.
	* driver.c (DllMain): New function for mixed-mode assembly support.
	* Makefile.am: Add -Wl,--kill-at to libmono_la_LDFLAGS on Windows to
	export __stdcall functions without decoration.

	Contributed under MIT/X11 license.

2008-04-28  Mark Probst  <mark.probst@gmail.com>

	* tramp-amd64.c, mini-amd64.c: Preserve R11 in the trampoline by
	saving it very early.

2008-04-28  Mark Probst  <mark.probst@gmail.com>

	* mini.h, mini.c: Lots of code for accessing the old RGCTX
	deleted.  The only way to access the new RGCTX is via the
	trampline.

	* mini.c, mini-amd64, mini-x86.c, mini-exceptions.c: Pass the
	vtable instead of the RGCTX to static methods.

	* mini-tramplines.c, tramp-amd64.c, tramp-x86.c: Trampoline for
	accessing the new RGCTX.

	* generic-sharing.c: There is no separation between self, type
	arguments and other types in the RGCTX anymore.

2008-04-25  Jonathan Chambers <joncham@gmail.com>

	* mini-amd64.c (add_general): Remove previous stack adjustment.
	(mono_arch_call_opcode): Remove OP_OUTARG_MEMBASE and instead simply
	adjust stack pointer after pushing args. Adjust ARGS_OFFSET to account
	for 32 bytes of stack space reserved for all calls.
	
	* inssel-amd64.brg (OP_OUTARG_MEMBASE): Remove.
	(OP_AMD64_OUTARG_ALIGN_STACK): Take argument to specify size of stack 
	adjustment.
	
	Code contributed under MIT/X11 license.

2008-04-23  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mini_method_verify): Only verify non-inflated methods, check
	against the root definition, peeling out method and type instantiations.
	Cache verify success results, code that fails verification is still
	checked multiple times.

2008-04-23  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Avoid inserting write barriers for stores of null.

2008-04-23  Jonathan Chambers <joncham@gmail.com>

	* mini-amd64.c (add_general): Always increment stack on Win64.
	(mono_arch_call_opcode): Use OP_OUTARG_MEMBASE instead of OP_OUTARG
	on Win64.
	
	* inssel-amd64.brg (OP_OUTARG_MEMBASE): Add OP_OUTARG_MEMBASE for 
	stack based argument handling on Win64.
	
	Code contributed under MIT/X11 license.

2008-04-23  Raja R Harinath  <harinath@hurrynot.org>

	* Makefile.am (version.h): Add support for git-svn.

2008-04-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_native_sigsegv): Rework the gdb calling code
	so instead of calling g_spawn_command_line_sync, we do everything by hand, 
	avoiding allocations and libc functions which might deadlock.
	
	* mini-exceptions.c (mono_handle_native_sigsegv): Avoid calling gdb if the
	'no-gdb-backtrace' option is set.

	* mini.c (mini_parse_debug_options): Parse 'no-gdb-backtrace' option.

	* mini.h (MonoDebugOptions): Add 'no_gdb_backtrace' option.

2008-04-21  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h (MonoDebuggerInfo): Removed `attach', `detach'
	and `get_lmf_addr'; `notification_address' is no longer a pointer.

2008-04-21  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h (MonoDebuggerInfo): Added `thread_vtable_ptr',
	`thread_vtable', `event_handler_ptr' and `event_handler'.

2008-04-21  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h (MonoDebuggerInfo): Added `init_code_buffer';
	allows delayed initialization of the `executable_code_buffer' when
	attaching.

2008-04-21  Martin Baulig  <martin@ximian.com>

	* mini.h (mono_debugger_create_notification_function): Removed.
	* tramp-*.c (mono_debugger_create_notification_function): Removed.

	* mdb-debug-info64.s
	(MONO_DEBUGGER__notification_function): Added this in the .text section.

	* mdb-debug-info32.s
	(MONO_DEBUGGER__notification_function): Added this in the .text section.

	* Makefile.am: Fix the mdb-debug-info*.s logic; the debugger
	currently only works on x86 and x86_64, so don't create it on ppc.

2008-04-21  Martin Baulig  <martin@ximian.com>

	* mini.h (MonoDebugOptions): Added `mdb_optimizations'.

	* mini.c
	(mini_method_compile): In the fp elimination check, check
	`debug_options.mdb_optimizations' in addition to
	mono_debug_using_mono_debugger().	

	* driver.c (mono_main): Added `--debug=mdb-optimizations' option to
	disable some JIT optimizations which are only disabled when
	running inside the debugger.
	Added `--help-debug' option to describe the debugging options.
	(parse_debug_options): New static function to parse the `--debug'
	options, so we can easily add more stuff in future.

2008-04-20  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (set_exception_type_from_invalid_il): Avoid reading invalid memory when
	the method has no body.

2008-04-19  Jonathan Chambers <joncham@gmail.com>

	* mini-amd64.c (cpuid): Implement with MSVC intrinsic as inline
	assembly is not allowed in MSVC 64-bit compiler. 
	(mono_arch_cpu_init): Don't set floating point precision on MSVC build
	as we get floating point exceptions everywhere.
	
	* exceptions-amd64.c (get_throw_trampoline): Push empty args on stack to
	correctly align arguments for call to throw_exception.
	(prepare_for_guard_pages): Cast to guint64 instead of unsigned long.
	
	Code contributed under MIT/X11 license.

2008-04-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (amd64_patch): Make the check for (%rip) addressing more strict.

2008-04-17  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg (OP_SWITCH): Use (gint64) instead of (long) to cast a large constant.

	* mini-amd64.c (NEW_INS): Set cil_code.

	* mini.c (mini_method_compile): Move the disabling of fp elimination to here
	from mini-amd64.c so all debugger related logic is in one place.

	* mini.c: Set cfg->ip to NULL after passes which set it so instructions created
	later won't have a random ip assigned to them.

2008-04-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_create_jump_trampoline): Add an assert to check that
	the arch specific function initializes code_size.
	(mono_create_delegate_trampoline): Ditto.

	* mini-mips.h mini-mips.c inssel-mips.brg inssel-long32-mips.brg cpu-mips.md
	tramp-mips.c: Resurrect MIPS port and also fix the issues on little-endian
	platforms.

	* liveness.c (mono_analyze_liveness): Disable the initlocals optimization if 
	running under the debugger.

	* linear-scan.c (mono_linear_scan): Avoid sharing registers if running under the
	debugger.

	* mini.c (mini_method_compile): Set a few flags in cfg if running under the
	debugger. Also move the disabling of optimizations here from driver.c.
	(mono_allocate_stack_slots_full): Avoid sharing stack slots if running under the
	debugger.

	* mini.h (MonoCompile): Add a few new flags.

2008-04-15  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Set cfg->ip before processing an IL instruction
	so the cil_code field of created MonoInst's is properly set.
	(mini_select_instructions): Ditto.

	* mini.h (MONO_INST_NEW): Initialize the cil_code field using cfg->ip.
	(MONO_INST_NEW_CALL): Ditto.

	* mini.c inssel.brg inssel-x86.brg inssel-amd64.brg: Use MONO_INST_NEW ()
	in many places so the ins->cil_code field is properly initialized.

	* mini.c (mono_bblock_add_inst): Call MONO_ADD_INS () so the logic is in one
	place.

2008-04-14  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Print a different message when compiling a 
	shared method.
	
	* mini.c (GENERIC_SHARING_FAILURE): Print a failure message when verbose_level
	> 1.

2008-04-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Implement OP_ABS directly using
	SSE2 instructions.

	* basic-math.cs: Fix warnings. Add a test for Math.Abs ().
	
2008-04-11  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (handle_stack_args): Make this return void since its return value was
	never used. Also set cfg->unverifiable for invalid IL instead of calling
	G_BREAKPOINT ().

2008-04-10  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Make sure "this" is live in catch clauses with type
	variables in shared generic code.

2008-04-08  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Replaced uses of MONO_TYPE_IS_REFERENCE with calls to
	generic_class_is_reference_type() to ensure the proper behaviour
	when sharing generic code and the type in question is a type
	argument.

2008-04-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c: Applied patch from Mark Spruiell (mes@zeroc.com). Fix
	race conditions when printing thread dumps. Fixes #377738.

2008-04-08  Massimiliano Mantione  <massi@ximian.com>
	
	aliasing.c (update_aliasing_information_on_inst): Fixed a bug which
	shows up when both MonoInst arguments can cause aliasig.
	There is likely no way in the current JIT to trigger this problem, but
	it showed up in the development of generics sharing, when in a new
	opcode both args of an OP_GROUP can be aliases (addresses of a local).
	When the generics sharing code will be committed, its tests will be
	valid also for this bug.

2008-04-08  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (decode_patch_info): Always transform PATCH_INFO_WRAPPER to
	PATCH_INFO_METHOD.

	* mini.c (mono_resolve_patch_target): Fix a crash in the AOT case if method is
	NULL.

2008-04-07  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_exception_internal): When --debug=casts is used,
	use a more detailed exception message for InvalidCastException.

	* mini.h (MonoJitTlsData): Add 'class_cast_from' and 'class_cast_to' fields.

	* driver.c (mono_main): Add --debug=casts option to turn on better 
	InvalidCastException message details.

	* mini.c (mini_get_debug_options): New helper function to return the address of
	the debug_options variable.

	* mini.c (mono_get_jit_tls_intrinsic): New helper function to create a load of
	the jit_tls TLS variable.

	* mini.c (mono_jit_tls): New TLS variable.

	* inssel.brg: Save the details of a cast to a TLS variable when the --debug=casts
	option is used.

2008-04-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.h: Removed verifer related stuff. This code was moved to verify.c

	* mini.c: Removed verifer related stuff, code moved to verify.c.

	* driver.c: Using code from verify.c instead of mini.c.

2008-04-05  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (check_for_method_verify): Remove the mscorlib comment since it is no
	longer valid.

2008-04-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (check_for_method_verify): Enabling verification of
	corlib if mono_verify_all is set. Bugs in the verifier preventing that
	have been fixed.

2008-04-04  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c (throw_exception): Unify the win32/non-win32 cases, save
	caller saved registers as well.
	
	* exceptions-amd64.c (mono_arch_get_restore_context): Restore most caller
	saved registers as well.

2008-03-30  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c cpu-x86.md inssel-x86.brg: Add min/max intrinsics.

	* mini-amd64.c mini-amd64.h cpu-amd64.md: Get rid of the non-SSE2 floating point
	code.

2008-03-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_get_this_arg_reg): Add a 'gsctx' argument and pass it
	to get_call_info.
	(get_call_info): Take a gsctx argument instead of 'cfg'.

2008-03-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (check_for_method_verify): Avoid verifying mscorlib methods even if
	mono_verify_all is set.

	* driver.c (compile_all_methods_thread_main): Don't exit at the first error.

	* mini.c mini.h: Remove the unused and incomplete stack merge verification code.

2008-03-25  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (compile_all_methods_thread_main): Error out if compilation fails with
	an exception.

	* driver.c mini.c mini.h: Add a --verify-all development option to test the
	verifier and the code generated by the compiler.

2008-03-25  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Generic sharing of the non-nullable case of the box
	instruction.

2008-03-24  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg: Fix the build.

	* iltests.il.in: Add a test for lconv.ovf.u8.un.

2008-03-24  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mono_method_to_ir): Implement readonly for ldelema and
	Array:Address. Fixes #372410.

	* iltests.il.in: New tests for readonly prefix.

2008-03-23  Zoltan Varga  <vargaz@gmail.com>

	* mini.h mini.c mini-trampolines.c: Move trampoline related code to 
	mini-trampolines.c.

	* mini.h mini.c mini-exceptions.c: Move mini_init_exceptions () to 
	mini-exceptions.c.

	* mini-amd64.c mini-s390.c (mono_arch_lowering_pass): Use mono_decompose_op_imm ().
	
	* mini.c (mono_decompose_op_imm): New helper function.

	* mini-s390x.c (calculate_sizes): Rename this to get_call_info for consistency
	with the other architectures, add an 'mp' argument, fold 'sz' argument into the
	return value.

	* mini-s390x.c: Handle DIV_IMM/REM_IMM in the lowering pass instead of in 
	mono_arch_output_basic_block. Fix warnings.

	* inssel-s390x.brg: Remove the unneccesary OP_LMUL_IMM rule to fix the s390x build
	for now.

2008-03-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (ves_icall_get_frame_info): Remove the ia64/s390 workarounds
	since the extra frame is now detected automatically inside the loop.

	* mini-s390.c (mono_arch_peephole_pass_2): Remove the arch independent peephole 
	opts which are now in mono_peephole_ins ().
	
	* mini-s390.c (mono_arch_output_basic_block): Fix OP_FCALL_MEMBASE.

	* mini-exceptions.c (ves_icall_get_frame_info): Skip native-to-managed wrapper
	frames and skip duplicate managed-to-native frames. Fixes #367665.

	* mini-x86.c (mono_arch_peephole_pass_1): Remove the arch independent peephole
	opts which are now in mono_peephole_ins ().
	(mono_arch_peephole_pass_2): Ditto.

	* mini-codegen.c (mono_peephole_ins): Fix a problem on 32 bit platforms.

	* mini-codegen.c (mono_peephole_ins): New helper function containing the
	arch independent peephole optimizations.

	* mini-amd64.c (mono_arch_peephole_pass_1): Remove the arch independent peephole
	opts which are now in mono_peephole_ins ().

	* mini-amd64.c (mono_arch_peephole_pass_2): Ditto.
	
	* mini-s390.c (mono_arch_output_basic_block): Fix build.

	* tramp-s390.c (mono_arch_get_vcall_slot): Handle an additional instruction
	pattern.

	* mini-s390.c (mono_arch_output_basic_block): Handle big offsets in the
	CALL_MEMBASE opcodes. Fix setting of the destination in the OP_LCONV_TO_OVF_I
	opcode.	

2008-03-21  Zoltan Varga  <vargaz@gmail.com>

	* mini-s390.c (calculate_sizes): Rename this to get_call_info for consistency
	with the other architectures, add an 'mp' argument, fold 'sz' argument into the
	return value.

	* mini-s390.c: Handle DIV_IMM/REM_IMM in the lowering pass instead of in 
	mono_arch_output_basic_block. Fix warnings.

2008-03-20  Zoltan Varga  <vargaz@gmail.com>

	* inssel-long32.brg: Add rules for long conv.ovf.i/conv.ovf.u/conv.ovf.i.un/
	conv.ovf.u.un.

2008-03-20  Zoltan Varga  <vargaz@gmail.com>

	* inssel-long.brg: Add rules for long conv.ovf.i/conv.ovf.u/conv.ovf.i.un/
	conv.ovf.u.un.

	* iltests.il: Add new tests.

2008-03-20  Kornél Pál  <kornelpal@gmail.com>

	* mini.c: Removed Windows version macros.

2008-03-20  Mark Probst  <mark.probst@gmail.com>

	* generic-sharing.c: Put reflection types in the extensible part
	of the runtime generic context.

	* mini.c: Generic sharing of the GetTypeHandle special case of the
	ldtoken instruction.

2008-03-20  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MONO_BB_FOR_EACH_INS_SAFE): New helper macro.

	* mini-<ARCH>.c: Use the new macro instead in the peephole/lowering passes.
	
	* mini.h (MONO_DEL_INS): Rename to MONO_DELETE_INS and Add a 'bb' argument for 
	consistency with the other version on the linear IR branch.

	* mini-<ARCH>.c: Update callers of MONO_DEL_INS.

	* inssel-long32.brg inssel-long.brg: Add rules for conv.ovf.i/conv.ovf.u.

	* iltests.il.in: Add new tests.

2008-03-19  Zoltan Varga  <vargaz@gmail.com>

	* inssel-long32.brg inssel-long.brg: Add rules for conv.ovf.i.un/conv.ovf.u.un.

	* iltests.il.in: Add new tests.

2008-03-19  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Two variables with the same name were declared in
	nesting contexts and one wasn't initialized.  Fixed.

2008-03-19  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Generic sharing of the initobj instruction.

Tue Mar 18 20:18:02 CET 2008 Paolo Molaro <lupus@ximian.com>

	* mini.c: make the test to optimize ldtoken from typeof() more
	precise.

2008-03-18  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Generic sharing of the initobj instruction for reference
	types.

Tue Mar 18 12:39:27 CET 2008 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-amd64.c, mini-x86.c, tramp-amd64.c, tramp-x86.c: change
	the mono_breakpoint_clean_code() code to perform bound checks.

Tue Mar 18 11:50:14 CET 2008 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-trampolines.c, tramp-*.c: change the signature of
	mono_arch_patch_callsite() to include the start of the managed method
	to be able to perform bound checks.

2008-03-17  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Generic sharing for the isinst instruction.

2008-03-17  Mark Probst  <mark.probst@gmail.com>

	* mini-ops.h, inssel.brg, inssel-long.brg, inssel-long32.brg,
	inssel-long32-mips.brg: Added opcodes for doing indirect calls
	with the runtime generic context argument.

	* mini.c: Share calls to several types of unsharable methods by
	putting the address of the method code in the runtime generic
	context and doing an indirect call.

	* graph.c, local-propagation.c, aliasing.c: Added the new opcodes
	to switches.

2008-03-16  Mark Probst  <mark.probst@gmail.com>

	* generic-sharing.c: Change due to a change in the runtime genric
	context API.

2008-03-15  Martin Baulig  <martin@ximian.com>

	* tramp-x86.c
	(mono_arch_nullify_class_init_trampoline): Add call to
	mono_breakpoint_clean_code() to make things work when running
	inside the debugger.

	* tramp-amd64.c
	(mono_arch_nullify_class_init_trampoline): Add call to
	mono_breakpoint_clean_code() to make things work when running
	inside the debugger.

2008-03-14  Zoltan Varga  <vargaz@gmail.com>

	* inssel-long.brg (reg): Fix 64 bit build.

2008-03-14  Mark Probst  <mark.probst@gmail.com>

	* mini.c, mini.h: Share static generic code by passing it an
	implicit argument pointing to the runtime generic context.

	* mini-ops.h, inssel.brg, inssel-long.brg, inssel-long32.brg,
	inssel-long32-mips.brg: New opcodes for calling shared static,
	which need to be passed the runtime generic context.

	* mini-amd64.c, mini-x86.c: Save the runtime generic context
	argument on the stack in the prologue if needed.  New function for
	finding the runtime generic context argument from the registers
	saved by the trampoline.

	* mini-amd64.h, mini-x86.h: Specify which register to use for the
	runtime generic context argument.

	* tramp-amd64.c: Also restore the register used for the runtime
	generic context argument.

	* mini-trampoline.c: Resolve shared static calls by consulting the
	runtime generic context via the new argument.

	* generic-sharing.c: Add an argument to sharability-checking
	functions that specifies whether type variables should be treated
	as sharable type arguments.

	* inssel-x86.brg: Removed a superfluous, buggy rule.

	* graph.c, local-propagation.c, aliasing.c: Added the new opcodes
	to switches.

2008-03-14  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c (main_thread_handler): Call
	mono_runtime_run_main() without sending any notifications.

	* debug-debugger.h (MonoDebuggerInfo): Added `get_method_signature.

2008-03-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_magic_trampoline): Fix build on platforms without IMT.

2008-03-14  Mark Probst  <mark.probst@gmail.com>

	* tramp-x86.c: Fixed register restore offsets in the trampoline
	code for ECX and EDX.

2008-03-12  Geoff Norton  <gnorton@novell.com>

	* mini-arm.h: Add some #defines for locating sp, pc, r4 with
	different ucontext_t implementations.
	* exceptions-arm.c: Use the above defines to get exceptions working on 
	iPhone (based on a patch by Luke Howard lukeh@padl.com)
	* mini-arm.c: Implement iPhone icache support (based on a patch by
	Luke Howard lukeh@padl.com)

2008-03-12  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Enable generic sharing of calls to non-static
	non-interface non-generic non-value-type methods.

	* mini-trampolines.c: Resolve calls from shared generic code.

2008-03-11  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am il2tests.il iltests.il.in: Delete il2tests, merge it into iltests.

	* tramp-amd64.c (mono_arch_create_trampoline_code): Correctly save RBP as well.

Mon Mar 10 11:59:34 CET 2008 Paolo Molaro <lupus@ximian.com>

	* mini.c: some fixes for the AOT compiler.

2008-03-07  Zoltan Varga  <vargaz@gmail.com>

	* cpu-amd64.md: Add clob:1 to some float opcodes.

2008-03-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.h: Added MiniVerifierMode enumeration.

	* mini.c: Added mini_verifier_set_mode to control
	the usage of the new verifier.

	* mini.c (mono_method): Integrated the new verifier.

	* driver.c: Extended --security option with validil and
	verifiable options to activate the new verifier.

2008-03-07  Zoltan Varga  <vargaz@gmail.com>

	* mini.c jit-icalls.h jit-icalls.c: Generalize the exception creation 
	optimization to ctors taking 0 or 2 arguments too.

	* mini.c (mono_method_to_ir): Optimalize the size of the exception throwing code
	a bit.

	* jit-icalls.h (mono_create_corlib_exception): New JIT icall.

	* mini-amd64.c (mono_arch_emit_prolog): Improve the first_bb optimization a bit.

2008-03-06  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Apply one of the ldstr optimizations in the
	non-aot case as well.

	* cpu-amd64.md: Reduce the max size of some frequently used opcodes.

	* aot-runtime.c (decode_patch_info): Update this after the ldfld/stfld wrapper
	changes.

	* aot-compiler.c (encode_patch): Ditto.

	* mini.h (G_MININT32): Fix the definition of this.

2008-03-05  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Define G_MININT32/G_MAXINT32 if using an older glib version.

	* cfold.c: Remove definition of G_MININT32 which is now in mini.h.

2008-03-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_compute_omit_fp): Don't disable fp elimination for 
	methods returning vtypes in registers.
	(mono_arch_allocate_vars): Ditto.

	* mini-amd64.c (mono_arch_get_this_arg_reg): New arch specific helper function.

	* tramp-amd64.c (mono_arch_get_unbox_trampoline): Use mono_arch_get_this_arg_reg ().	

	* generics.cs: Add a test from the linear IR branch.

	* mini-amd64.c (emit_load_volatile_arguments): Handle vtypes passed in regs too.

	* mini.c (inline_method): Cache failed inline attempts.

2008-03-04  Mark Probst  <mark.probst@gmail.com>

	* mini.c: For shared methods of generic classes put the location
	of "this" into the MonoGenericJitInfo.

	* mini-x86.c, mini-amd64.c, mini.h: Added function for fetching a
	register out of a MonoContext by register number.  Add the generic
	sharing context as an argument to mono_arch_find_this_argument().

	* mini-alpha.c, mini-arm.c, mini-hppa.c, mini-ia64.c, mini-mips.c,
	mini-ppc.c, mini-s390.c, mini-s390x.c, mini-sparc.c: Added stub
	for new arch function.

	* mini-exception.c: Handle open exception clauses in shared
	generic code.

	* mini-trampolines.c: Supply additional argument to
	mono_arch_find_this_argument().

2008-03-04  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (regtests): Run the bench.exe tests last.

2008-03-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_prolog): Improve the first bblock optimization
	a bit.

2008-03-02  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Allow callvirt on static methods for compatibility
	with MS.

	* mini-amd64.c (mono_arch_emit_prolog): Fix tracing after the last change.
	
	* mini-amd64.c (mono_arch_emit_prolog): Avoid saving dead arguments.

	* mini.c (mono_method_check_inlining): Avoid disabling inlining for methods
	whose class has no cctor.

	* liveness.c (mono_analyze_liveness): Mark dead arguments with MONO_INST_IS_DEAD.

2008-03-01  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Report calling a static method using callvirt as
	unverified.

2008-02-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-ops.h: Remove OP_SPARC_INARG_VT, add a new OP_VTARG_ADDR opcode instead
	to be in sync with the code on the linear IR branch.

	* mini-sparc.c inssel-sparc.brg: Use OP_VTARG_ADDR.

	* inssel-s390.brg (OP_SETRET (freg)): Set dreg correctly.

2008-02-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-mips.c: Use cfg->vret_addr instead of cfg->ret.

	* mini-s390x.c: Use cfg->vret_addr instead of cfg->ret.

	* mini-s390.c: Use cfg->vret_addr instead of cfg->ret.

	* mini-<ARCH>.h mini.c: Get rid of the MONO_ARCH_HAVE_CREATE_VARS define.

	* mini-<ARCH>.c (mono_arch_create_vars): Define this for all architectures.
	
	* mini.c (mono_method_to_ir): Avoid invalid memory reads for methods without a
	body.

2007-11-14  Yoichi NAKAYAMA  <nakayama@pixela.co.jp>

	* inssel-mips.brg (OP_OUTARG_MEMBASE (CEE_LDIND_R4 (base))): Add missing
	OP_LOADR4_MEMBASE emission.

	* mini-codegen.c (mono_spillvar_offset_int): Remove assertion.
	(mono_spillvar_offset_float): Ditto.

	* mini-mips.c (mono_arch_emit_prolog): Ditto.

	* inssel-long32-mips.brg: Fix wrong branching, reduce redundant code
	emission.

	* basic-long.cs: Add regression tests for them.

	* mini-mips.c (add_float32_arg): Respect o32 calling convention in gr
	use.
	(mono_arch_allocate_vars): Fix representation of single-precision float
	argument.
	(mono_arch_output_basic_block): Ditto.

	* inssel-mips.brg: Ditto, remove duplicate items.

	* mini-mips.c (emit_load_volatile_arguments): New function to handle
	arguments of tail calls as on other platforms.
	(mono_arch_output_basic_block): Handle tail calls.

	* inssel-mips.brg (OP_OUTARG_VT (CEE_LDOBJ (base))): Correct destination
	register.

	* objects.cs (test_5_pass_static_struct): Add test for it.

	Contributed under MIT/X11 license.

2008-02-26  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am: Use gmcs for compiling the regression tests.

	* *.2.cs *.2.il: Rename to *.cs and *.il.

2008-02-24  Zoltan Varga  <vargaz@gmail.com>

	* regalloc.h: Make the vassign array smaller.

	* mini.c (mini_method_compile): Remove an unused field in cfg.

	* mini-codegen.c: Add a bunch of micro optimizations.

2008-02-23  Zoltan Varga  <vargaz@gmail.com>

	* regalloc.h: Remove some unused fields.

2008-02-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_patch_code): Fix a warning.

	* ssa.c (mono_ssa_remove): Avoid declaring volatile variables dead.

2008-02-22  Mark Probst  <mark.probst@gmail.com>

	* mini.h: New trampoline type (RGCTX_LAZY_FETCH).

	* mini-trampolines.c, tramp-amd64.c, tramp-x86.c: RGCTX lazy fetch
	trampoline: Fetch an entry from the runtime generic context.  If
	it's NULL, jump to the actual trampoline to fill the runtime
	generic context.  Otherwise, return it.

	* mini.c: Call the lazy fetch trampoline to get entries out of the
	runtime generic context.

	* tramp-ia64.c, tramp-arm.c, tramp-alpha.c, tramp-s390.c,
	tramp-s390x.c, tramp-ppc.c, tramp-hppa.c, tramp-mips.c,
	tramp-sparc.c: Stubs for the lazy fetch trampoline.

2008-02-21  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Fetch data out of the extensible part of the runtime
	generic context instead of calling a helper function.

	* generic-sharing.c: Some functions moved into
	metadata/generic-sharing.c.  Helper function for fetching other
	types now checks and asserts against extensible rgctx (just for
	debugging purposes - the helper function isn't called anymore
	unless for debugging).

2008-02-21  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_output_basic_block): Implement proper argument passing
	for tail calls up to the point that the tests in iltests.exe run. Also add a
	dummy CKFINITE implementation.
	(mono_arch_emit_prolog): Avoid saving the method in the LMF since it is only
	needed for trampoline LMF frames.

	* exceptions-arm.c (mono_arch_find_jit_info): Only read lmf->method for 
	trampoline LMF frames.

2008-02-21  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (inline_method): clean any pending loader error when inlining fail.
	Otherwise loader errors in mono_method_to_ir leaks and cause spurious errors.

2008-02-21  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (encode_patch): Handle ICALL_ADDR patch type.

	* aot-runtime.c (decode_patch_info): Ditto.

	* mini.c (mono_resolve_patch_target): Ditto.
	
	* aot-compiler.c (compile_method): Add some experimental code for AOT compiling
	icall wrappers.

	* patch-info.h (PATCH_INFO): Add 'ICALL_ADDR' patch type.
	
	* mini.c (mono_method_to_ir): Convert a CEE_MONO_LDPTR opcode to an AOT constant
	if it references an icall address.

2008-02-20  Zoltan Varga  <vargaz@gmail.com>

	* cpu-s390x.md: Remove some more unused opcodes.
	
	* cpu-s390x.md: Remove some unused opcodes.

	* mini-ia64.c (mono_arch_lowering_pass): Add some more opcodes. Use
	mono_op_imm_to_op ().

	* mini-sparc.c (opcode_to_sparc_cond): Use the mono_opcode_to_cond () functions
	instead of a switch statement.
	
	* mini-sparc.c (mono_arch_allocate_vars): Allocate a stack slot for use by
	the int<->float conversion opcodes instead of using mono_spillvar_offset_float ().

	* mini-codegen.c: Eliminate rassign macro which is no longer needed.
	
	* mini-codegen.c: Remove unused mono_regstate2_... functions.

	* mini-codegen.c (mono_print_ins_index): Avoid printing an index when it is
	-1.

2008-02-19  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_main): Improve error reporting when an assembly cannot be
	opened. Fixes #362607.

	* cpu-ia64.md cpu-s390x.md: Remove some unused opcodes.

	* iltests.il.in: Add a test for static methods in interfaces.

2008-02-18  Zoltan Varga  <vargaz@gmail.com>

	* genmdesc.c (build_table): Fix a crash on older glib versions.

	* cpu-sparc.md: Remove some unused opcodes.
	
	* genmdesc.c: Error out if the .md contains CEE_ opcodes if 
	MONO_ARCH_ENABLE_NORMALIZE_OPCODES is defined.

	* cpu-amd64.md: Remove some unused opcodes.

	* mini.h mini-ops.h mini.c: Define the OP_Ccc opcodes in mini-ops.h normally
	like the other opcodes.

2008-02-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c: Use cfg->vret_addr instead of cfg->ret.

	* mini-arm.h mini-arm.c: Use cfg->vret_addr instead of cfg->ret.

	* mini-sparc.c: Use cfg->vret_addr instead of cfg->ret. Name the MonoCompile
	variables 'cfg' instead of 'm' for consistency.

	* mini-x86.c: Use cfg->vret_addr instead of cfg->ret.

	* mini.h (MonoCompile): Add new 'vret_addr' field which represents the hidden
	argument holding the vtype return address, to avoid the ambigious use of
	cfg->ret for this purpose.

	* mini.c (NEW_RETLOADA): Use vret_addr if set.

	* mini-amd64.c: Use cfg->vret_addr instead of cfg->ret.
	
	* mini-codegen.c (mono_print_ins): Rename to mono_print_ins_index (), Add a
	new mono_print_ins () function which only takes one argument.

2008-02-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-s390.h (MONO_OUTPUT_VTR): Use cfg instead of s, avoid assignments to
	macro arguments.

2008-02-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-ops.h: Get rid of OP_SPARC_LOCALLOC_IMM.

	* mini-sparc.c inssel-sparc.brg: Use OP_LOCALLOC_IMM instead of OP_SPARC_LOCALLOC_IMM.

	* mini-x86.c: Sync with the version on the linear IR branch by adding new 
	opcodes and other small changes.

	* mini-ops.h: Add some new opcodes from the linear IR branch.

	* mini-ops.h: Get rid of the OP_X86_..._MEMBASE opcodes.

	* mini-x86.c inssel-x86.brg cpu-x86.md: Get rid of the confusing _MEMBASE
	opcodes, use the REG_MEMBASE opcodes instead.
	
	* mini-amd64.c inssel-amd64.brg cpu-amd64.md: Get rid of the confusing _MEMBASE
	opcodes, use the REG_MEMBASE opcodes instead.
	
	* mini-amd64.c (mono_arch_output_basic_block): Sync with the version on the
	linear IR branch.

	* mini.c (mono_op_imm_to_op): New helper function.

	* mini-ops.h: Add some opcodes from linear IR branch.

2008-02-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-alpha.h mini-alpha.c tramp-alpha.c: Alpha port updates from Sergey Tikhonov 
	<tsv@solvo.ru>.

2008-02-12  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_normalize_opcodes): Always convert CEE_CONV_R4/R8 to 
	OP_ICONV_TO_R4/R8.

	* mini-ia64.c cpu-ia64.md: Add OP_ICONV_TO_R4/R8.

2008-02-09  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_method_code): Add an assert.

	* mini-arm.h mini-arm.c exceptions-arm.c: Modify the exception throwing code and
	the IMT code so it is AOT friendly. Enable AOT for methods which call interface
	methods.

2008-02-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_output_basic_block): Fix the ordering of arguments for 
	some load/store opcodes so they are consistent.	
	(mono_arch_emit_prolog): Simplify some code.

	* aot-runtime.c (mono_aot_get_plt_entry): Fix a warning.

	* objects.cs: Add tests for large argument offsets on ARM.

	* mini-arm.c (mono_arch_emit_prolog): Fix handling of arguments with large 
	stack offsets. Fixes #359651.

	* mini.c (mono_normalize_opcodes): Remap CEE_CONV_R4/R8 properly.

	* cpu-s390x.md: Add OP_LCONV_TO_R4/R8.

	* cpu-ia64.md mini-ia64.h mini-ia64.c: Get rid of CEE_ opcodes.

	* mini-ops.h: Add OP_ICONV_TO_R_UN opcode.

	* mini.c (mono_normalize_opcodes): Remap CEE_CONV_R_UN too.

	* cpu-s390x.md cpu-s390.md mini-s390x.c mini-arm.c cpu-arm.md mini-s390.c: Get
	rid of CEE_CONV_R_UN.

	* mini-s390x.c mini-s390x.h cpu-s390x.md inssel-s390x.brg: Get rid of CEE_ opcodes.

2008-02-07  Zoltan Varga  <vargaz@gmail.com>

	* mini-s390.c mini-s390.h cpu-s390.md: Get rid of CEE_ opcodes.

	* mini.c (mono_normalize_opcodes): Add some more opcodes.

	* mini-arm.c mini-arm.h cpu-arm.md: Get rid of CEE_ opcodes.

	* cpu-amd64.md: Remove some unused opcodes.

	* mini-sparc.c mini-sparc.h cpu-sparc.md: Get rid of CEE_ opcodes.

	* mini-x86.c mini-x86.h cpu-x86.md: Get rid of CEE_ opcodes.

	* mini.c mini-<ARCH>.c: Remove mono_arch_local_regalloc (), instead make 
	arch specific functions for its parts. Call the peephole pass after local
	regalloc so the prolog can compute a more accurate max_offset.
	
	* mini.c (mono_normalize_opcodes): New mini pass to convert CEE_ opcodes to
	the corresponding OP_I/OP_L opcodes.

	* mini-amd64.c mini-amd64.h cpu-amd64.md: Get rid of CEE_ opcodes.

	* mini-sparc.c (mono_arch_output_basic_block): Fix the sparc build.

2008-02-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-s390.c (mono_arch_get_inst_for_method): Remove the Interlocked cases
	as they are handled in mini.c.

	* mini-s390x.c (mono_arch_get_inst_for_method): Ditto.
	
	* mini-<ARCH>.c (mono_arch_get_inst_for_method): Remove the MemoryBarrier
	case since it is handled in mini.c.

	* cpu-sparc.md (sparc_setfreg_float): Fix the sparc build.

	* mini-ops.h: Add new opcodes OP_CALL/OP_CALLVIRT.

	* *.c: Use the new opcodes in the IR and back end code.

	* mini-ops.h cpu-<ARCH>.md: Correct the name of the bgt_un opcodes.

	* mini-amd64.c (emit_call_body): Use a far-call for calling dynamic methods.

2008-02-06  Mark Probst  <mark.probst@gmail.com>

	* mini-trampolines.c (mono_generic_class_init_trampoline): Removed
	an assert because it has a race condition.

2008-02-06  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_patch_callsite): Add more diagnostics.

	* inssel.brg mini-<ARCH>.c cpu-<ARCH>.md: Get rid of unused CEE_RET opcode.

	* mini-<ARCH>.c cpu-<ARCH>.md: Get rid of unused LDIND/STIND opcodes.

	* *.brg mini-<ARCH>.c cpu-<ARCH>.md: Get rid of OP_SETREG/OP_SETFREG/OP_SETREGIMM,
	use OP_MOVE/OP_FMOVE/OP_ICONST instead.

2008-02-05  Zoltan Varga  <vargaz@gmail.com>

	* cpu-amd64.md (move): Correct the maximum size of move.

2008-02-05  Mark Probst  <mark.probst@gmail.com>

	* tramp-amd64.c, tramp-x86.c, mini-trampolines.c: Added a check in
	the generic class init trampoline to return quickly if the class
	is already inited.

2008-02-04  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_patch_callsite): Add some diagnostics to help debug
	issues where an 32 bit callsite cannot be patched by a 64 bit address.

2008-02-03  Zoltan Varga  <vargaz@gmail.com>

	* generics.2.cs generics-variant-types.2.il: Merge some tests from the linear IR
	branch.

2008-01-31  Zoltan Varga  <vargaz@gmail.com>

	* objects.cs: Add some soft-float tests.

	* mini.c: Fix a couple more soft-float issues.

	* helpers.c (mono_disassemble_code): Fix disassembly on ARM.

	* mini-amd64.c (peephole_pass): Use IXOR instead of LXOR for zeroing a register to
	avoid a REX prefix.

2008-01-30  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c (mono_arch_find_jit_info): Fix stack unwinding when an
	exception happens while compiling a virtual method.

2008-01-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (mono_arch_emit_epilog): Fix folding of negative return values.
	
	* mini-sparc.c: Fix build.

	* mini-sparc.c (get_call_info): Add support for generic sharing.

	* mini-exceptions.c: Add a FIXME.

2008-01-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_exception_internal): Remove the old style
	altstack handling code.

	* mini-s390.c (mono_arch_emit_exceptions): Really fix a warning.
	
	* mini-s390.c (mono_arch_emit_exceptions): Fix a warning.

	* mini-s390.c: Add support for generic sharing.

	* mini-exceptions.c (ves_icall_System_Security_SecurityFrame_GetSecurityFrame): 
	Fix CAS on s390.
	(ves_icall_System_Security_SecurityFrame_GetSecurityStack): Ditto.

	* mini-s390x.c (mono_arch_emit_exceptions): Fix a warning.

	* mini-s390x.c: Add support for generic sharing.
	
	* mini-exceptions.c (ves_icall_System_Security_SecurityFrame_GetSecurityFrame): 
	Fix CAS on ia64.
	(ves_icall_System_Security_SecurityFrame_GetSecurityStack): Ditto.

	* mini-s390x.c: Use is_imm16 instead of is_uimm16 when checking whenever s390_aghi
	can be used since it takes a 16 bit signed immediate.

	* inssel-s390x.brg: Fix OP_SETRET.

	* mini-s390x.c (mono_arch_output_basic_block): Fix OP_BREAK.

	* mini-codegen.c (mono_opcode_to_cond): Fix a warning.

	* mini-s390x.c cpu-s390x.md: Implement sext.i4 properly by sign extension.

	* mini.c (mono_create_delegate_trampoline): Don't use mono_create_ftpntr here.

	* mini-trampolines.c (mono_delegate_trampoline): Use mono_get_addr_from_ftnptr
	in one place.

	* mini-ia64.h mini-ia64.c: Add minimal support for the delegate trampoline 
	stuff.

	* mini.h inssel-x86.brg inssel-amd64.brg tramp-alpha.c tramp-ia64.c: Get rid
	of the unused mono_arch_patch_delegate_trampoline stuff.

2008-01-26  Zoltan Varga  <vargaz@gmail.com>

	* basic-long.cs: Move the fp related tests to basic-float.cs.

	* mini-ops.h (OP_OUTARG_FREG_R4): New opcode.

	* mini-ia64.c inssel-ia64.brg: Implement proper R4 argument passing.

	* basic-calls.cs: Add a test for proper float argument passing.

	* mini-ia64.h (mono_ia64_context_get_ip): Do not substract 1 from the ip
	if the context corresponds to an exception received through a signal.

	* exceptions.cs: Add a test for nullref handling at the start of a try
	clause.

	* mini-ia64.c (mono_arch_call_opcode): Fix ia64 argument passing.

	* jit-icalls.c (mono_break): New JIT icall.

	* mini-<ARCH>.c: Use mono_break instead of mono_arch_break.

	* mini-arm.c (arm_patch): Add support for patching the blx calling sequence.

2008-01-25  Zoltan Varga  <vargaz@gmail.com>

	* cpu-*.md: Get rid of unused opcodes.

	* cpu-g4.md: Rename this to cpu-ppc.md for consistency with other archs.

	* Makefile.am: Move mini-trampolines.c to $(common_sources) since it is now used
	by all platforms.

	* mini-<ARCH>.h mini.c: Get rid of the MONO_ARCH_HAVE_CREATE_SPECIFIC_TRAMPOLINE
	define.

	* mini-s390x.h tramp-s390x.c Makefile.am: Rework the s390x trampoline code to use
	the arch independent trampoline code in mini-trampolines.c.

	* aot-runtime.c (mono_aot_init_vtable): Fix a warning.

	* mini.c (get_runtime_generic_context_ptr): Fix a warning.

	* mini-s390.h: Remove an unused define.
	
	* mini-s390.h tramp-s390.c Makefile.am: Rework the s390 trampoline code to use
	the arch independent trampoline code in mini-trampolines.c.

	* mini-arm.c (mono_arch_emit_prolog): Fix build.

2008-01-24  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (mono_arch_output_basic_block): Remove some unecessary code.

	* mini-s390.c (mono_arch_emit_prolog): Fix build.

	* mini-s390x.c (mono_arch_emit_prolog): Fix build.

	* mini-ppc.c (mono_arch_emit_prolog): Fix build.

	* cpu-amd64.md: Use smaller sizes for int opcodes.

	* *.c: Get rid of the NOT_IMPLEMENTED define which is now in mini.h.

	* *.cs: Add some tests from the linear-ir branch. Move structs tests to 
	objects.cs.

	* driver.c (mono_main): Add a --break-at-bb command line argument for JIT
	debugging.

	* mini.h *.c: Change cfg->vars to contain the MonoMethodVar entries directly
	instead of though a pointer to save an indirection when accessing elements of
	the array.

	* mini.h (MONO_IS_COND_BRANCH_OP): Move these macros here from mini.c. Fix
	some typos.
	(NOT_IMPLEMENTED): New helper macro.
	(MONO_BB_FOR_EACH_INS): New helper macro to iterate through the instructions
	of a bb.

	* *.c: Use the new helper macro.

2008-01-21  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.h (MONO_ARCH_AOT_SUPPORTED): Disable AOT for apple x86.

2008-01-20  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_prolog): Optimize the omit fp case to save two
	stack slots.

2008-01-18  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_prolog): Disable	the new optimization if
	profiling is enabled.
	
	* mini-amd64.c (mono_arch_call_opcode): Emit the save_sp_to_lmf instruction at
	the end.
	(mono_arch_emit_prolog): Add more first bblock optimizations.

	* mini-amd64.c (mono_arch_call_opcode): Keep assignments to the arg registers
	in order if possible.
	(mono_arch_emit_prolog): Optimize assignments to arg registers in the first
	bblock, since the arguments are still in their original registers.

	* mini.c (type_from_op): Calling add.ovf on floats is not valid IL code.

2008-01-17  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Use the no-spilling optimization for CEE_CALLI
	as well.

	* mini-amd64.c (mono_arch_emit_prolog): Save an instruction if the LMF is at
	offset 0.

	* mini-amd64.h (MONO_ARCH_HAVE_NOTIFY_PENDING_EXC): Turn on this for amd64.

	* exceptions-amd64.c (mono_arch_notify_pending_exc): New function to 
	process async exceptions received while in unmanaged code.

	* mini.c (mini_init): Install a callback with the runtime which will be called
	when a thread receives an async exception while in unmanaged code.

	* mini.c driver.c: Update after mono_get_native_wrapper () signature change.

	* mini-s390x.c (mono_arch_output_basic_block): Fix s390x build.

2008-01-16  Wade Berrier  <wberrier@novell.com>

	* cpu-g4.md:
	* cpu-arm.md:
	* cpu-s390x.md:
	fix build

2008-01-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_output_basic_block): Remove some gccism which prevents
	compilation with sun cc.

	* cpu-*.md: Fix the build.

	* cpu-x86.md: Fix the length of some load membase opcodes. Fixes #354241.

	* mini-amd64.h: Add some comments to the MonoLMF structure.

	* mini-ops.h cpu-amd64.c: Add a OP_AMD64_SAVE_SP_TO_LMF opcode.
	
	* mini-amd64.c exceptions-amd64.c tramp-amd64.c: Avoid setting the rip field
	in the LMF structure if possible. This saves two instructions in the
	managed->native wrappers.

	* mini-ops.h *.md: Make some opcodes names uniform by removing the op_ prefix.

2008-01-16  Mark Probst  <mark.probst@gmail.com>

	* generic-sharing.c: New type argument lookup code which uses the
	runtime generic context template.

2008-01-15  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Avoid emitting a write barrier when storing NULL.

	* mini-arm.c (add_general): Fix arm eabi parameter passing.
	(mono_arch_output_basic_block): Fix localloc implementation.

	* mini-amd64.c (peephole_pass): Sync store+load optimizations with the x86 version.

	* mini-ia64.c (peephole_pass): Fix ia64 build.

	* mini-amd64.c (peephole_pass): Fix a warning.
	
	* mini-amd64.c (mono_arch_allocate_vars): Make sure the LMF is always stored
	at a constant offset from sp/fp.

	* exceptions-amd64.c (mono_arch_find_jit_info): Compute the LMF address from fp/sp
	instead of obtaining it from *lmf in the managed method case.

2008-01-14  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c (mono_arch_find_jit_info): Remove some duplicate code.

Mon Jan 14 12:33:06 CET 2008  David S. Miller  <davem@davemloft.net>

	* mini.h (MonoInstList): New type.
	(MONO_INST_LIST_INIT, MONO_INST_LIST_EMPTY,
	__MONO_INST_LIST_ADD, MONO_INST_LIST_ADD,
	MONO_INST_LIST_ADD_TAIL, __MONO_INST_LIST_DEL,
	__MONO_INST_LIST_SPLICE, MONO_INST_LIST_SPLICE,
	MONO_INST_LIST_SPLICE_TAIL, MONO_INST_LIST_SPLICE_INIST,
	MONO_INST_LIST_SPLICE_TAIL_INIT, mono_container_of,
	MONO_INST_LIST_ENTRY, MONO_INST_LIST_FIRST_ENTRY,
	MONO_INST_LIST_LAST_ENTRY, MONO_INST_LIST_FOR_EACH,
	MONO_INST_LIST_FOR_EACH_PREV, MONO_INST_LIST_FOR_EACH_SAFE,
	MONO_INST_LIST_FOR_EACH_PREV_SAFE,
	MONO_INST_LIST_FOR_EACH_ENTRY,
	MONO_INST_LIST_FOR_EACH_ENTRY_REVERSE,
	MONO_INST_LIST_FOR_EACH_ENTRY_SAFE,
	mono_inst_list_first, mono_inst_list_last,
	mono_inst_list_next, mono_inst_list_prev): New instruction
	list handling interfaces.
	(MonoBasicBlock): Remove 'last_ins' and 'code', replace with
	list head 'ins_list'.
	(MonoInst): Replace next pointer with list head 'node'.
	(MonoCallInst): Make 'out_args' a MonoInstList.
	(MONO_INST_NEW_CALL): Explicitly init ->out_args.
	(MonoCompile): Delete reverse_inst_list and
	reverse_inst_list_len.
	* mini-hppa.c (mono_arch_call_opcode, NEW_INS,
	mono_arch_lowering_pass, mono_arch_local_regalloc,
	mono_arch_output_basic_block, mono_arch_emit_prolog):
	Convert to new instruction lists.
	(insert_after_ins): Delete.
	* inssel.brg (MONO_EMIT_NEW_BRANCH_BLOCK): Convert to new
	instruction lists.
	* mini-hppa.h (MONO_EMIT_NEW_COMPARE_BRANCH_BLOCK): Likewise.
	* mini.c (NEW_BBLOCK, ADD_BBLOCK, CHECK_BBLOCK,
	split_bblock, mono_add_ins_to_end, mono_emit_call_args,
	mono_emulate_opcode, mono_emit_load_got_addr,
	inline_method, mono_method_to_ir, mono_print_bb_code,
	print_dfn, decompose_pass, nullify_basic_block,
	replace_out_block_in_code, remove_block_if_useless,
	merge_basic_blocks, move_basic_block_to_end,
	try_unsigned_compare, optimize_branches, mono_print_code,
	mini_select_instructions, remove_critical_edges): Likewise.
	* mini-amd64.c (emit_sig_cookie, mono_arch_call_opcode,
	peephole_pass_1, peephole_pass, mono_arch_lowering_pass,
	mono_arch_output_basic_block, mono_arch_emit_prolog):
	Likewise.
	* mini-mips.c (mono_arch_call_opcode, peephole_pass,
	NEW_INS, mono_arch_lowering_pass, mono_arch_local_regalloc,
	mono_arch_output_basic_block): Likewise.
	(inst_list_prepend, insert_after_ins): Delete.
	* mini-mips.h (MONO_EMIT_NEW_BRANCH_NONZERO_LABEL,
	MONO_EMIT_NEW_COMPARE_BRANCH_BLOCK): Convert to new
	instruction lists.
	* mini-x86.c (emit_sig_cookie, mono_arch_call_opcode,
	peephole_pass_1, peephole_pass, mono_arch_output_basic_block,
	mono_arch_emit_prolog): Likewise.
	* cfold.c (mono_constant_fold): Likewise.
	* liveness.c (visit_bb, mono_analyze_liveness,
	optimize_initlocals): Likewise.
	* ssapre.c (dump_code, process_bb, code_motion): Likewise.
	* graph.c (mono_draw_code_cfg): Likewise.
	* ssa.c (mono_ssa_rename_vars, mono_ssa_compute,
	mono_ssa_remove, mono_ssa_avoid_copies, mono_ssa_create_def_use,
	mono_ssa_cprop): Likewise.
	* abcremoval (get_relations_from_previous_bb, process_block):
	Likewise.
	* local-propagation (mono_cprop_invalidate_values,
	mono_local_cprop_bb): Likewise.
	* mini-s390x.c (mono_arch_call_opcode, emit_sig_cookie,
	peephole_pass, mono_arch_output_basic_block,
	mono_arch_emit_prolog):	Likewise.
	* mini-arm.c (mono_arch_call_opcode, peephole_pass,
	NEW_INS, mono_arch_lowering_pass, mono_arch_local_regalloc,
	mono_arch_emit_prolog): Likewise.
	(insert_after_ins): Delete.
	* aliasing.c (print_code_with_aliasing_information,
	mono_build_aliasing_information, mono_aliasing_deadce):
	Convert to new instruction lists.
	* mini-ia64.c (emit_sig_cookie, mono_arch_call_opcode,
	peephole_pass, NEW_INS, mono_arch_lowering_pass,
	mono_arch_local_regalloc, mono_arch_output_basic_block):
	Likewise.
	(insert_after_ins): Delete.
	* mini-sparc.c (emit_sig_cookie, mono_arch_call_opcode,
	peephole_pass, mono_arch_output_basic_block): Convert to
	new instruction lists.
	* mini-codegen (InstList, inst_list_prepend,
	insert_after_ins): Delete.
	(insert_before_ins, get_register_force_spilling,
	get_register_spilling, free_up_ireg, free_up_reg,
	create_copy_ins, create_spilled_store, alloc_int_reg,
	alloc_float_reg, alloc_reg, mono_local_regalloc): Convert
	to new instruction lists.
	* mini-ppc.c (mono_arch_call_opcode, peephole_pass,
	NEW_INS, mono_arch_lowering_pass, mono_arch_local_regalloc,
	mono_arch_output_basic_block, mono_arch_emit_prolog): Likewise.
	(insert_after_ins): Delete.
	* mini-alpha.c (NEW_INS, peephole_pass, mono_arch_lowering_pass,
	mono_arch_local_regalloc, mono_arch_output_basic_block,
	mono_arch_call_opcode): Convert to new instruction lists.
	(insert_after_ins): Delete.
	* mini-s390.c (mono_arch_call_opcode, emit_sig_cookie,
	peephole_pass, mono_arch_output_basic_block,
	mono_arch_emit_prolog): Convert to new instruction lists.

2008-01-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Use a 4 byte load in OP_CHECK_THIS.

	* mini-sparc.c (mono_arch_output_basic_block): Use a byte load in CHECK_THIS.
	Fixes #353182.

	* Makefile.am (version.h): Make this work with non-bash shells.

2008-01-10  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (handle_delegate_ctor): Optimize away setting of NULL target.

2008-01-08  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Fix possible reading of invalid memory in 
	the InitializeArray optimization.

2008-01-06  Zoltan Varga  <vargaz@gmail.com>

	* mini.c driver.c: Don't include os/gc_wrapper.h.

2008-01-05  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (print_jit_stats): Print GC statistics if available.

2008-01-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_allocate_vars): Align argument storage offsets to 8.

2007-12-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_get_delegate_invoke_impl): Fix flushing of icache.

2007-12-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_init): Move the setting of GC_stackbottom to mono_gc_base_init ().
	
	* mini.c (mini_init): Call mono_gc_base_init () instead of MONO_GC_PRE_INIT ().

	* driver.c (mono_main): Ditto.

2007-12-23  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_delegate_trampoline): Use mono_get_delegate_invoke ().

	* aot-compiler.c (emit_klass_info): Avoid emitting info if one of the methods
	in the vtable can't be encoded.
	(compile_method): Ditto.

2007-12-21  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (setup_jit_tls_data): Use the MONO_ARCH_INIT_TOP_LMF_ENTRY macro if
	defined.

	* mini-amd64.h mini-amd64.c exceptions-amd64.c tramp-amd64.c: Rename lmf->ebp to 
	lmf->rbp.

	* exceptions-amd64.c (mono_arch_find_jit_info): Fix the detection of whenever
	the top LMF entry belongs to the current method.

	* mini.c: Update after renaming of mono_thread_get_pending_exception ().

2007-12-20  Zoltan Varga  <vargaz@gmail.com>

	* tramp-ia64.c (mono_arch_create_trampoline_code): Fix a warning.
	
	* tramp-ia64.c (mono_arch_create_trampoline_code): Ditto.

	* tramp-sparc.c (mono_arch_create_trampoline_code): Check for thread interruption.

	* tramp-amd64.c (mono_arch_create_trampoline_code): Ditto.

	* tramp-x86.c (mono_arch_create_trampoline_code): Check for thread interruption.

	* cpu-amd64.md mini-amd64.h mini-amd64.c inssel-amd64.brg: Add ulong->double 
	implementation.

	* basic-float.cs: Add an ulong->double cast test.

2007-12-15  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Fix a warning.

2007-12-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-ops.h: Add OP_SWITCH.

	* mini.c graph.c ssa.c aliasing.c mini-<ARCH>.c inssel-<ARCH>.brg: Avoid using
	CEE_SWITCH in back-end code, use OP_SWITCH instead.

2007-12-11  Geoff Norton  <gnorton@novell.com>

	* mini-s390x.c: Minor change to the MAX() define to allow
	it to compile with other gcc versions.

2007-12-11  Geoff Norton  <gnorton@novell.com>

	* cpu-s390x.md:
	* mini-s390x.c: Implement sext_i4 to fix the build on s390x

2007-12-11  Rodrigo Kumpera  <rkumpera@novell.com>

	exceptions-arm.c (mono_arch_get_restore_context): Restore
	the frame pointer.

	exceptions-arm.c (throw_exception): Save the frame pointer.
	This is a partial fix for #323747. Only the client side is
	fixed.

2007-12-11  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mono_method_to_ir): Verbose message in CEE_NEWOBJ
	was using an unrelated variable to log the class which
	needed the cctor to be called. This was crashing on arm.

2007-12-09  Robert Jordan  <robertj@gmx.net>

	* mini-x86.c (mono_arch_emit_epilog):
	Consider all kinds of 64-bit types. Fixes #323114.

2007-12-08  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_create_trampoline_code): Clean up the code a bit.

2007-12-07  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (peephole_pass): Add a missing instruction check.

Fri Dec 7 22:08:23 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: run type ctor before allocating an object, not only
	when running it's constructor method (fixes at least part of bug #342507).

2007-12-07  Zoltan Varga  <vargaz@gmail.com>
	
	* mini-trampolines.c (mono_delegate_trampoline): Fix a warning.
	
	* mini-trampolines.c (mono_generic_class_init_trampoline): Remove a debug printf.
	* mini.h mini-amd64.c mini-x86.c: Get rid of the mono_arch_find_vtable () 
	function.

	* tramp-x86.c tramp-amd64.c mini-trampolines.c: Pass the vtable argument to
	mono_generic_class_init_trampoline () the same as it is done with the other
	trampolines.

	* mini-arm.h mini-arm.c tramp-arm.c inssel-arm.brg cpu-arm.md 
	aot-runtime.c aot-compiler.c: Implement AOT support.	

2007-12-07  Mark Probst  <mark.probst@gmail.com>

	* mini-trampolines.c (mono_generic_class_init_trampoline): Fixed
	build for archs which don't have the vtable trampoline defined
	yet.

2007-12-07  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c (mono_arch_create_trampoline_code): Fix the build.

	* tramp-ppc.c (mono_arch_create_trampoline_code): Use the new helper function.

	* mini-trampolines.c (mono_get_trampoline_func): New helper function.

	* tramp-<ARCH>.c: Use the new helper function.

2007-12-07  Mark Probst  <mark.probst@gmail.com>

	* inssel.brg: Added a pattern for the OP_TRAMPCALL_VTABLE
	trampoline call, which takes a vtable argument.

	* graph.c, mini-ops.h, local-propagation.c, aliasing.c: Treat
	OP_TRAMPCALL_VTABLEs like other calls.

	* mini-amd64.c, mini-amd64.h, mini-x86.c, mini-x86.h: Designated a
	register to hold the vtable argument to the OP_TRAMPCALL_VTABLE
	call.  Implemented a support function which fetches the vtable
	from a register set.

	* mini.c, mini.h, tramp-amd64.c, tramp-x86.c, mini-trampolines.c:
	Implemented a generic class init trampoline, using the
	OP_TRAMPCALL_VTABLE opcode.

	* mini.c: Implemented static field access when sharing generic
	code.  This implies initing the class using the new
	OP_TRAMPCALL_VTABLE call.

2007-12-07  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Don't compile methods with sharing enabled if their
	classes are disabled for sharing.

2007-12-06  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg: Add a missing sign extension to the GETCHR and array access
	opcodes. Fixes #346563.

	* objects.cs: Add a new test.

	* aot-compiler.c (emit_method_code): Put back an #ifdef which is needed.

	* mini-<ARCH>.h mini.c aot-compiler.c aot-runtime.c: Get rid of the
	HAVE_PIC_AOT define and use AOT_SUPPORTED instead.

2007-12-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.h mini-arm.c: Add support for the common vtable trampoline.

2007-12-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_emit_exceptions): Avoid uninitialized memory in the
	code stream.

2007-12-02  Zoltan Varga  <vargaz@gmail.com>

	* patch-info.h (PATCH_INFO): Add DELEGATE_TRAMPOLINE.

	* mini.c aot-compiler.c aot-runtime.c: Implement the delegate creation 
	optimization in the AOT case.
	
2007-11-30  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime (mono_aot_get_method_from_vt_slot): Add support for multi-byte method ref encodings.
	
	* aot-runtime.c (decode_klass_ref): Implement decoding of generic instances.

	* aot-compiler.c (encode_klass_ref): Implement proper encoding of generic instances.

	* mini.c (mono_method_to_ir): Optimize the common ldftn+create delegate combination.

	* mini-trampolines.c (mono_delegate_trampoline): Add some code to handle the case when the delegate
	is created by the inlined delegate ctor.

	* mini-x86.c (mono_arch_output_basic_block): Unify div/rem code and handle the case when sreg2 is EDX.	

	* mini.c (mono_jit_compile_method_inner): Replace calls to delegate invoke with the trampoline here too.

2007-11-29  Zoltan Varga  <vargaz@gmail.com>

	* cpu-x86.md: Fix the length of ckfinite.

2007-11-28  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_output_basic_block): Unify div/rem code and handle the case when sreg2 is EDX.
	
	* mini-x86.c (mono_arch_output_basic_block): Clean up the fp stack properly in CKFINITE.
	(mono_arch_output_basic_block): Get rid of unused last_ins and last_offset.

	* mini-x86.c (mono_arch_output_basic_block): Add some micro optimizations.

	* mini-x86.c inssel-x86.brg cpu-x86.md: Move the implementation of the 
	OP_START_HANDLER/OP_ENDFINALLY/OP_ENDFILTER opcodes to mini-x86.c.

2007-11-28  Martin Baulig  <martin@ximian.com>

	* mini-x86.c
	(mono_arch_get_delegate_invoke_impl): Call mono_debug_add_delegate_trampoline()
	after creating the trampoline.

2007-11-27  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_aot_module): Check runtime version if needed.

	* aot-compiler.c: Add bind-to-runtime-version for producing AOT files which only load into a runtime with
	the same version.

	* generic-sharing.c (mono_helper_get_rgctx_other_ptr): Change the signature to take the calling class
	instead of the calling method to help AOT.

	* mini.c (get_runtime_generic_context_other_ptr): Update after the change.

2007-11-26  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_init_vtable): Simplify this if MONO_ARCH_COMMON_VTABLE_TRAMPOLINE
	is defined.

2007-11-23  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_class_name_table): Properly encode generic class names.
	
	* aot-compiler.c (compile_method): Correct check for generic method definitions.
	(encode_method_ref): No need to handle generic method definitions specially.

	* mini.h (MONO_AOT_FILE_VERSION): Bump this.

	* aot-runtime.c (decode_klass_ref): Clean this up and rename from 
	decode_klass_info.

	* aot-compiler.c (encode_klass_ref): Clean this up and rename from
	encode_klass_info.
	(compile_method): Enable generic sharing.

2007-11-22  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (get_runtime_generic_context_other_ptr): Disable AOT here.
	(mini_method_compile): Add preliminary support for AOTing shared generic code.

	* aot-compiler.c (compile_method): Add preliminary support for AOTing shared
	generic code.

	* mini-trampolines.c: Fix a warning.

	* mini.c (get_runtime_generic_context_other_ptr): Use NEW_METHODCONST instead of
	NEW_PCONST.
	(mono_method_to_ir): Use NEW_DOMAINCONST in one place.
	(generic_class_is_reference_type): Remove unused function.

	* mini-trampolines.c (mono_magic_trampoline): Avoid loading metadata if possible
	in the generic vtable trampoline case.

	* aot-runtime.c (mono_aot_init_vtable): Use the generic vtable trampoline.
	
	* aot-runtime.c (mono_aot_get_method_from_vt_slot): New helper function to
	return an AOT method based on a vtable slot.

	* aot-compiler.c (compile_method): Avoid AOTing synchronized methods for now.

	* mini.c (mini_get_vtable_trampoline): Export this.

2007-11-22  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h
	(MonoDebuggerInfo): Move `debugger_version' up.

2007-11-22  Martin Baulig  <martin@ximian.com>

	* mini-amd64.c
	(mono_arch_get_delegate_invoke_impl): Call mono_debug_add_delegate_trampoline().

	* mini-trampolines.c
	(mono_delegate_trampoline): Call mono_debugger_trampoline_compiled()
	after compiling the method.

2007-11-20  Martin Baulig  <martin@ximian.com>

	* debug-mini.c
	(mono_debugger_insert_method_breakpoint): Moved into mono-debug-debugger.c.
	(mono_debugger_remove_breakpoint): Likewise.
	(mono_debugger_check_breakpoints): Likewise.

	* debug-debugger.c: Implement the new breakpoint interface here.

2007-11-18  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Unify the implementation of
	CEE_CONV_I1/SEXT_I1 and I2 since they are the same.

	* mini-x86.c (mono_arch_output_basic_block): Ditto.	

2007-11-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Fix a typo.

	* mini-x86.c (mono_arch_get_inst_for_method): Remove code which is now in
	mini.c.

	* mini-ia64.c (mono_arch_get_inst_for_method): Remove code which is now in
	mini.c.

	* mini-amd64.c (mono_arch_compute_omit_fp): Disable fp elimination for methods
	returning a vtype in a register.

	* mini.c (mini_get_inst_for_method): Move the handling of the atomic operations
	here from the arch specific code.

	* mini-amd64.c (mono_arch_get_inst_for_method): Remove code which is now in
	mini.c.

	* mini-amd64.c (mono_arch_output_basic_block): Add some micro optimizations.
	(mono_arch_emit_prolog): Increment maximum prolog size.

	* mini-amd64.c inssel-amd64.brg cpu-amd64.md: Move the implementation of the
	START_HANDLER/ENDFINALLY/ENDFILTER opcodes to mini-amd64.c.

	* mini-x86.c (get_call_info): Receive a MonoCompile instead of a 
	MonoGenericSharingContext.

	* mini-ia64.c (get_call_info): Receive a MonoCompile instead of a 
	MonoGenericSharingContext. Allocate memory from the cfg mempool.

2007-11-15  Mark Probst  <mark.probst@gmail.com>

	* mini.c, mini.h, generic-sharing.c: Functions for producing code
	which extract fields out of the runtime generic context.  Full
	sharing of the NEWARR opcode.

Thu Nov 15 14:20:21 CET 2007 Paolo Molaro <lupus@ximian.com>

	* abcremoval.c, mini.c, ssa.c, ssapre.c: updated to implement
	--enable-minimal=ssa.

2007-11-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_delegate_trampoline): Update after 
	mono_marshal_get_delegate_invoke () signature change.

2007-11-13  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Removed the shared context in favor of the generic
	sharing context.  Allocate the MonoJitInfo structure with room for
	the generic sharing context if it's needed.

	* mini.h: Remove MonoGenericSharingContext declaration.  It's in
	domain-internals.h now.

	* mini-x86.c: Pass the generic sharing context to get_call_info ().

	* generic-sharing.c: Several changes for working without a shared
	context and instead operating on open types instead.

2007-11-12  David S. Miller  <davem@davemloft.net>

       * inssel-sparc.brg: Fix double instruction emit.

2007-11-12  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_runtime_invoke): Avoid trying to compile the Array 
	Get/Set/Address methods.
	
	* mini.c debug-debugger.c mini-trampolines.c: Update after 
	mono_marshal_get_delegate_invoke signature change.

2007-11-12  Rodrigo Kumpera  <rkumpera@novell.com>

	* cpu-arm.md: Increase the max size of OP_THROW to 24 bytes.
	This can happens with dynamic methods. Fixes the other bug in #322722.

2007-11-12  Rodrigo Kumpera  <rkumpera@novell.com>

	* tramp-arm.c (mono_arch_patch_callsite): Support patching
	BX call sequence.

	* mini-arm.c (arm_patch): Implement patching of BX call
	sequence. Fixes one of the bugs in #322722.

2007-11-03  David S. Miller  <davem@huronp11.davemloft.net>

       * mini-sparc.c (mono_arch_flush_icache): Make more efficient
       under Linux.  We only need to flush every 32-byte cache line.	

2007-11-07  Massimiliano Mantione  <massi@ximian.com>

	* mini.c:
	move_basic_block_to_end: Add branches when needed, eventually creating
	a new BB.
	optimize_branches: added a parameter that tells if it's ok to create
	new BBs (doing is "df_visit" has been called is (IMHO) a nightmare),
	and avoid calling move_basic_block_to_end when it's not ok.
	Fixes bug 318677.

2007-11-07  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Abort inlining call to InitializeArray if something
	looks wrong.  Let the icall handle it, which now has proper safety
	checks.

2007-11-05  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mono_spill_call): add support for soft-float.

	* mini.c (mono_method_to_ir): add support for soft-float
	to inlined functions that return float.

	* mini.c (mono_method_to_ir): add support for soft-float
	to cee_stsfld opcode on float fields.

2007-11-05  Geoff Norton  <gnorton@novell.com>

	* mini-x86.h: Fix the structure access for X86 Leopard.


2007-11-05  Martin Baulig  <martin@ximian.com>

	* mini-trampolines.c
	(mono_magic_trampoline): Call mono_debugger_trampoline_compiled()
	after compiling the method to notify the debugger.

2007-11-05  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h (MonoDebuggerInfo): Use the new breakpoint tables.

2007-11-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (EMIT_COND_SYSTEM_EXCEPTION_GENERAL): Applied patch from
	David Miller <davem@davemloft.net>. Allow larger offsets in branches.

2007-11-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_prolog): Check the domain as well for
	native-to-managed wrappers.
	
2007-11-01  Geoff Norton  <gnorton@novell.com>

	* mini-ppc.h, mini-x86.h:  Handle Leopards renaming of some structure 
	members.

Wed Oct 31 20:23:14 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini-x86.c: when getting back from unmanaged code
	to managed via a marshaled delegate we also need to set the
	right domain.

Wed Oct 31 19:53:33 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-amd64.c, mini-amd64.h, tramp-amd64.c: breakpoint table support
	for amd64.

Wed Oct 31 19:29:30 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h, mini-x86, tramp-x86.c, mini-x86.h: added API to
	let the debugger or other external agents to tell the JIT when
	a sw breakpoint has been inserted in the code that the JIT needs
	to be able to inspect.

2007-10-31  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h
	(MonoDebuggerInfo): Remove `runtime_class_init'.

2007-10-30  Martin Baulig  <martin@ximian.com>

	* debug-mini.h
	(mono_debugger_thread_created): Added `MonoThread *' argument.
	(mono_debugger_extended_notification): New public method.
	(mono_debugger_trampoline_compiled): New public method.

	* debug-mini.c
	(MonoDebuggerThreadInfo): Added `thread' and
	`extended_notifications' fields.

	* debug-debugger.c
	(debugger_executable_code_buffer): New static variable.

	* debug-debugger.h
	(MonoDebuggerInfo): Added `executable_code_buffer',
	`executable_code_buffer_size', `breakpoint_info_area',
	`breakpoint_table' and `breakpoint_table_size'.

2007-10-26  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-arm.c (mono_arch_build_imt_thunk): Take the advantage
	that IP  either is an unused value or the vtable pointer. IMT 
	calls use vtable + offset now. Reduced by almost half the size
	of IMT entries.

2007-10-26  Jonathan Chambers <joncham@gmail.com>

	* mini-amd64.c: Begin Win64 port. Use AMD64_ARG_REG#
	defines to access param registers. Replace long usage with
	gsize as sizeof(long) != sizeof(void*) on Win64.

	* mini-amd64.h: Add %rdi and %rsi to MonoLMF structure
	on Win64. Fix intrinsic, use _AddressOfReturnAddress
	instead of non-existant _GetAddressOfReturnAddress.

	* tramp-amd64.c: Use AMD64_ARG_REG#	defines to access 
	param registers. Save/restore %rdi and %rsi in MonoLMF.

	* exceptions-amd64.c: Use AMD64_ARG_REG# defines to access 
	param registers. Modify (throw_exception) signature to take 
	%rdi and %rsi on Win64. 

	Code is contributed under MIT/X11 license.

Thu Oct 25 23:06:58 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* helpers.c: unlink debugging output files.

2007-10-25  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Move mono_create_ftnptr () to object.c.

2007-10-24  Rodrigo Kumpera  <rkumpera@novell.com>

	* helpers.c (mono_disassemble_code): MonoCompile parameter is now
	optional. This function can now be used to disassemble code generated
	outside the JIT such as trampolines and IMT thunks.

	* mini-arm.h: defined MONO_ARCH_HAVE_IMT.

	* mini-arm.c (decode_vcall_slot_from_ldr): added, extract the
	vtable pointer from a ldr instruction.

	* mini-arm.c (mono_arch_get_vcall_slot_addr): support the
	new IMT call sequence.

	* mini-arm.c (mono_arch_output_basic_block): emit the IMT
	call sequence for interface invocations.

	* mini-arm.c (mono_arch_emit_imt_argument): added, required
	for imt support. This function is empty since IMT on ARM requires no
	special handling on the IR side.

	* mini-arm.c (mono_arch_find_imt_method): added, required for
	imt support.

	* mini-arm.c (mono_arch_find_this_argument): added, required
	for imt support.

	* mini-arm.c (arm_emit_value_and_patch_ldr): added, patches
	a ldr instruction to load a value stored in the code stream.

	* mini-arm.c (mono_arch_build_imt_thunk):added, required
	for imt support.


2007-10-23  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_init): Install the jump trampoline callback.

Tue Oct 23 17:07:52 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-trampolines.c: handle synchronized methods with the common
	vtable trampoline (bug #335601).

2007-10-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.h mini-amd64.c: Add support for the common vtable trampoline.

	* inssel.brg (mini_emit_virtual_call): Fix the computation of ins->inst_offset on
	64 bit platforms.

	* mini-ia64.h mini-ia64.c: Add support for IMT.

	* mini-x86.c (mono_arch_emit_prolog): Increase the size allocated for the
	prolog. Fixes #331958.

2007-10-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.h mini-sparc.c: Add support for the common vtable trampoline.

Mon Oct 15 11:18:52 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, mini-ppc.h: ppc support for the common vtable
	trampoline.

Mon Oct 15 10:41:27 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-amd64.c, mini-amd64.h: amd64 support for the common vtable
	trampoline.

Mon Oct 15 10:39:26 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c, mini-x86.h: x86 support for the common vtable
	trampoline.

Mon Oct 15 10:37:15 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-trampolines.c: changed the magic rampoline to understand
	the common vtable trampoline method: the method to invoke is
	determined by the vtable displacement of the call.

Mon Oct 15 10:35:12 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h: register the common vtable trampoline if the
	architecture supports it.

Mon Oct 15 09:50:52 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* cpu-amd64.md: use the correct max length for tls_get.

2007-10-14  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Use mini_get_class in CEE_LDELEM_ANY and
	CEE_STELEM_ANY. Fixes #333696.

Thu Oct 11 18:04:29 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* exceptions-x86.c: provide more graceful handling of the case where
	we followed a bogus function pointer from managed code (bug #332866).

2007-10-11  Mark Probst  <mark.probst@gmail.com>

	* mini.h, mini.c: Introduced the MonoGenericSharingContext, which
	replaces the generic_shared flag and will carry more information
	in the future.

	* generic-sharing.c: Added mini_type_stack_size() which allows
	allows open types if given a generic sharing context.
	mini_get_basic_type_from_generic() takes a
	MonoGenericSharingContext* instead of a MonoCompile* now.

	* mini-alpha.c, mini-amd64.c, mini-arm.c, mini-hppa.c,
	mini-ia64.c, mini-mips.c, mini-ppc.c, mini-s390.c, mini-s390x.c,
	mini-sparc.c, mini-x86.c: Trivial changes required by the two
	changes above.  Just passing arguments through to the right
	places.

Wed Oct 10 19:44:42 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: unify the call emission to emit_code_seq().

Wed Oct 10 13:05:46 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* tramp-arm.c: reduced the trampoline size.

2007-10-10  Mark Probst  <mark.probst@gmail.com>

	* generic-sharing.c, mini.h, mini-amd64.c, mini-x86.c: Moved type
	variable handling out of arch-specific code.

Wed Oct 10 10:49:28 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: implemented fast delegate dispatch.

2007-10-09  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_compute_omit_fp): Add more checks to ensure
	that fp elimination is turned off if the space required by locals is too
	big. Fixes #331958.

Tue Oct 9 21:01:03 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, mini-arm.c, mini-arm.h, tramp-arm.c: ported
	ARM to the new style trampoline.

2007-10-09  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c: Rework the specific trampoline code to make it smaller.

	* mini-amd64.h mini-amd64.c: Export amd64_patch as mono_amd64_patch.

2007-10-09  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h
	(MonoDebuggerMetadataInfo): Added `field_info_type_offset' and
	`field_info_offset_offset'.	

Tue Oct 9 09:47:51 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, mini-ppc.h, mini-ops.h, inssel-ppc.brg, cpu-g4.md:
	removed more internal usage of the r11 register and made it available
	to the register allocator.

2007-10-08  Mark Probst  <mark.probst@gmail.com>

	* mini.c, mini-amd64.c, mini-x86.c: Allow open generic contexts
	when sharing generics and treat type variables as references.

Mon Oct 8 10:55:38 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: started removing the internal uses of register r11
	to eventually allow the register allocator to manage it as an
	additional available register.

Mon Oct 8 14:25:39 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* tramp-amd64.c: fixed memory corruption in the trampoline generation.

Mon Oct 8 12:06:33 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* tramp-ppc.c, tramp-x86.c: reduce the alignment requirements for
	specific trampolines as they are not performance critical as a jump
	target (maybe align as before only for AOT code?). This saves about
	200 KB of native code on x86 for monodevelop startup.

Mon Oct 8 10:04:40 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* tramp-ppc.c: reduce the size of the trampolines, saves 160KB on
	monodevelop startup.

2007-10-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (mono_arch_get_vcall_slot_addr): Allow signed displacements.

	* mini-sparc.h mini-sparc.c: Implement IMT support.

	* tramp-sparc.c (mono_arch_create_trampoline_code): Rework the trampoline code so
	its smaller and doesn't clobber sparc_g1.

	* mini-sparc.c (mono_arch_get_vcall_slot_addr): Update after trampoline changes.

Fri Oct 5 18:28:11 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: optimized the size of the IMT thunks a bit.

Fri Oct 5 18:08:30 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: implemented fast delegate invocation.

Fri Oct 5 00:01:05 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.h, mini-ppc.c: IMT support for the PPC architecture.

Thu Oct 4 22:04:49 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, mini-ppc.h, tramp-ppc.c, Makefile.am: port the PPC
	code to the new style trampoline in preparation for IMT support.

Thu Oct 4 19:01:59 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, tramp-ppc.c: don't use r13 as it's used by the PPC EABI
	systems already. This also reduces the specific trampiline sizes and
	prepares for the use of r12 as the IMT identifier register.

Thu Oct 4 16:38:27 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-mips.h: endianess fix (simplified from a patch by
	Thomas Kunze <thommy@tabao.de>, bug #323737).

Thu Oct 4 14:43:49 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c, mini-ppc.h: refactor to use macros
	to access ucontext fields and enable netbsd support
	(partially from Magnus Henoch <mange@freemail.hu>).

Thu Oct 4 12:35:27 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* genmdesc.pl: patch from Henryk Plötz <henryk@openmoko.org> to
	use the preprocessor from the CPP env var if it is set.

Wed Oct 3 17:11:38 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-trampolines.c: fixed an assertion and moved it earlier in the
	code, before interface_offset gets used.

2007-10-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_convert_imt_slot_to_vtable_slot): Call 
	mono_class_setup_vtable () before accessing klass->vtable.

2007-10-01  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (get_plt_index): Rework the handling of wrappers to be not so
	hackish.

Mon Oct 1 15:00:27 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini-trampolines.c, mini.h: enable the lazy filling of the
	IMT slots (this saves hundreds of KB of memory in programs like
	IronPython and Monodevelop).

Mon Oct 1 14:44:19 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: print the delegate counter.

Mon Oct 1 14:36:50 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c: make it easier to enable the debugging code for IMT
	slots.

2007-09-28  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h
	(MonoDebuggerMetadataInfo): Add `klass_image_offset',
	`mono_method_klass_offset' and `mono_method_token_offset'.

2007-09-20  Mark Probst  <mark.probst@gmail.com>

	* mini.c: First generics sharing implementation.  Can only share
	in very simple cases.  If sharing doesn't work it falls back to
	dedicated compilation.

	* mini.h: Flag in MonoCompile to specify whether generic
	compilation is shared.  Flags enum for marking which generic inst
	of a context is used.  Prototypes for helper functions.

	* generic-sharing.c: Helper functions for generic method sharing.

	* optflags-def.h: Optimization flag (gshared) for enabling generic
	method sharing added.

	* Makefile.am: generic-sharing.c added.

2007-09-19 Daniel Nauck <dna@mono-project.de>

	* mini.c (mono_thread_abort): fixed typo in r86014. It should be '==' instead of '!='.

2007-09-19  Massimiliano Mantione  <massi@ximian.com>
	* mini.c (mono_thread_abort): Correctly handle ThreadAbortException,
	fixes bug 325507.

2007-09-19  Martin Baulig  <martin@ximian.com>

	* mini.c (mini_cleanup): Only call mono_debugger_cleanup() here;
	mono_debug_cleanup() is now part of mono_cleanup().

2007-09-18  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_main): Fix a warning.

2007-09-17  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Optimize various parts when processing large assemblies.
	Fixes ##325568.

	* mini.c (mono_patch_info_hash): Improve hash function.

2007-09-14  Jonathan Chambers <joncham@gmail.com>

	* mini-exceptions.c: Add HAVE_UNISTD_H check around include.
	
	Code is contributed under MIT/X11 license.

2007-09-14  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_init): Fix a leak.

	* debug-mini.c (mono_debug_free_method_jit_info): Fix a leak.

Fri Sep 14 12:53:13 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: redirect string.InternalAllocStr() to the managed allocator.

2007-09-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_find_imt_method): Add support for AOT code.

2007-09-13  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am generics-variant-types.2.il generics.cs: Add some generics
	variance tests.

	* inssel.brg: Reorganize the isinst/castclass code to reduce code duplication.

	* mini.c (handle_alloc): Enable managed allocators in AOT code.

	* aot-compiler.c (encode_patch): Add support for MONO_WRAPPER_ALLOC.

	* aot-runtime.c (decode_patch_info): Ditto.

2007-09-12  Jonathan Chambers <joncham@gmail.com>

	* mini-x86.c (mono_arch_get_delegate_invoke_impl): Implement
	static case. Cache delegates in architecture specific code, 
	based on number of parameters.
	
	* mini-amd64.c (mono_arch_get_delegate_invoke_impl): Cache delegates
	in architecture specific code, based on number of parameters.
	
	* mini-trampolines.c (mono_delegate_trampoline): Architecture specific 
	caching happen in architecture specific code now.
	
	Code is contributed under MIT/X11 license.

2007-09-12  Jonathan Chambers <joncham@gmail.com>

	* mini.h, mini.c, mini-x86.c, mini-amd64.c, mini-hppa.c, mini-mips.c,
	mini-s390x.c, mini-arm.c, mini-ia64.c, mini-sparc.c, mini-ppc.c, mini-alpha.c,
	mini-s390.c: Add mono_arch_init and mono_arch_cleanup methods.

	Code is contributed under MIT/X11 license.

2007-05-15  Massimiliano Mantione  <massi@ximian.com>
	* mini.c: (mono_thread_abort) Fixed bug #82416.

Tue Sep 11 16:15:53 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.: hook the new managed GC allocation feature into the JIT.

Tue Sep 11 16:14:16 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: implementation for the new runtime tls opcode.

2007-09-11  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h
	(MonoDebuggerMetadataInfo): Add `mono_method_flags_offset' and
	`mono_method_inflated_offset'.

2007-09-07  Zoltan Varga  <vargaz@gmail.com>

	* driver.c mini.h mini.c: Add a new devel command line option for injecting
	async exceptions into a method.

	* mini-amd64.h mini-amd64.c: Implement injecting of async exceptions for the
	purpose of testing whenever the unwinder works at every instruction.

Thu Sep 6 12:42:14 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: check accessibility of method used in ldftn (fixes
	bug #82635).

2007-09-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Fix a warning.

	* inssel.brg: Fix a warning.

2007-09-03  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c: `MONO_DEBUGGER_EVENT_INITIALIZE_MANAGED_CODE'
	now takes the `main_method' as argument.

2007-09-02  Zoltan Varga  <vargaz@gmail.com>

	* cpu-sparc.md (endfilter): Add missing src1:i argument.

2007-08-30  Jonathan Chambers <joncham@gmail.com>

	* driver.c: include the cil-coff.h header on Windows.
	
	Code is contributed under MIT/X11 license.

Thu Aug 30 16:17:23 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, driver.c: don't include the cil-coff.h header.

Thu Aug 30 14:50:53 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: flag places that needs fixes fo soft-float support.

Wed Aug 29 18:26:20 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h, inssel-float.brg: fix soft-float constant loads on big
	endian systems (partially from Dean Jenkins, bug #81924).

2007-08-28  Mark Probst  <mark.probst@gmail.com>

	* mini.c (check_linkdemand): Remove embedded reference object in
	call to LinkDemandSecurityException.
	(mono_jit_compile_method_inner): Call LinkDemandSecurityException
	with an IntPtr instead of a reference object.

2007-08-28  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (handle_initobj): Handle alignment properly.

	* inssel.brg (mini_emit_memset): Ditto.	

	* inssel.brg (mini_emit_memcpy): Ditto.	

	* inssel-sparc.brg: Ditto.		

	* mini.h mini.c inssel-*.brg: Pass alignment information to OP_MEMCPY/MEMSET.

2007-08-26  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_exception_internal): Skip the first frame for
	exceptions raised in unmanaged code. Fixes part of #82594.

2007-08-24  Mark Probst  <mark.probst@gmail.com>

	* mini.c (mono_method_to_ir), declsec.c
	(mono_declsec_linkdemand_aptc): Fixed custom attr leaks.

2007-08-22  Martin Baulig  <martin@ximian.com>

	* debug-mini.h
	(MonoDebuggerThreadInfo): New typedef.
	(mono_debugger_thread_table): New global variable.
	(mono_debugger_thread_created): New public function.
	(mono_debugger_thread_cleanup): New public function.

	* debug-debugger.h
	(MonoDebuggerInfo):
	- removed `get_current_thread' and `lookup_assembly'.
	- removed `data_table'.
	- added `thread_table'.

	* mini.c
	(mono_thread_start_cb): Call mono_debugger_thread_created().
	(mono_thread_attach_cb): Likewise.
	(mini_thread_cleanup): Call mono_debugger_thread_cleanup().
	(mini_cleanup): Move mono_debug_cleanup() down, after free'ing the
	initial domain.

	* driver.c (mono_main): Move mono_debug_init() up, before calling
	mini_init(); mono_debug_init_1() and mono_debug_init_2() are gone.

Tue Aug 21 16:40:04 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c, inssel-x86.brg: group multiple stack adjustments
	together when passing several arguments of type double (gives a small
	speedup and saves a few bytes of generated code).

2007-08-20  Jb Evain  <jbevain@novell.com>

	* mini.c (mono_method_to_ir): fix leak on InvalidProgramException.

2007-08-20  Jb Evain  <jbevain@novell.com>

	* mini.c (mono_method_to_ir): throw MethodAccessException
	and FieldAccessException instead of InvalidProgramException.

2007-08-20  Mark Probst  <mark.probst@gmail.com>

	* mini.c: CoreCLR security checks.

	* mini.h: Removed MonoSecurityMode (moved to
	metadata/security-manager.h) and mono_security_mode global var
	(replaced by set/get functions in security-manager.h).

	* driver.c: Added "core-clr-test" security mode for testing.  Used
	set-function for setting security mode.

2007-08-17  Mark Probst  <mark.probst@gmail.com>

	* mini.c: MonoJitInfo's are freed hazardously now.  Statistics for
	the new jit_info_table.

	* driver.c: Test code for the new jit_info_table (enabled by the
	define MONO_JIT_INFO_TABLE_TEST).

2007-08-14  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_nullify_class_init_trampoline): Fix
	detection of call <REG> instruction sequence. Fixes build on freebsd.

2007-08-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c: Fix a warning.

2007-08-11  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c (mono_arch_handle_altstack_exception): Enable the new
	stack overflow handling code on amd64 too.

	* mini-exceptions.c (mono_setup_altstack): Make this use 
	mono_thread_get_stack_bounds ().

	* mini-x86.h: Disable sigaltstack on solaris x86.

2007-08-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_setup_altstack): Enable this to work on solaris x86.

2007-08-10  Geoff Norton  <gnorton@customerdna.com>

	* tramp-x86.c: Remove some unneeded alignment changes on Apple.  Fixes #82387.

2007-08-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_print_thread_dump): Enable this on amd64 too.

	* mini-amd64.h (MONO_INIT_CONTEXT_FROM_FUNC): Fix a warning.

2007-08-03  Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c (add_general): Adjust offset calculation to take into account of rounding up
	due to alignment.

Thu Aug 2 17:36:22 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: avoid an invalid encoding of unsigned right shift by 0
	to be emitted (bug #82281).

2007-08-01  Martin Baulig  <martin@ximian.com>

	Merged the `debugger-dublin' branch.

	* debug-debugger.h (MonoDebuggerInfo):
	Removed the `old_*' compatibility entries.
	Added `debugger_version' and `data_table'.
	Renamed `get_method_addr_or_bpt' -> `insert_breakpoint'.
	Renamed `remove_method_breakpoint' -> `remove_breakpoint'.

	* debug-mini.c
	(MiniDebugMethodBreakpointInfo): Add `address_list'.
	(mono_debugger_check_breakpoints): Take a `MonoDebugMethodAddress *'
	instead of a `gconstpointer'.
	(mono_debugger_insert_method_breakpoint): Return a
	`MonoDebugMethodAddressList *'.

2007-06-28  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h (MonoDebuggerInfo): Added `debugger_version'.

2007-08-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.h (MONO_INIT_CONTEXT_FROM_FUNC): Avoid using 
	__builtin_frame_address () since it is broken on older gcc versions.

Tue Jul 31 17:34:42 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h, mini-exceptions.c: added a bit of documentation
	on the stack overflow handling and made the managed stack overflows
	catchable in most cases using soft guard pages.
	* exceptions-x86.c: added code to restore the protection in the soft
	guard pages at the end of exception handling.

2007-07-31  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (SIG_HANDLER_SIGNATURE): Fix a warning.

Mon Jul 30 17:43:13 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c, mini-ppc.h: arch-specific stack overflow
	exception handling.

Mon Jul 30 17:38:13 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-alpha.h, mini-ia64.h, mini-sparc.h: disable the altstack
	signal handling support until it has been ported to the new mechanism.
	* mini.c: fixed stack overflow detection and use the new
	architecture code  to handle signals on the altstack.

Mon Jul 30 17:33:02 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* exceptions-amd64.c, mini-amd64.h: amd64 code to handle
	stack overflows on the alt stack.

Mon Jul 30 17:29:56 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* exceptions-x86.c, mini-x86.h, mini.h: new code to handle
	stack overflows on the alt stack.

Mon Jul 30 11:50:06 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c: cleanup preparing for altstack support.

Mon Jul 30 11:31:24 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* exceptions-arm.c: cleanup preparing for altstack support.

2007-07-27  Mark Probst  <mark.probst@gmail.com>

	* mini.c (print_jit_stats): Output hazard pointer stats.

2007-07-26  Mark Probst  <mark.probst@gmail.com>

	* driver.c, mini.c: Replaced security mode flags with a single
	enum variable.

Thu Jul 26 20:12:12 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini-exceptions.c: cleanup the sigaltstack code.

2007-07-25  Mark Probst  <mark.probst@gmail.com>

	* mini.c, mini.h, driver.c (mono_main): Added command-line flag
	(which doesn't do anything yet) for activating Core CLR
	(Silverlight) security.

Tue Jul 24 21:16:17 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-codegen.c: work around a possible gcc bug on arm.

Tue Jul 24 17:20:19 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* driver.c, mini-x86.h, mini-amd64.h: print a nice error
	message for platforms that don't support AOT compilation.

Mon Jul 23 10:29:29 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini.c, driver.c: temporary smcs hack.

Mon Jul 23 09:29:34 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-arm.h, mini-arm.c: arm EABI fixes.

2007-07-22  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c (mono_arch_find_jit_info): Handle the lmf->method == NULL
	case.

	* tramp-x86.c (mono_arch_create_trampoline_code): Only set lmf->method for
	trampolines taking a method argument.

	* mini-x86.h (MonoLMF): Add an 'esp' field plus comments.

	* mini-x86.c (mono_arch_emit_prolog): Update after changes to the LMF structure.
	* tramp-x86.c (mono_arch_create_trampoline_code): Ditto.

	* exceptions-x86.c (mono_arch_get_jit_info): Properly clean up the stack after
	JIT compilation throws an exception. Fixes #82050.

2007-07-19  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Removed the MonoLoaderErrorKind enum and replaced it
	with the MONO_EXCEPTION_ defines.

2007-07-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_find_imt_method): Handle mov reg,IMM64 case. Fixes
	#82117.
	
	* mini-amd64.c (mono_arch_find_imt_method): Add some debug code to help find out
	the cause of an assertion.

Mon Jul 16 19:31:21 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, jit-icalls.c: mono_get_inflated_method() is obsolete,
	removed.

2007-07-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_build_imt_thunk): Remove the non-32bit MonoMethod
	assert. Should fix #82103.

2007-07-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_jit_walk_stack_from_ctx): Use MONO_CONTEXT_GET_SP ()
	here too. Fixes #82095.

	* mini-amd64.c (mono_arch_build_imt_thunk): Add support for non-32bit MonoMethod
	addresses.

	* mini-amd64.c (mono_arch_get_vcall_slot_addr): Add a couple asserts.

	* mini-amd64.h: Enable IMT for amd64.
	
	* mini-amd64.c (mono_arch_build_imt_thunk): Optimize IMT thunk size.

2007-07-12  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_get_vcall_slot_addr): Add support for IMT call sequences.

2007-07-12  Mark Probst  <mark.probst@gmail.com>

	* mini.c (check_linkdemand, mono_method_to_ir): Abort compilation
	as soon as check_linkdemand sets an exception_type.

Thu Jul 12 12:18:22 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c: fixed offsets for IMT call sequence.
	* mini-x86.h: enable IMT again.

2007-07-11  Zoltan Varga  <vargaz@gmail.com>

	* trace.c (mono_trace_enter_method): Decode MonoType too.

	* mini-amd64.c (mono_arch_get_vcall_slot_addr): Handle signed displacements too.

	* mini.h mini-x86.h mini-trampolines.c: Change the signature of mono_arch_find_imt_method () to pass the calling code address too.

	* mini-amd64.c: Add preliminary IMT implementation.
	
Wed Jul 11 18:21:30 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c: adjusted mono_arch_get_vcall_slot_addr () to
	understand the new IMT-base interface invocation (thanks to
	Daniel Nauck for the report and the remote debugging session).

Wed Jul 11 14:54:39 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c: size and speed optimizations for the IMT bsearch.

2007-07-11  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (aotcheck): Make this actually use the AOTed code.

Wed Jul 11 12:41:32 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-trampolines.c: implement AOT IMT support.
	* mini-x86.h: enable IMT support for wider testing.

2007-07-10  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg (emit_imt_argument): Add aot support here.

	* aot-runtime.c (decode_patch_info): Fix reading of MONO_PATCH_INFO_METHOD.

Tue Jul 10 17:50:58 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c, mini-x86.h, tramp-x86.c: x86 arch-specific changes
	of the IMT implementation, partially from massi, with my
	implementation of the bsearch sequence. Disabled by default until
	the AOT code is implemented.

2007-07-10  Zoltan Varga  <vargaz@gmail.com>

	* cpu-x86.md: The source argument of sext_i1/i2 must by a byte reg.

	* inssel-x86.brg: Add reg:ldind.i1(regvar) rules. Fixes #82056.

Tue Jul 10 17:33:12 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* inssel.brg, mini.c, mini.h, mini-trampolines.c:
	arch-independent IMT JIT code from Massimiliano
	Mantione (massi@ximian.com) with small cleanups from me.

Tue Jul 10 13:07:24 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: fix svn invocation to get the svn revision to be
	independent of the local language (build fix).

2007-07-09  Mark Probst  <mark.probst@gmail.com>

	* mini.c (inline_method): Reset cfg->exception_type if the
	inlining is aborted.  Fixes: 82049.

Mon Jul 9 17:26:47 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: remove assert from exception handling code when exception_ptr
	is not set.

2007-07-05  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_codegen): Add an assert.

	* mini-x86.c (mono_arch_emit_prolog): Allocate space for the profiler method 
	enter and leave code.
	* mini-amd64.c (mono_arch_emit_prolog): Likewise.

Thu Jul 5 20:12:52 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: fixed memory corruption for localloc(0)
	(bug #81852).

2007-07-05  Zoltan Varga  <vargaz@gmail.com>
	
	* mini.c: Fix warnings.

Wed Jul 4 15:30:36 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* optflags-def.h, mini-x86.c: added sse2 optimization flag and use it
	to emit better double->int conversions.

Tue Jul 3 19:42:16 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: the provided Min/Max optimizations are valid for unisgned
	ints.

2007-07-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (can_access_method, can_access_field): methods moved to metadata/class.c and renamed to mono_method_can_access_method and mono_method_can_acesss_field

2007-06-28  Miguel de Icaza  <miguel@novell.com>

	* mini.c (mono_running_on_valgrind): Add support for reporting the
	method and  its boundaries to valgrind.

2007-06-28  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h (MonoDebuggerInfo): Added `debugger_version'.

2007-06-25  Zoltan Varga  <vargaz@gmail.com>

	* ssa.c (visit_inst): Add support for OP_BR. Fixes #81946.

	* generic.2.cs: Add new test case.

2007-06-25  Martin Baulig  <martin@ximian.com>

	Merged the `debugger-dublin' branch.

	* debug-mini.c
	(mono_debugger_insert_method_breakpoint): New public method.
	(mono_debugger_remove_method_breakpoint): Likewise.
	(mono_debugger_check_breakpoints): New static method.
	(mono_debug_close_method): Call mono_debugger_check_breakpoints().

	* debug-debugger.h (MonoDebuggerInfo):
	Renamed (to keep backward compatibility in the vtable):
	`insert_breakpoint' -> `old_insert_breakpoint'.
	`remove_breakpoint' -> `old_remove_breakpoint'.
	`create_string' -> `old_create_string'.
	`lookup_class' -> `old_lookup_class'.
	`lookup_type' -> removed; changed into a dummy field.
	`lookup_assembly' -> `old_lookup_assembly'.
	Added (same functionality, but different signature):
	`create_string', `lookup_class', `lookup_assembly'
	Added new:
	`get_method_addr_or_bpt', `remove_method_breakpoint',
	`runtime_class_init'.

	* debug-debugger.c: Merged the `debugger-dublin' branch.

2007-06-23  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (peephole_pass_1): Optimize away moves at the beginning of the bb as
	well.
	(peephole_pass): Likewise.

Fri Jun 22 09:17:08 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* driver.c: hopefully make setaffinity work also for ancient
	versions of linux.

2007-06-22  Atsushi Enomoto  <atsushi@ximian.com>

	* driver.c : win32 build fix.

Thu Jun 21 19:24:03 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* driver.c: check for the MONO_NO_SMP env var and bind to a single
	processor if it is set.

2007-06-21  Martin Baulig  <martin@ximian.com>

	* debug-mini.h: New file.

	* debug-mini.c
	(mono_debugger_insert_breakpoint_full): Moved here from
	../metadata/mono-debug-debugger.c.
	(mono_debugger_remove_breakpoint): Likewise.
	(mono_debugger_breakpoint_callback): Likewise.

2007-06-15  Raja R Harinath  <rharinath@novell.com>

	* jit-icalls.c (mono_helper_compile_generic_method): Update to
	changes in MonoGenericClass.

2007-06-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_opcode_to_type): Fix ia64 build.

2007-06-14  Raja R Harinath  <rharinath@novell.com>

	* jit-icalls.c (mono_helper_compile_generic_method): Update to
	removal of MonoGenericMethod.

Thu Jun 14 12:42:04 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini-exceptions.c: hooks for the exception events profiling API.

2007-06-14  Randolph Chung  <tausq@debian.org>

	* Makefile.ma: Add hppa target.
	* mini-arch.h: Include mini-hppa.h
	* cpu-hppa.md, exceptions-hppa.c, inssel-hppa.brg, mini-hppa.c,
	mini-hppa.h, tramp-hppa.c: New files for 32-bit HPPA port.
	Contributed under the X11 license (http://bugzilla.ximian.com/show_bug.cgi?id=81866).

2007-06-14  Randolph Chung  <tausq@debian.org>

	* inssel.brg: Add rules for "chained" compare-branch operations so that
	a single compare op can affect multiple branches.  Adjust cost for
	OP_CEQ/OP_CGT/OP_CGT_UN/OP_CLT/OP_CLT_UN.
	* inssel-long32.brg: Update rules to use compare-branch macros.  Adjust
	cost for some rules so that they can more easily be overridden by
	per-arch rules (with fixes from lupus).
	Contributed under the X11 license (http://bugzilla.ximian.com/show_bug.cgi?id=81866).

2007-06-13  Randolph Chung  <tausq@debian.org>

	* mini-ops.h: Reorder branch ops so that they match the order of the
	corresponding CEE_* ops.  The code expects them this way.
	Add new ops for HPPA target.
	Contributed under the X11 license (http://bugzilla.ximian.com/show_bug.cgi?id=81866).

2007-06-13  Randolph Chung  <tausq@debian.org>

	* mini-exceptions.c: Handle cases where the stack grows towards
	larger addresses.
	Contributed under the X11 license (http://bugzilla.ximian.com/show_bug.cgi?id=81866).

Wed Jun 13 19:13:23 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* jit-icalls.c, mini.h, mini.c: added virtual generic invoke
	counter.
	* driver.c: explain where a non-matching corlib is found.

2007-06-13  Mark Probst  <mark.probst@gmail.com>

	* mini.c (print_jit_stats): Output dynamic code allocation stats.

2007-06-10  Sanghyeon Seo <sanxiyn@gmail.com>

	* mini-exceptions.c: Generate a method profile leave event during
	an exception to ensure that the profiler gets notified.

2007-06-07  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (peephole_pass): Merge some small changes from the linear-ir 
	branch.

	* cpu-amd64.md: Add long_and/or/xor opcodes.

2007-06-06  Wade Berrier  <wberrier@novell.com>

	* cpu-s390x.md (shr_imm): Correct the length of shr_imm instruction.
	(./class/lib/monolite/mcs.exe:25498): WARNING **: wrong maximal instruction 
	length of instruction shr_imm (expected 8, got 10)

2007-06-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_output_basic_block): Really fix the build.

2007-06-06  Mark Probst  <mark.probst@gmail.com>

	* mini.c, driver.c: Changed MonoDomain.jit_code_hash to a
	MonoInternalHashTable again (fixed bug in the internal hash table
	code).

2007-06-06  Mark Probst  <mark.probst@gmail.com>

	* mini.c, driver.c: Reverted the MonoInternalHashTable changes.
	Have to figure out what makes it crash the SWF regression.

2007-06-05  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_lowering_pass): Fix ia64 build.

Tue Jun 5 17:40:04 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: optimize out the type check when storing null in a
	reference array.

2007-06-04  Mark Probst  <mark.probst@gmail.com>

	* mini.c, driver.c: Changed MonoDomain.jit_code_hash to a
	MonoInternalHashTable.

Mon Jun 4 11:29:43 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* inssel.brg, mini.c, mini-ops.h: optimized Math.Mini/Max
	signed integer methods.

2007-06-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_get_delegate_invoke_impl): Disable the static case 
	permanently since the current approach doesn't work.

2007-06-02  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg (stmt): Only call delegate->invoke_impl if 
	MONO_ARCH_HAVE_CREATE_DELEGATE_TRAMPOLINE is defined.

2007-06-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Unify div/rem opcodes and handle
	the sreg2==rdx case.
	
	* mini-amd64.c cpu-amd64.md: Correct length of r4const instruction and take into
	account if it contains a rex prefix.
	(peephole_pass): Handle OP_FMOVE as well.

2007-06-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_get_delegate_invoke_impl): Disable the static case for now
	as it causes regressions.

2007-05-31  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_get_delegate_invoke_impl): Implement support for the
	static case as well.

	* tramp-ia64.c (mono_arch_create_trampoline_code): Fix ia64 build.

	* mini-x86.c (mono_arch_get_delegate_invoke_impl): New arch dependent function.
	(mono_arch_get_this_arg_from_call): Ditto.

	* tramp-x86.c (mono_arch_patch_delegate_trampoline): Removed.

	* inssel.brg (mini_emit_virtual_call): Call delegate->Invoke through the delegate's
	invoke_impl field.

	* mini-amd64.c (mono_arch_get_delegate_invoke_impl): New arch dependent function.
	(mono_arch_get_this_arg_from_call): Ditto.

	* tramp-amd64.c (mono_arch_patch_delegate_trampoline): Removed.
	
	* mini-trampolines.c (mono_delegate_trampoline): Complete rewrite. On first call,
	try to create optimized invoke code and use that for further invocations. 
	Otherwise, use the original mono_marshal_get_delegate_invoke () implementation.

	* mini-x86.h mini-ia64.h: Remove MONO_ARCH_HAS_CREATE_DELEGATE_TRAMPOLINE for now.

2007-05-29  Rodrigo Kumpera  <kumpera@gmail.com>

	* inssel.brg (mini_emit_virtual_call): Statically dispatch virtual calls to
	sealed classes or methods.
	*devirtualization.cs: tests for the new optimization

2007-05-29  Zoltan Varga  <vargaz@gmail.com>

	* liveness.c (update_gen_kill_set): No need to set VOLATILE flags here, it is done
	by the update_volatile () function.

2007-05-27  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_main): Call g_thread_init () early since newer glib versions
	require it.

	* abcremoval.c (mono_perform_abc_removal): Avoid using alloca.

2007-05-24  Jonathan Chambers  <joncham@gmail.com>

	* mini.c: Add configure checks for header files.
	* mini-x86.c: Add configure checks for header files.
	* trace.c: Add configure checks for header files.
	* aot-runtime.c: Add configure checks for header files.
	* aot-compiler.c: Add configure checks for header files.
	* driver.c: Add configure checks for header files.
	* mini-codegen.c: Add configure checks for header files.
	
	Code is contributed under MIT/X11 license.

2007-05-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_lowering_pass): Fix the handling of
	icompare_imm -128 + op_iclt. Fixes #81703.

2007-05-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_local_regalloc): Fix long-shift-regalloc on amd64.

2007-05-15  Massimiliano Mantione  <massi@ximian.com>

	* inssel.brg: added "mini_emit_load_intf_bit_reg_vtable", and used it
	inside "mini_emit_isninst_iface_cast" and "mini_emit_castclass_iface"
	so that all isinst checks now use "interface_bitmap".

2007-05-15  Zoltan Varga  <vargaz@gmail.com>

	* cpu-amd64.md (jmp): Fix a warning.

	* inssel.brg (CEE_SWITCH): Hopefully fix #80738.

	* basic.cs: Add new regression test.

	* basic.cs: Remove test which is now in basic-long.cs.

	* mini-ia64.c (mono_arch_output_basic_block): Sign extend in CEE_CONV_I8/CEE_CONV_I.

	* basic-long.cs: Add new test.
	
2007-05-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (mono_spillvar_offset_float): Fix sparc build.

2007-05-12  Zoltan Varga  <vargaz@gmail.com>

	* cpu-x86.md minix-86.c: Add a peephole_pass_1 () as on amd64.

	* mini-x86.c (mono_arch_output_basic_block): Use mono_opcode_to_cond () in a few
	places.
	
	* mini-x86.c (mono_arch_emit_exceptions): Decrease the size of the exception 
	throwing code a bit.

	* exceptions-x86.c (mono_arch_get_throw_corlib_exception): Decrease the size of 
	the exception throwing code a bit.

	* mini-x86.c (get_call_info): Allocate result from a mempool.

2007-05-11  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (find_typespec_for_class): Fix the assert.

	* mini.h (MONO_AOT_FILE_VERSION): Bump AOT file version.

	* mini.h (MonoCompile): Add 'token_info_hash' field.

	* mini.c: Save token->method associations during compilation so the AOT 
	compiler can use it.
	
	* aot-compiler.c aot-runtime.c: Add support for compiling non-generic methods
	which reference generic classes and methods.

2007-05-10  Zoltan Varga  <vargaz@gmail.com>

	* mini.h mini-<ARCH>.h: Get rid of MONO_ARCH_HAS_XP_LOCAL_REGALLOC.

	* aot-compiler.c (compile_method): Fix a typo in a comment.

	* aot-runtime.c (decode_cached_class_info): Skip generic types.

	* aot-compiler.c: Add minimal support for AOTing generic code by skipping 
	everything generic.

	* mini.c (mono_method_to_ir): Disable AOT when calling helper_compile_generic_method.

2007-05-09  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MonoCompile): Add 'args' field.

	* mini.c (mono_compile_create_vars): Store variables representing the arguments
	into cfg->args.

	* mini-<ARCH>.c: Use cfg->args for accessing the method arguments.

2007-05-08  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_compile_get_interface_var): Remove this unused function.

	* mini-ops.h inssel.brg mini-<ARCH>.c: Add a new opcode for ckfinite as well.

	* mini-ops.h: Introduce new opcodes used in the IR instead of the original CEE_
	opcodes for some opcodes.

	* mini.h *.brg *.c: Use the new opcodes.

2007-05-08  Massimiliano Mantione  <massi@ximian.com>

	* mini.h: Bumped aot revision.

	* inssel.brg: modified code generation of type checks for interfaces
	to use the new "MonoClass.interface_bitmap" instead of the old
	"MonoClass.interface_offsets".

2007-04-30  Zoltan Varga  <vargaz@gmail.com>

	* cpu-amd64.md (jmp): Increase the maximum size of the jmp opcode to 128.

2007-04-29  Zoltan Varga  <vargaz@gmail.com>

	* abcremoval.c (summarize_integer_value): Handle OP_LCONV_TO_I4 to fix abcrem on
	64 bit platforms.

2007-04-27  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c: Fix MONO_TYPE_VALUETYPE processing.

2007-04-27  Wade Berrier  <wberrier@novell.com>

	* mini-s390x.c: Remove redeclaration of CompRelation and CompType (defined in 
	mini.h) to fix build.

2007-04-26  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (peephole_pass_1): Fix and reenable this pass.
	
	* mini-amd64.c (mono_arch_local_regalloc): Disable the new peephole_pass_1 as it
	causes the corlib unit tests to fail.

2007-04-25  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_opcode_to_type): Fix a bug in the previous patch.

	* mini-amd64.c (peephole_pass_1): New pass to perform before local regalloc.

	* mini-codegen.c (mono_opcode_to_cond): New helper function to convert conditional 
	opcodes to the comparison relations.

	* mini-codegen.c (mono_opcode_to_type): New helper function to convert conditional 
	opcodes to their types.
	
	* mini-ia64.c mini-amd64.c: Use mono_opcode_to_cond and mono_opcode_to_type.

	* mini-amd64.c (get_call_info): Allocate the result from the cfg mempool and cache 
	it in cfg->arch.cinfo.

	* local-propagation.c (mono_local_cprop_bb): Fix a warning.

	* mini.h mini.c branch-opts.c: Change bbhash to be an array and store it in 
	cfg->cil_offset_to_bb.

2007-04-24  Zoltan Varga  <vargaz@gmail.com>

	* liveness.c (optimize_initlocals): New mini-pass to optimize away dead assignments
	created becase of initlocals.

2007-04-23  Zoltan Varga  <vargaz@gmail.com>

	* mini-alpha.c cpu-alpha.md: More alpha port work from 
	Sergey Tikhonov <tsv@solvo.ru>.

2007-04-21  Andreas Faerber  <andreas.faerber@web.de>

	* Makefile.am (BUILT_SOURCES): Fix for automake 1.6.x. Fixes #81417.

2007-04-19  Zoltan Varga  <vargaz@gmail.com>

	* cpu-s390.md (break): Correct the length of break instruction.

Thu Apr 19 16:28:52 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: fix a couple of soft-float issues and comments.

2007-04-15  Miguel de Icaza  <miguel@novell.com>

	* trace.c (is_filenamechar): - is also a filename char.

2007-04-15  Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c: Correct checking for enum type in return value processing.

2007-04-14  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (BUILT_SOURCES): Add 'version.h'.
	(version.h): Makefile is in the build directory.

2007-04-06  Andreas Faerber  <andreas.faerber@web.de>

	* mini-amd64.h: fix for assertion failure on Solaris/amd64

2007-04-11  Martin Baulig  <martin@ximian.com>

	* mini.c (can_access_member): Fix handling of generic classes;
	fixes #81259.

2007-04-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_plt_resolve): Fix disabling of AOT. Fixes #81316.

2007-04-05  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c: Fix disabling of AOT. Fixes #81316.

Fri Mar 23 20:25:31 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-codegen.c: make sure the right spill amount is
	used for fp or integer registers (fixes the float_sub_spill() on ppc).

Fri Mar 23 19:43:35 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: fixes for the fp_branch_nan test.

2007-03-23  Zoltan Varga  <vargaz@gmail.com>

	* basic.cs: Comment out new test which still fails on ia64.

Fri Mar 23 15:54:23 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: immediate shifted or fix (mono_metadata_user_string assert).

Fri Mar 23 12:53:28 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, mini-ppc.h: struct passing ABI fix (bug #77968).

2007-03-22  Zoltan Varga  <vargaz@gmail.com>

	* cfold.c (FOLD_BINOP): Cast the result to gint32 to prevent overflow problems
	on 64 bit machines. Fixes part of #80738.

	* basic.cs: Add regression test.

2007-03-17  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg basic.cs: Revert previous change to fix build.

	* inssel.brg (SWITCH): Clean out the upper word of the switch value on 64 bit
	platforms.
	
	* inssel.brg (SWITCH): Use an integer comparison. Fixes #80738.

	* basic.cs: Add new regression test.

2007-03-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_emit_prolog): Fix an assert when a function has too
	many arguments.

2007-03-16  Neale Ferguson <neale@sinenomine.net>

	* cpu-s390x.md: Correct length of break instruction.

2007-03-16  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, cpu-s390x.md: Fix #80507 for s390x.
	* mini-s390.c, cpu-s390.md: Fix #80507 for s390.

2007-03-15  Jonathan Chambers  <joncham@gmail.com>

	* *.c: Begin WIN64 port.
	* mini.c:  Use correct register in profiler.
	* mini-amd64.c: No inline assembly on Win64.
	* mini-amd64.h: Implement MONO_INIT_CONTEXT_FROM_FUNC for Win64.
	Only define MONO_ARCH_USE_SIGACTION on non-windows platforms.
	* exceptions-amd64.c: Only need gregs_from_ucontext if MONO_ARCH_USE_SIGACTION
	is defined. Implement mono_arch_sigctx_to_monoctx, mono_arch_monoctx_to_sigctx, and
	mono_arch_ip_from_context for Win64.
	
	Contributed under MIT/X11 license.

2007-03-15  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c (seh_handler): Ditto.

	* exceptions-x86.c (seh_handler): Fix a memory leak.

Thu Mar 15 13:47:59 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c, mini-mips.c, mini-ppc.c, mini-s390.c,
	mini-s390x.c: fixed peephole optimizations to deal
	correctly with 1 and 2 byte reload avoidance.

Thu Mar 15 10:17:54 CET 2007 Paolo Molaro <lupus@ximian.com>

	* cpu-s390.md, cpu-s390x.md: update localloc length.

Wed Mar 14 21:00:19 CET 2007 Paolo Molaro <lupus@ximian.com>

	* cpu-g4.md: added missing descriptions.

2007-03-14  Miguel de Icaza  <miguel@novell.com>

	*  Makefile.am: Add support so the tail tests are not executed on
	PowerPC as that is a known limitation of the PowerPC port.

2007-03-13  Jonathan Chambers  <joncham@gmail.com>

	* runmdesc.bat:  Move to msvc directory.
	
2007-03-13  Jonathan Chambers  <joncham@gmail.com>

	* runmdesc.bat:  Run executable that was produced by the current
	target and sent via an argument.
	
2007-03-11  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Fix box+brtrue optimization. Fixes
	#81102.

	* generics.2.cs: Add regression test.

2007-03-09  Wade berrier  <wberrier@novell.com>

	* mini-ppc.h: Undo typo of MONO_CONTEXT_SET_SP (ppc doesn't define this symbol)

2007-03-09  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_aot_module): Load all dependent assemblies eagerly since all
	AOT code depends on this.

Thu Mar 8 19:36:13 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: more precise tracking of types in the eval stack
	(part of fix for bug #81044).

2007-03-07  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_class_from_name): Add a cache.

	* aot-compiler.c (encode_patch): Remove an obsolete comment.

2007-03-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_native_sigsegv): Fix a warning.

	* mini.c (mono_method_to_ir): Add a workaround for bug #80733.

2007-02-22  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (type_from_op): Convert CEE_CONV_U to OP_LCONV_TO_U when the argument is
	a pointer on 64 bit systems. Fixes #80190.

	* iltests.il: Add new regression test.

Tue Feb 20 11:33:28 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: inline a constant for Environment.IsRunningOnWindows.

2007-02-19  Geoff Norton  <gnorton@customerdna.com>

	* trace.c: Remove an erroneous alignemnt check when tracing.
	  Fixes --trace on OSX86.

Wed Feb 14 19:45:56 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-$(arch).h: initialize SP in context for all the archs.

2007-02-14  Sebastien Pouliot  <sebastien@ximian.com>

	* mini-x86.h: Initialize SP in MONO_INIT_CONTEXT_FROM_FUNC. Fix CAS
	regressions in the thread tests.

2007-02-14  Zoltan Varga  <vargaz@gmail.com>

	* *-alpha.*: More alpha port work from Sergey Tikhonov <tsv@solvo.ru>:
	- fixed implementation of LOCALLOC opcode
	- implemented non-un compare for floats
	- code cleanup
	- implementation of FDIV and CKFINITE opcodes
	- fixes for latest mono updates
	- additional arch opcodes

Mon Feb 12 11:54:16 CET 2007 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: simplify and merge rules for cross-compilation.

2007-02-07  Massimiliano Mantione  <massi@ximian.com>

	* local-propagation.c: Actually *apply* the fix for bug 80591...

Tue Feb 6 19:03:19 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-exceptions.c: backuot part of the last change
	(fixes cas tests on amd64 related to GetExecutingAssembly ()).

2007-02-06  Massimiliano Mantione  <massi@ximian.com>
	* inssel.brg: Fix bug 59286.


Tue Feb 6 12:23:50 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-exceptions.c: patch from Zoltan to correctly check for
	stack boundaries (using the stack register, not the frame register),
	fixes bugs #80724, #79717.

2007-02-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c inssel-sparc.brg mini-sparc.c cpu-sparc.md: Get rid of OP_SETREG/
	OP_SETREGIMM, use OP_MOVE/OP_ICONST instead.

	* mini-amd64.c (mono_arch_output_basic_block): Fix ATOMIC_EXCHANGE in the
	presence of frame pointer elimination.

2007-02-01  Geoff Norton  <gnorton@customerdna.com>
        
	* mini-x86.h: NetBSD UCONTEX_REG defines.

2007-02-01  Zoltan Varga  <vargaz@gmail.com>

	* inssel-amd64.brg: Fix amd64 build.

Thu Feb 1 14:02:09 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h: remove extern to workaround what looks likes gcc bug 26905
	on amd64.

2007-01-31  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_is_regsize_var): New helper function usable by the back
	ends.

	* mini-<ARCH>.c: Use mono_is_regsize_var ().

2007-01-30 Mark Mason <mason@broadcom.com>

	   * exceptions-mips.c: Lots of exception handling fixes, LMFs now work, some cleanups.
	   * mini-mips.h: Add LMF magic numbers, and fix context set/get macros.
	   * mini-mips.c: Cleanups, LMF handling now works, optimize store of zero, implement localloc
	   beginning support for CEE_JMP [not quite working yet]
	   * tramp-mips.c: LMF handling now works
	
2007-01-30  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (peephole_pass): Optimize code common in initlocals blocks.

	* mini.h (NULLIFY_INS): New macro.

Tue Jan 30 16:33:33 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: statistical profiler fix for windows, patch
	from Tor Lillqvist (tml@novell.com).

2007-01-30  Massimiliano Mantione  <massi@ximian.com>
	* local-propagation.c: Fix bug 80591.

Mon Jan 29 12:14:34 CET 2007 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: put back the --export-dynamic option as with
	the previous gmodule flags (thanks to Robert Jordan).

2007-01-28  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (peephole_pass): Fix #80622 for sparc as well.

	mini.h *.c: Allocate fp vregs from the same pool as the int vregs. Use this to
	simplify and speed up the local register allocator. Also rename some fields
	like iassign->vassign.
	
	* regalloc.c: Remove some functions which are no longer used since their
	inlined version is in mini-codegen.c.
	
	* mini-codegen.c: Rename mono_regstate2_ functions to mono_regstate_.

	* basic.cs objects.cs iltests.il: Merge tests from the linear IL branch.

2007-01-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (peephole_pass): Remove optimizations which omit a 
	narrowing. Fixes #80622.

	* iltests.il: Add new regresssion test.	

Fri Jan 26 18:31:45 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-trampolines.c, aliasing.c, mini-codegen.c,
	debug-debugger.c, debug-debugger.h: warning fixes.
	* driver.c: updated copyright year and made it fit in one line.

Fri Jan 26 12:48:39 CET 2007 Paolo Molaro <lupus@ximian.com>

	* aot-runtime.c: updated to use mono-dl instead of gmodule.

2007-01-25  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_output_basic_block): Fix #80507 for x86.

	* mini-amd64.c (mono_arch_output_basic_block): Fix #80507 for amd64.

	* iltests.il: Add new test for bug #80507.

Wed Jan 24 19:10:28 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-arm.h: use soft-float also on vfp for now.

Wed Jan 24 14:54:40 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: fix some more soft-float issues.

2007-01-24  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.h (MONO_ARCH_FRAME_ALIGNMENT): Fix sparc build.

2007-01-24  Massimiliano Mantione  <massi@ximian.com>
	* mini-arch.h, , inssel-amd64.brg, mini-x86.c, inssel-x86.brg,
	mini-ia64.c, mini-sparc.c, mini-alpha.c: Introduced
	MONO_ARCH_LOCALLOC_ALIGNMEENT to fix bug 80498.

Wed Jan 24 12:04:39 GMT 2007 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: typo fix.

2007-01-23  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c: Use lgb instructions for I1 type variables instead of lb.

2007-01-21  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_allocate_stack_slots_full): Allocate memory from the cfg mempool.
	Share stack slots for scalar types. Avoid expensive g_list_free () calls.

	* mini-x86.c (mono_arch_allocate_vars): Don't free the result of allocate_stack_slots_full.

	* mini-amd64.c mini-ia64.c mini-alpha.c: Ditto.	

	* mini.h (MonoJitStats): Add a new JIT statistics: locals_stack_size.
	
	* inssel.brg: Fix a warning.

	* mini.h (MonoBasicBlock): Make bb->dominated a GSList.

	* abcremoval.c ssa.c ssapre.c: Update after this change.
	
	* dominators.c (compute_dominators): Allocate bb->dominated from the cfg mempool.

	* dominators.c (df_set): Use mono_bitset_union_fast.	

Sat Jan 20 16:59:01 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h, genmdesc.c, genmdesc.pl, mini-${arch}.c, cprop.c,
	mini-codegen.c: reduce relocations and memory usage for the cpu
	description.

2007-01-20  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_regstate2_alloc_int): Optimize this using bsfq on amd64.

	* genmdesc.c genmdesc.pl mini.h: Remove some unused fields from the mdesc tables
	to reduce their size.

2007-01-19 Mark Mason <mason@broadcom.com>

	* exceptions-mips.c: fix mono_arch_ip_from_context(), increase exception debug support.
	* mini-mips.c: more configuration macros, support long conditional branches, additional
	asserts, fix epilog instrumentation.
	* mini-mips.h: use standard stack walk
	* cpu-mips.md: increase size of div, rem and conditional branches
	
Fri Jan 19 17:23:32 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-codegen.c, mini-$(arch).h: claenup references
	to cpu spec data.

2007-01-19  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (encode_klass_info): Allow classes of the form <Type>[][].
	(compile_method): Ditto.

	* aot-runtime.c (decode_klass_info): Ditto.

	* mini.c (mono_method_to_ir): Call mono_get_got_var () in a place where it is
	needed by the code generated by inssel.brg. Also fix a warning.

Thu Jan 18 17:55:22 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: deal with enums that become genericinsts by
	being nested in a generic class (bug #79956).

Thu Jan 18 16:52:56 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: match the generic definition to check for
	private access with generic types (bug #78431).

Thu Jan 18 11:50:13 CET 2007 Paolo Molaro <lupus@ximian.com>

	* genmdesc.pl, Makefile.am: perl implementation of genmdesc,
	to make life easier for people cross-compiling that insist on not
	using scratchbox.

2007-01-17 Mark Mason <mason@broadcom.com>

	* inssel-long.brg: patch to deal with mips missing flags
	* inssel-long32-mips.brg: implement overflow checks
	* insset-mips.brg: implement overflow checks
	* mini-mips.h: implement conditional exception handling
	* mini-mips.c: add mips_emit_exc_by_name(), implement conditional exception handling.
	  Remove unused code, minor cleanups.
	* exceptions-mips.c: minor cleanups
	* mini-ops.h: add mips conditional exception ops
	* cpu-mips.md: add mips conditional exception ops

	
Wed Jan 17 19:22:34 CET 2007 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: patch from Mark Mason <mason@broadcom.com>
	to deal with mips missing of flags.

Tue Jan 16 20:01:01 CET 2007 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c: execute fault handlers.

Tue Jan 16 19:54:44 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: handle missing call locationss with FORCE_INDIR_CALL.

Tue Jan 16 13:14:31 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: handle also floating point values in initialize_array.

Tue Jan 16 12:42:40 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, aot-runtime.c, aot-compiler.c: enable aot compilation of
	array initialization and make it conditional on the intrins option.

Tue Jan 16 11:28:45 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h, patch-info.h, Makefile.am, aot-compiler.c: reduce
	relocations and put the patch info names close to the enum definition.

2007-01-15 Mark Mason <mason@broadcom.com>

	* basic.cs, exceptions.cs: break up large tests to increase debugability.

Mon Jan 15 18:57:14 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: optimized RuntimeHelpers::InitializeArray () calls.

2007-01-12  Raja R Harinath  <rharinath@novell.com>

	* mini.c (mono_method_to_ir): Use new MonoGenericContext accessor.

Thu Jan 11 11:16:42 CET 2007 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: distribute the mips sources.

Wed Jan 10 19:49:33 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-codegen.h: handle bug #80489 here, by excluding ecx
	directly.

Wed Jan 10 19:08:05 CET 2007 Paolo Molaro <lupus@ximian.com>

	* cpu-x86.md: back out for now as this triggers other regressions.

Wed Jan 10 18:33:16 CET 2007 Paolo Molaro <lupus@ximian.com>

	* cpu-x86.md: force src1 and dest regpair for long shift instructions
	to eax:edx, so ecx can't get allocated to them (bug #80489).

Tue Jan 9 12:36:11 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini-exceptions.c: enabled running fault handlers
	(bug #80469).

2007-01-03  Miguel de Icaza  <miguel@novell.com>

	* driver.c: If nothing fail, do not use the string "failed",
	because it makes it very annoying to view test result logs on the
	web. 

2006-12-30  Miguel de Icaza  <miguel@novell.com>

	* debug-debugger.c (mono_debugger_main): Rename "main" to
	"main_method" to prevent a warning.

	Remove a warning for unused field.

2006-12-28  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c
	(MONO_DEBUGGER__debugger_info): Add `get_lmf_addr'.

2006-12-22  Martin Baulig  <martin@ximian.com>

	* mdb-debug-info32.s, mdb-debug-info64.s: New files.
	Put a pointer to the `MONO_DEBUGGER__debugger_info' into a
	seperate `.mdb_debug_info' section, so we can access it from the
	debugger even if the binary is stripped.

	* debug-debug.c: Reference the `MONO_DEBUGGER__debugger_info_ptr'
	from the `.mdb_debug_info' here to prevent the linker from
	removing that section.

	* Makefile.am (mono_debugger_sources): Add mdb-debug-info32.s /
	mdb-debug-info64.s.

2006-12-19  Robert Jordan  <robertj@gmx.net>

	* mini-x86: enable the code to return small structures in
	registers for FreeBSD as well. Fixes bug #80278.
	* aot-runtime.c: Include sys/wait.h for WEXITSTATUS/WIFEXITED.

Mon Dec 18 19:47:17 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c: align the stack when calling the profiler
	function instrumenting the prolog (on OSX).

Thu Dec 14 15:22:43 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: emit a break opcode where Debugger.Break () is called.

2006-12-13  Miguel de Icaza  <miguel@novell.com>

	* mini.c (mono_method_to_ir): Provide useful information on this
	assert, to prevent others from debugging like I did.

Tue Dec 12 17:01:38 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: enable code which was incorrectly commented
	(bug #80235).

Tue Dec 12 16:28:15 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c: enable on OSX, too, the code to return small
	structures in registers.

Mon Dec 11 19:22:35 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c: remove the use of the dynamic code manager here, too.

Mon Dec 11 19:08:33 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, debug-debugger.c, tramp-*.c: fixed 
	mono_debugger_create_notification_function() to use
	mono_global_codeman_reserve () instead of a dynamic code manager.

Tue Dec 5 17:54:50 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c, jit-icalls.h, jit-icalls.c: remove the 
	ves_array_element_address() jit icall and use a generated
	managed method instead (which is about 4 times faster for a rank 3
	array access).

2006-11-29  Mark Mason  <mason@broadcom.com>

	* basic-calls.cs: additional tests for passing
	structures as function arguments.

2006-11-29  Mark Mason  <mason@broadcom.com>

	* mini-mips.h: disable custom exception handling
	* mini-mips.c: throw/rethrow should use jalr to call
	exception stubs.  Fixed bug with passing structures
	by value. More support for tracing floating point
	functions.

Wed Nov 29 20:28:17 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: fixed typo in the soft-float ldind.r4 handling
	(bug #80086).

Wed Nov 29 11:33:03 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h, driver.c: added --runtime command line
	option to select a different runtime than the autodetected one.
	* jit.h: added API for embedders to initialize with a specific
	runtime version.

Tue Nov 28 21:24:55 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: handle also boxing of r4 values (bug #80024).

Tue Nov 28 19:45:44 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: force indirect calls until we reserve
	enough address space for all the generated code.

Tue Nov 28 20:04:34 GMT 2006 Paolo Molaro <lupus@ximian.com>

	* exceptions-arm.c: workaround bugs in the libc definition
	of struct ucontext.

Mon Nov 27 15:13:41 CET 2006 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: fixes from me and Mark Mason.

2006-11-23  Dick Porter  <dick@ximian.com>

	* wapihandles.c (mini_wapi_seminfo): No need to adjust the counter
	semaphore display now we've fixed the initial value

Wed Nov 22 11:04:37 CET 2006 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: partially revert the last change to fix the build.

2006-11-21  Mark Mason  <mason@broadcom.com>

	* inssel.brg: Add and use compare-and-branch macros to support
	architectures that do not have condition code registers (ie. MIPS).
	* *-mips.{c,brg,md}: Fix copyright statements

2006-11-20  Mark Mason  <mason@broadcom.com>

	* Makefile.am: remove mini-codegen.c from list of MIPS sources
	* mini.c: Allow GET_CONTEXT to be specified by the arch port
	* mini.h: Added declaration for mono_print_ins()
	* mini-codegen.c: added ins_spec initializer for MIPS
	* mini-codegen.c (mono_call_inst_add_outarg_reg): added asserts for
	vreg to be virtual and hreg to be non-virtual.
	* mini-codegen.c (mono_spillvar_offset): assert if MIPS - spilling
	is not yet working/implemented correctly.
	* mini-codegen.c (print_ins): rename to mono_print_ins(), make
	non-static, fixup calls to print_ins() from other parts in the file.

2006-11-20  Mark Mason  <mason@broadcom.com>

	* basic-calls.cs: added tests for passing structures as arguments
	to calls.

Mon Nov 20 19:40:11 CET 2006 Paolo Molaro <lupus@ximian.com>

	* inssel-long32.brg: optimize signed division by power of two.

Mon Nov 20 17:37:58 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: added support for interworking with thumb code
	(mono must be still be built using the ARM instruction encoding).

2006-11-19  Miguel de Icaza  <miguel@novell.com>

	* mini.c (type_from_op): Separate the conditions for OP_EQ as the
	verifier has different rules for it.   Fixes a few verifier issues
	in the test suite.

	* mini-exceptions.c (mono_handle_native_sigsegv): Put the message
	at the end, so people know what happened.

Thu Nov 16 14:07:18 CET 2006 Paolo Molaro <lupus@ximian.com>

	* brach-opts.c: in optimize_exception_target() make sure we
	are in a catch clause (fixes bug #79871).

Thu Nov 16 12:42:13 CET 2006 Paolo Molaro <lupus@ximian.com>

	* jit-icalls.c, jit-icalls.h, mini-arm.c, mini.c:
	more soft-float support fixes.

Wed Nov 15 18:45:47 GMT 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c, inssel-arm.brg: ABI fix for longs and doubles
	that are passed half on the stack and half in registers.

Wed Nov 15 17:00:27 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ops.h, mini-arch.h, helpers.c, Makefile.am:
	more mips integration work from Mark E Mason 
	<mark.e.mason@broadcom.com>.

Wed Nov 15 16:34:03 CET 2006 Paolo Molaro <lupus@ximian.com>

	* exceptions-mips.c, inssel-mips.brg, mini-mips.h,
	cpu-mips.md, inssel-long32-mips.brg, mini-mips.c,
	tramp-mips.c: added sources for the mips port, not
	integrated in the build yet. Contributed by
	Mark E Mason <mark.e.mason@broadcom.com>.

2006-11-14  Neale Ferguson <neale@sinenomine.net>

	* mini-s390[x].c (is_regsize_var): Support PTR/FNPTR too.

Tue Nov 14 16:06:37 CET 2006 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, inssel-float.brg, inssel-softfloat.brg:
	put the soft-float rules in its own file since it seems to
	break s390 compilation.

Mon Nov 13 15:54:38 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: fixed wrnings.

Fri Nov 10 19:18:32 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c, mini-arm.h, cpu-arm.md, inssel-float.brg,
	inssel-arm.brg: ARM support for soft-float.

Fri Nov 10 18:38:15 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c, jit-icalls.c, jit-icalls.h: added first cut at handling
	loads and stores of 32 bit fp values.

2006-11-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (is_regsize_var): Support PTR/FNPTR too.

	* tramp-sparc.c (mono_arch_patch_callsite): Fix this function so it actually
	works. Fixes #79852 and #79463.

Thu Nov 9 16:56:13 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini-codegen.c, jit-icalls.c, jit-icalls.h:
	more soft-float support WIP and fixes.

Wed Nov 8 16:40:02 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: some VFP updates.

Tue Nov 7 19:45:51 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-exceptions.c: 0 is a valid local var offset in some
	architectures, don't assert (bug #78508).

Tue Nov 7 18:17:52 GMT 2006 Paolo Molaro <lupus@ximian.com>

	* exceptions-arm.c: fixed off by one error in stack walk code.

Tue Nov 7 11:27:26 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini.c: more precise tracking of type load exceptions.

2006-11-03  Robert Jordan  <robertj@gmx.net>

	* Makefile.am: [WIN32] Add monow.exe target.
	* driver.c: [WIN32] Don't detach the console when debugging.
	Fixes bug #79797.
	
2006-10-30  Miguel de Icaza  <miguel@novell.com>

	* tramp-x86.c (mono_arch_patch_delegate_trampoline): Eliminate warning.

2006-10-23  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_method_info): Add a case missed earlier.

	* driver.c (mini_regression): Fix --regression with AOT.

	* aot-compiler.c (emit_method_info): Fix AOT on amd64.

2006-10-17  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (GET_CONTEXT): Correct the definition of this for sparc/linux.

	* mini-sparc.h: Don't use sigaction on sparc/linux.

	* exceptions-sparc.c: Call mono_arch_flush_icache () in a couple of places.

	* mini-sparc.c (mono_sparc_flushw): Call mono_arch_flush_icache ().

	* mini-exceptions.c: Add proper include files for getpid ().

2006-10-16  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_method): Change this to return the native code
	address instead of a MonoJitInfo* to avoid decoding the exception info for the
	method.

	* aot-runtime.c aot-compiler.c: Use uint16 instead of uint32 entries in the
	name cache to reduce its size.

	* mini.h (MONO_AOT_FILE_VERSION): Bump aot file format version.

2006-10-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c: Save/restore the current LMF structure more efficiently using
	the mono_lmf TLS variable.

	* exceptions-x86.c (mono_arch_find_jit_info): Only access lmf->method in 
	trampoline lmf frames.	

	* mini-sparc.h (MONO_ARCH_ENABLE_EMIT_STATE_OPT): Define this on sparc as well.

2006-10-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c: Save/restore the current LMF structure more efficiently using
	the mono_lmf TLS variable.

	* mini-exceptions.c: Access the LMF structure through accessors.

	* mini.c: Allow the backends the option for storing the lmf in a dedicated TLS 
	variable instead of in jit_tls->lmf.

	* mini-x86.c mini-amd64.c: Update after lmf->lmf_addr name change.
	
	* exceptions-amd64.c (mono_arch_find_jit_info): Only access lmf->method in 
	trampoline lmf frames.

	* mini-amd64.c (mono_arch_emit_prolog): Do not set lmf->method as it is not needed.

2006-10-12  Zoltan Varga  <vargaz@gmail.com>

       * mini.c trace.c mini-x86.c: Revert these too.
	
       * mini.c trace.c mini-x86.c: Remove warning workarounds after the mono_type_size ()
       signature change.

Tue Oct 10 11:35:20 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* genmdesc.c: removed now dead code.

2006-10-09  Robert Jordan <robertj@gmx.net>

	* mini.c: Disable the CrashReporter on MacOS X; Fixes #74869

Mon Oct 9 17:06:41 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h: do not leave gaps in the opcode values.

Mon Oct 9 16:08:51 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* jit-icalls.h: flag functions as internal here, too.

Mon Oct 9 15:58:18 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, aliasing.h, declsec.h, regalloc.h, trace.h: mark internal
	functions with the internal attribute.

Mon Oct 9 15:52:45 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* aot-compiler.c: fclose the file descriptor in the profile read loop.

Fri Oct 6 16:01:38 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c, jit-icalls.c, inssel-float.brg: beginnings of support
	for soft-float.

2006-10-05  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (emit_load_volatile_arguments): New function to handle arguments of
	tail calls as on other platforms.

	* mini.c (mono_method_to_ir): Fix a few tailcall problems. Fixes #79557.

	* iltests.il: Add a few tailcall tests.

Tue Oct 3 16:33:08 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c: fix loop for old compilers (bug #79521).

2006-10-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (ves_icall_get_trace): Remove debug printf.

	* aot-runtime.c (mono_aot_get_class_from_name): Avoid a memory allocation.

	* aot-compiler.c: Add a new option 'metadata-only' to only emit the cached
	metadata without any code.

	* mini-exceptions.c (mono_handle_native_sigsegv): Add some code to print out
	more precise debugging information using gdb.

2006-09-30  Zoltan Varga  <vargaz@gmail.com>

	* inssel-ia64.brg: Make the helper methods static.

Thu Sep 28 16:40:07 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* inssel-x86.brg: make the helper methods static.

Thu Sep 28 16:31:32 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* inssel-amd64.brg, mini-amd64.c: small cleanup, use inst_call.

Thu Sep 28 15:36:07 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: updates for monoburg changes.
	* inssel.brg: make a few helper functions static as they should.

2006-09-27  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am: Move mini-codegen.c to common_sources.

Wed Sep 27 15:07:08 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h: instroduce inst_call in MonoInst for use in OUTARG
	instructions.
	* Makefile.am, cpu-g4.md, inssel-ppc.brg, mini-codegen.c, mini-ppc.c,
	mini-ppc.h: port to use the common local register allocator.

2006-09-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Remove the comment too then.

Tue Sep 26 14:02:58 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h: put back backend.data which is to be used shortly and
	doesn't increase the size of MonoInst. If any 64 bit arch aligned
	pointers on 4 byte boundaries it'd have much bigger issues running
	and you can ifdef it out anyway.

2006-09-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MonoInst): Remove backend.data field since it is unused and increases
	MonoInst size by 4 bytes on 64 bit machines.

Tue Sep 26 11:57:26 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* *.{c,h,brg}: long due removal of the unused field in MonoInst and
	replacement with more meaningful field names. Arch maintainers, please
	check the assigned names are good enough for your arch.

2006-09-26  Zoltan Varga  <vargaz@gmail.com>

	* cpu-ia64.md mini-ia64.c inssel-ia64.brg mini-ops.h: Get rid of the 
	OP_IA64_FETCHADD opcodes, use OP_ATOMIC_ADD_IMM_NEW opcodes instead.

Mon Sep 25 11:05:24 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, driver.c, optflags-def.h, Makefile.am: reduce runtime
	relocations and memory requirements, put the optimization flags
	definitions in their own file.

2006-09-24  Zoltan Varga  <vargaz@gmail.com>

	* jit-icalls.c (mono_helper_stelem_ref): Remove this unused helper function.

	* mini.c (mini_init): Remove reference to mono_helper_stelem_ref.

2006-09-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (add_valuetype): Fix an uninitialized memory issue.

Thu Sep 21 19:06:09 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: use the correct function to get the size of an item
	in an array, given an element class.
	* aot-compiler.c: do not access class->class_size directly.

Thu Sep 21 12:10:56 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, debug-mini.c: added a debugging function to print
	info about local variables and arguments in a jitted method.

2006-09-20  Zoltan Varga  <vargaz@gmail.com>

	* mini-alpha.c: More alpha port work from Sergey Tikhonov <tsv@solvo.ru>.

	* exceptions-ia64.c: Fix some problems reported by Bill Seurer <seurer@us.ibm.com>.

2006-09-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_call_opcode): Avoid using the same loop index in the
	inner and outer loops when passing vtypes.

Tue Sep 19 17:53:40 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: take into account the cpu errata for cache flushing
	which caused some random errors (bug #79381).

2006-09-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_exceptions): Emit the call to 
	mono_arch_throw_corlib_exception using emit_call () too. Fixes #79271.

2006-09-17  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_aot_module): Return immeditely if the AOT module was already
	loaded.

	* exceptions-amd64.c (gregs_from_ucontext): Apply another patch from the
	freebsd ports tree.

	* mini-amd64.c (emit_call): Avoid near calls on freebsd.
	(mono_arch_patch_code): Remove the unused handling of MONO_PATCH_INFO_CLASS_INIT.

	* tramp-amd64.c (mono_arch_create_specific_trampoline): Fix check for 32 bitness of
	displacement.

2006-09-13  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_aot_module_from_cache): Fix PPC build.

2006-09-12  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (UNVERIFIED): Add a 'break-on-unverified' MONO_DEBUG option so this 
	macro does not have to be changed during debugging.

	* cpu-alpha.md inssel-alpha.brg mini-alpha.h mini-alpha.c exceptions-alpha.c tramp-alpha.c: More alpha port work from Sergey Tikhonov <tsv@solvo.ru>.

	* cpu-pentium.md: Rename this to cpu-x86.md for consistency with other platforms.

	* Makefile.am mini-x86.c mini-codegen.c: Rename pentium_desc to x86_desc.
	
	* mini.c (mini_get_ldelema_ins): Allow ldelema2d optimization if 
	MONO_ARCH_NO_EMULATE_MUL is defined.

	* mini-ia64.h (MONO_ARCH_CALLEE_FREGS): Reserve f33 for use by instructions.

	* mini-ia64.h: Define MONO_ARCH_NO_EMULATE_MUL.

	* mini-ia64.c: Implement CEE_MUL based on gcc emitted code.

	* mini-ia64.c (mono_arch_lowering_pass): Optimize store_membase_imm with offset==0.
	
2006-09-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.h mini-amd64.h mini-exceptions.c: Move the bsd specific MAP_ANON
	stuff to mini-exceptions.c where it is used.

	* mini-sparc.c (mono_arch_setup_jit_tls_data): Remove the duplicate altstack
	setup code, the real one is in mini-exceptions.c.

	* mini-amd64.h mini-amd64.c exceptions-amd64.c: Move all dependencies on the
	layout of ucontext_t to helper functions in exceptions-amd64.c, as on x86. Add
	some changes from the freebsd ports tree.

	* mini-amd64.h exceptions-amd64.c: Fix the amd64 build. Get rid of the SC_
	constants.
	
	* mini-amd64.h: Freebsd has MAP_ANON instead of MAP_ANONYMOUS.

Mon Sep 11 13:18:55 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: on Linux, check for /proc to be mounted
	(bug# 79351, novell bug#201204).

Mon Sep 11 13:10:12 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: handle cases where pthread_attr_getstack() behaves
	incorrectly (bug #78096).

Mon Sep 11 11:31:10 BST 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: support larger stack frames (bug #79272).

2006-09-08  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_class_from_name): Remove a debug printf.

	* aot-compiler.c: Add a hash table to the AOT file mapping class names to typedef 
	tokens.

	* aot-runtime.c (mono_aot_get_class_from_name): New function used by 
	mono_class_from_name () to find a class from its name.

	* mini.c (mini_init): Register mono_aot_get_class_from_name () with the runtime.

2006-09-07  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (emit_call): Avoid strstr () call if possible.

2006-09-05  Kornél Pál  <kornelpal@gmail.com>

	* Makefile.am: Renamed mono-1.dll to mono.dll. (-avoid-version)

2006-09-04  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_icall_get_wrapper): Fix a race condition on initializing
	callinfo->trampoline.

	* mini-amd64.c (emit_call): Special case calls to the vararg array icalls. Hopefully
	fixes #79271.
	(mono_arch_patch_code): Add some debug code to help track down similar failures in the
	future.

2006-09-03  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_plt_resolve): Add an assert.

2006-09-02  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c (mono_arch_create_specific_trampoline): Don't increase
	stats.method_trampolines, it is already done by the generic trampoline code.

	* tramp-amd64.c (mono_arch_create_specific_trampoline): Ditto.
	
2006-09-01  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Remove some references to mono_compile_aot, and use cfg->compile_aot instead.

	* aot-runtime.c: Add some tweaks to the MONO_AOT_CACHE functionality.

	* tramp-amd64.c (mono_arch_create_specific_trampoline): Fix a FIXME.

	* mini.c (print_jit_stats): Print mscorlib mempool size too.
	
	* mini.c (print_jit_stats): Print new stats.

	* *-alpha.c: More alpha port work from Sergey Tikhonov <tsv@solvo.ru>.

2006-08-31  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_get_ldelema_ins): Fix verifier error when calling
	Address on two dimensional arrays. Fixes #78729.

	* mini.h (MonoCompile): Add a 'skip_visibility' field.

	* mini.c (method_to_ir): Disable visibility checks if skip_visibility is set on
	a method.

	* mini-amd64.c (mono_arch_emit_exceptions): Fix assertion introduced by the last change.

	* mini.c (mono_runtime_cleanup_handlers): Clean up signal handlers on unix. Fixes
	#79130.
	
	* mini.c (handle_array_new): Applied patch from "briaeros007". Fix
	a race condition.
	(mini_get_ldelema_ins): Ditto.

2006-08-30  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_exceptions): Align fp constants to 16 bytes.
	(mono_arch_output_basic_block): Avoid unaligned accesses in FNEG implementation. 
	Fixes #79213.

2006-08-29 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c, mini-s390x.c: Fix VARARG case processing with 0 arguments. Add
	mono_arch_get_patch_offset as a dummy entry point to allow successful link. 

	* exceptions-s390x.c: Cosmetic change.

	* tramp-s390.c: Fix warning.

	* cpu-s390.md: Correct length of mul_imm.

Wed Aug 23 19:24:00 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* aot-compiler.c: added binary writer with ELF backend
	implementation (only on Linux/x86 for now).

2006-08-18  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am: Don't run net 2.0 AOT tests.

	* aot-compiler.c (compile_method): Skip methods with tail calls as well.
	(mono_compile_assembly): Skip net 2.0 assemblies as well.

	* aot-runtime.c (load_patch_info): Fix an uninitialized memory error.

Fri Aug 18 19:38:28 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* aot-compiler.c: simplified and refactored the asm-writing code
	to allow different backends.

2006-08-18  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MONO_AOT_FILE_VERSION): Bump AOT file format version.

	* aot-compiler.c aot-runtime.c: Reorg the GOT slot allocation code a 
	little. Share patches of type TYPE_FROM_HANDLE as well.

	* mini.c (mono_patch_info_equal): New helper function.
	(mono_patch_info_hash): Ditto.

	* aot-compiler.c (emit_method_code): Fix s390 build.

	* mini.c (mono_allocate_stack_slots_full): Fix yet another place where byref
	is not handled because it is stored as a flag and not as a type ctor. Fixes
	#79016.

2006-08-17  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Fix computation of GOT slot statistics.
	
	* aot-compiler.c aot-runtime.c: Implement sharing of GOT slots for classes/fields.
	Also remove support for not PIC AOT.

	* mini.h: Bump AOT file format version.

	* objects.cs: Add a test for #78990.

	* mini-x86.c (mono_arch_output_basic_block): Applied patch from Peter Dettman
	(peter.dettman@iinet.net.au). Fixes #79087.

	* basic-long.cs: Add a test for the above.

2006-08-16  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (get_got_offset): Add a cache for GOT entries, not yet used.
	
	* aot-compiler.c (get_plt_index): Add a cache for wrappers too. Simplify the
	code somewhat.

2006-08-15  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_init): Fix registration of idiv/imul opcodes which can throw
	exceptions.

2006-08-10  Jonathan Chambers  <joncham@gmail.com>

	* mini.c: Don't verify COM proxy invoke calls
	

2006-08-10  Dick Porter  <dick@ximian.com>

	* wapihandles.c (mini_wapi_seminfo): More info, to help track down
	which process is holding semaphores locked.

2006-08-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c mini-amd64.c: Fix #79027.

	* mini-sparc.c (mono_arch_call_opcode): Fix the previous patch.

	* mini-sparc.c (mono_arch_call_opcode): Fix #79027.

	* mini-x86.c (mono_arch_call_opcode): Handle the case where there are no
	implicit arguments in a vararg call. Fixes #79027.

2006-08-07  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_get_element_address_signature): Use CDECL calling convention on windows. Fixes #78969.
	(mono_get_array_new_va_signature): Ditto.

2006-08-05  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c: Call init_plt lazily.

	* inssel-long.brg: Fix unsigned long->int conversion.

	* aot-runtime.c (init_plt): Remove a redundant make_writable () call.

	* aot-compiler.c aot-runtime.c: Reorganize the file structure in the amd64 case so
	that most data is now in the .rss/.data section.

2006-08-04  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Correct the computation of the 'direct-calls' statistic.	

	* aot-compiler.c: Print the number of methods without GOT slots as a statistics.

	* aot-compiler.c aot-runtime.c tramp-amd64.c: Resurrect amd64 AOT support.

	* tramp-amd64.c (mono_arch_patch_callsite): Fix a warning.

	* jit-icalls.c (mono_helper_compile_generic_method): Unbox vtypes since this is a
	virtual call. Fixes #79010.

	* mini.c (mono_method_to_ir): Pass an additional out arg to compile_generic_method 
	and use the result as the this argument in the real call.

	* generics.2.cs: Add a new test for #79010.
	
2006-08-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c: Fix a warning.

	* aot-compiler.c: Add a bunch of statistics.

	* mini.c (inline_method): Disable inlining in out-of-line bblocks.

2006-08-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-arch.h Makefile.am mini-ops.h mini-codegen.c: More alpha updates.

2006-08-01  Zoltan Varga  <vargaz@gmail.com>

	* cpu-alpha.md inssel-alpha.brg mini-alpha.h mini-alpha.c exceptions-alpha.c tramp-alpha.c: More alpha port work from Sergey Tikhonov <tsv@solvo.ru>.

2006-07-13  Miguel de Icaza  <miguel@novell.com>

	* mini.c (mono_method_to_ir): Obtain the original method in the
	CIL stream and use this to perform validation.

	Fixed: #78816

2006-07-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_get_argument_info): Fix a warning.
	(mono_arch_call_opcode): Ditto.

	* mini.c (mono_method_to_ir): Clear ins_flag at the end of CEE_CALL. Fixes
	#78826.

	* mini.c (mono_patch_info_dup_mp): New helper function.
	
	* aot-compiler.c (compile_method): Fix some of the memory allocated during
	compilation. Fixes #78827.

2006-07-18  Kornél Pál  <kornelpal@gmail.com>

	* declsec.c: Use original security informations for
	  MONO_WRAPPER_MANAGED_TO_MANAGED.

2006-07-15  Jonathan Chambers  <joncham@gmail.com>

	* mini.c: Allow Com Interop methods/classes and
	don't verify COM wrapper calls
	

2006-07-13  Zoltan Varga  <vargaz@gmail.com>

	* inssel-long32.brg: Fix long->i4 checked conversion.

	* exceptions.cs: Add a test for the above.

2006-07-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_setup_altstack): Fix a memory leak.

	* mini.c: Applied patch from Joachim Ante (joe@otee.dk). Fix some shutdown 
	leaks.

	* helpers.c (mono_disassemble_code): Avoid using fixed temporary files. Fixes
	#78775.

2006-07-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Fix solaris/x86 exception handling.

	* Makefile.am: Get rid of $(ICU_LIBS).

2006-07-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c: Fix handling of unhandled SIGSEGV exceptions on ia64.
	(ves_icall_System_Security_SecurityFrame_GetSecurityStack): Use MONO_INIT_CONTEXT_FROM_CURRENT.
	(ves_icall_System_Security_SecurityFrame_GetSecurityFrame): Ditto.

	* mini-ia64.h (MONO_CONTEXT_SET_FUNC): New macro.

	* mini-exceptions.c (mono_handle_native_sigsegv): Prevent infinite loops if
	this function causes a SIGSEGV.

2006-06-22  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Remove unused solaris/x86 includes.

2006-06-21  Zoltan Varga  <vargaz@gmail.com>

	* jit.h: Add G_BEGIN_DECLS/G_END_DECLS.

2006-06-20  Jb Evain  <jbevain@gmail.com>

	* cpu-g4.md: fix max length of start_handler instruction.

2006-06-20  Massimiliano Mantione  <massi@ximian.com>
	* simple-cee-ops.h, simple-mini-ops.h: Fixed bug 78656.

2006-06-16  Massimiliano Mantione  <massi@ximian.com>
	* ssa.c: Fixed bug 78653 for SSA based deadce.
	* mini.h: added MONO_INST_DEFINITION_HAS_SIDE_EFFECTS flag go
	MonoInst.flags, used in SSA based deadce.
	* aliasing.c: Fixed bug 78653 for "fastpath" deadce.
	* simple-cee-ops.h, simple-mini-ops.h: Fixed bug 78653.

Thu Jun 15 16:52:46 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* tramp-ppc.c: don't use malloc () for trampoline code, sometimes
	it can end up using non executable memory on ppc64 systems
	running ppc32 userspace (fix from Johannes Berg).

2006-06-14  Dick Porter  <dick@ximian.com>

	* wapihandles.c: Fix a bunch of signed/unsigned warnings from gcc
	4.1.1

2006-06-13  Massimiliano Mantione  <massi@ximian.com>
	* mini.c: Made so that inline is locally disabled if it would
	trigger a .cctor, because too many apps depend on this behavior
	(which seems to be also the one of the MS CLR).

2006-06-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_emit_stack_alloc): Fix initialization of localloc'ed memory.
	No idea why this worked before.

	* branch-opts.c (mono_branch_optimize_exception_target): Avoid branches
	which branch to outer exception clauses since they could skip the
	inner finally clauses. Fixes #78633.

	* exceptions.cs: Add a test for the above.

	* mini.c (merge_basic_blocks): Nullify the branch at the end of the first bb.
	Fixes #78629.

	* iltests.il: Add a test for the above.

2006-06-12  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (remove_block_if_useless): Do not remove the bblock immediately
	after the end of a try bblock, to prevent asserts in mini_method_compile ().

	* iltests.il: Add a test for the above.

2006-06-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_lowering_pass): Remove some code duplication.
	
	* mini-ia64.c inssel-ia64.brg: Implement the new net 2.0 Interlocked.Add
	methods as instrinsics.

2006-06-09  Wade Berrier <wberrier@novell.com>

	* Makefile.am: Fix sources list for svn rename so that make dist succeeds
	(simple-cee-ops.h ssapre-mini-ops.h)

2006-06-09  Neale Ferguson <neale@sinenomine.net>

	* mini-exceptions.c (ves_icall_get_frame_info): Fix this function on s390/s390x.
	* mini-s390x.c, mini-s390.c: Correct ATOMIC operations (incorrect register for CS
	instruction).
	* mini-s390x.h, mini-s390.h: Simplify MCONTEXT_GET_BP.
	* cpu-s390x.md: Fix max. length values for a couple of instructions.

2006-06-09  Jonathan Chambers  <jonathan.chambers@ansys.com>

	* mini-exceptions.c: Minor fix for building mono in Visual Studio.

2006-06-08  Massimiliano Mantione  <massi@ximian.com>

	* ssapre-cee-ops.h: Renamed as "simple-cee-ops.h"
	* simple-cee-ops.h: Was "ssapre-cee-ops.h" (renamed).
	* ssapre-mini-ops.h: Renamed as "simple-mini-ops.h"
	* simple-mini-ops.h: Was "ssapre-mini-ops.h" (renamed).
	* local-propagation.c: In mono_cprop_invalidate_values use a whitelist
	of opcodes, so that bug 78549 should not happen again.
	* ssapre.c: Updated to use the renamed files.

2006-06-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Fix a wrong reg-reg move 
	in OP_ATOMIC_EXCHANGE_I4.

2006-06-07  Wade Berrier <wberrier@novell.com>

	* tramp-s390.c: Fix s390 build (add missing pointer declarations 
	in mono_debugger_create_notification_function)

2006-06-06  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (NEW_AOTCONST_TOKEN): Fix amd64 build.
	
	* mini.c (type_from_stack_type): Disable some changes which do not
	seem to work.

	* driver.c: Reenable opts.

	* mini.h (MonoStackSlot): New structure to keep track of the verification state
	of the evaluation stack.
	
	* mini.h (MonoBasicBlock): Add a 'stack_state' field to keep track of the
	evaluation stack trace at entry to the bblock.

	* mini.c (merge_stacks): New function to perform verification of stack merges.
	Turned off by default.

	* mini.c: Fill up ins->klass for instructions whose type is STACK_OBJ or
	STACK_MP.
	
2006-06-06  Massimiliano Mantione  <massi@ximian.com>

	* local-propagation.c: Fixed bug 78549.

2006-06-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (ves_icall_get_frame_info): Fix this function on ia64.

2006-06-02  Miguel de Icaza  <miguel@novell.com>

	* tramp-sparc.c, tramp-ppc.c, tramp-s390.c, tramp-s390x.c,
	tramp-arm.c, tramp-ia64.c
	(mono_debugger_create_notification_function): Update signature to
	new signature and use new protocol for creating the notification
	function.  

	Should fix the build.

2006-06-02  Geoff Norton  <gnorton@customerdna.com>

	* exceptions-ppc.c (mono_jit_walk_stack)
	(ves_icall_get_frame_info): Fix the build

2006-06-02  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_set_defaults): Fix the handling of -O=-all.

2006-05-31  Raja R Harinath  <rharinath@novell.com>

	* il2tests.2.il: New file for generics CIL tests.  Add test for
	#78019.
	* Makefile.am: Update.

	Fix #78019
	* mini.c (mono_method_to_ir): Don't apply box+brtrue optimization
	to nullable types.

2006-05-30  Massimiliano Mantione  <massi@ximian.com>

	* aliasing.c: Fixed bug 78311.

2006-05-29  Martin Baulig  <martin@ximian.com>

	* mini-exceptions.c (mono_find_jit_info): When computing the
	native offset, check whether we're actually inside the method's
	code; call mono_debug_print_stack_frame() to format the frame.
	(ves_icall_System_Exception_get_trace): Call
	mono_debug_print_stack_frame() to format the stack frame.
	(ves_icall_get_trace): Update to the new debugging API.
	(mono_jit_walk_stack_from_ctx): Likewise.
	(ves_icall_get_frame_info): Likewise.

	* mini.c (get_method_from_ip): Use the new debugging API.
	(mono_print_method_from_ip): Likewise.

	* exceptions-ppc.c
	(mono_jit_walk_stack): Use the new debugging API.
	(ves_icall_get_frame_info): Likewise.	

2006-05-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Fix MONO_PROFILE_COVERAGE.

2006-05-25  Massimiliano Mantione  <massi@ximian.com>

	* mini.c: Added "limitator" to inline for debugging.

2006-05-24  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c (mono_debugger_init): Create a private,
	malloc()-based code manager for the notification function and
	intentionally leak it on exit.  This fixes the crash-on-exit race
	condition.

	* tramp-amd64.c
	(mono_debugger_create_notification_function): Added
	`MonoCodeManager *' argument.

	* tramp-x86.c
	(mono_debugger_create_notification_function): Added
	`MonoCodeManager *' argument.

2006-05-23  Massimiliano Mantione  <massi@ximian.com>

	* aliasing.c: Fixed 64 bit issue.
	* driver.c: Enabled inline,consprop,copyprop,treeprop,deadce by
	default since all known bugs are fixed (one more time!).

Tue May 23 13:47:28 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: write barrier support.

2006-05-23  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c: Revert Paolo's change.  Add comment and #error
	check at the top of the file.

Sun May 21 12:22:29 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* debug-debugger.c: fix the build. Again. Hopefully Martin will stop
	reverting changes without reason and without changelog entries.

2006-05-18  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (mono_arch_output_basic_block): Add support for large stack offets
	to a few opcodes. Fixes #78439.

	* mini-sparc.c: Rename mono_sparch_break () to mono_arch_break () to improve
	consistency with other archs.

	* mini-ia64.c (mono_arch_emit_prolog): Remove debug stuff left in by mistake.

Wed May 17 18:07:33 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* debug-debugger.c: fix the build.

2006-05-17  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c
	(debugger_thread_vtable): Moved here from ../metadata/threads.c.
	(debugger_init_threads): Formerly known as mono_debugger_init_threads().
	(debugger_finalize_threads): Formaly known as mono_debugger_finalize_threads().
	(debugger_attach): Call GC_mono_debugger_add_all_threads().

2006-05-11  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_init): Call pthread_attr_destroy () to fix a small memory leak.

2006-05-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_instrument_epilog): Fix handling of 
	MONO_TYPE_GENERICINST.
	
	* mini-amd64.c (mono_arch_instrument_epilog): Fix handling of 
	MONO_TYPE_GENERICINST.

2006-05-09  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_get_vcall_slot_addr): Add a missing call sequence. Fixes
	#78325.

2006-05-08  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_create_jump_trampoline): Allocate MonoJitInfo from the domain
	mempool.
	(mono_jit_free_method): Remove the method from jump_trampoline_hash as well.

2006-05-06  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_cleanup): Applied patch from Joachim Ante (joe@otee.dk). Call
	mono_trace_cleanup ().

	* iltests.il: Fix problem with the newly added test.

	* mini-codegen.c (mono_local_regalloc): When changing the dreg of an instruction
	due to register constraints, free up the previous hreg. Fixes #78314.

	* iltests.il: Add new test for #78314.	

	* mini-x86.c (mono_arch_get_inst_for_method): Use OP_ATOMIC_ADD_NEW_I4 for
	Interlocked.Add. Fixes #78312.

	* mini-amd64.c (mono_arch_get_inst_for_method): Ditto.
	
2006-05-05  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg (mini_emit_virtual_call): Fix a warning.

2006-05-05  Martin Baulig  <martin@ximian.com>

	* debug-mini.c (mono_debug_open_block): New method.

	* mini-amd64.c
	(mono_arch_output_basic_block): Call mono_debug_open_block() at
	the beginning of each basic block.

	* mini-x86.c
	(mono_arch_output_basic_block): Call mono_debug_open_block() at
	the beginning of each basic block.

2006-05-04  Massimiliano Mantione  <massi@ximian.com>

	* driver.c: Disabled inline,consprop,copyprop,treeprop,deadce by
	default until I understand why they break the build on amd64.

2006-05-04  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_cleanup): Call mono_cleanup ().

	* mini.c (UNVERIFIED): New macro to make it easier to track down verification
	errors.

2006-05-04  Massimiliano Mantione  <massi@ximian.com>

	* aliasing.c: Fixed shameful cut&paste error that caused JIT crashes.
	* driver.c: Enabled inline,consprop,copyprop,treeprop,deadce by
	default since all known bugs are fixed, and I cannot reproduce bug
	77944... I'm asking Matt Hargett to test again after this commit.

2006-04-28  Massimiliano Mantione  <massi@ximian.com>

	* mini-codegen.c: Fixed typo that thrashed inline.

2006-04-28  Zoltan Varga  <vargaz@gmail.com>

	* dominators.c (compute_dominators): Avoid using a worklist since
	it is not correct in some cases. Instead, iterate over all bblocks as
	in the original paper. Fixes --compile-all -O=all System.Xml.dll.

2006-04-28  Miguel de Icaza  <miguel@novell.com>

	* mini.c (mono_jit_compile_method_inner): Use
	mono_prepare_exception_from_error that resets the value
	internally.

2006-04-27  Miguel de Icaza  <miguel@novell.com>

	* mini.c: Move the mini_loader_error_to_exception to metadata. 
	
2006-04-27  Massimiliano Mantione  <massi@ximian.com>

	* aliasing.c: Fixed bug 78210.

2006-04-27  Massimiliano Mantione  <massi@ximian.com>

	* driver.c: Disabled inline,consprop,copyprop,treeprop,deadce by
	default until all their problems (or the ones they trigger) are fixed.

2006-04-26  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_method_from_token_inner): Fix the previous patch.
	
	* aot-runtime.c (mono_aot_get_method_from_token_inner): Mark the method
	as loaded only after resolving patches since that could invoke the same method.

	* aot-runtime.c (mono_aot_plt_resolve): Fix ppc etc. builds.

	* aot-compiler.c: Refactor mono_aot_compile_aot () into a bunch of smaller
	functions.

	* aot-runtime.c (init_plt): Use a normal trampoline to transfer code to the
	AOT loader.

	* aot-compiler.c (emit_plt): Pass the plt offset in %eax instead of on the
	stack.

	* mini-trampolines.c (mono_aot_plt_trampoline): New trampoline to handle calls
	made from AOT code through the PLT table.

	* mini-x86.h mini-amd64.h: Define MONO_ARCH_AOT_PLT_OFFSET_REG to the register
	holding the plt offset when a call is made to the aot plt trampoline.
	
2006-04-25  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c aot-compiler.c cpu-amd64.md mini-amd64.c: Update parts of the 
	amd64 AOT support.

	* Makefile.am (common_sources): Fix build breakage.

	* aot-runtime.c aot-compiler.c: Reorganize the AOT code yet again: Make all
	calls through a jump table similar to the ELF PLT table. Avoid indirect calls for
	intra-assembly calls if possible.
	
	* tramp-*.c: Add new functions for patching/nullifying PLT entries.

	* mini-trampolines.c: Handle PLT entries.

	* mini.c: Avoid creating a GOT var for calls.

	* jit-icalls.c (helper_ldstr_mscorlib): New helper function for loading strings
	from mscorlib code.

	* jit-icalls.c (helper_newobj_mscorlib): New helper function to create objects
	from mscorlib code.

	* mini.c (mono_method_to_ir): Use the new helper functions in throw bblocks in
	AOT code.	

	* mini.h: Bump AOT file format version.
	
	* mini.c (get_basic_blocks): Fix the calculation of bb->out_of_line so it
	covers more cases.

2006-04-25  Martin Baulig  <martin@ximian.com>

	* driver.c: Disable copyprop, consprop and inline when running
	inside the debugger.

2006-04-25  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h (MonoDebuggerInfo): Replaced `get_thread_id'
	with `get_current_thread' and added `detach'.
	(MonoDebuggerMetadataInfo): Added `thread_size',
	`thread_tid_offset', `thread_stack_ptr_offset' and
	`thread_end_stack_offset'.

2006-04-25  Zoltan Varga  <vargaz@gmail.com>

	* aot.c Makefile.am: Split aot.c into two new files aot-compiler.c and 
	aot-runtime.c.

	* inssel.brg (mini_emit_load_intf_reg_vtable): Use a new kind of AOT constant
	ADJUSTED_IID to avoid the need for adjusting the IID at runtime.

	* mini.h (MonoJumpInfoType): Add MONO_PATCH_INFO_ADJUSTED_IID.

	* mini.c (mono_resolve_patch_target): Handle ADJUSTED_IID.

	* aot.c: Add support for ADJUSTED_IID.	

2006-04-24  Zoltan Varga  <vargaz@gmail.com>

	* aot.c (emit_method_order): Don't align method_order_end.

	* inssel.brg (stmt): Fix interface calls in AOT code which got broken by
	the interface ID changes.

2006-04-21  Dick Porter  <dick@ximian.com>

	* mini.c (mini_thread_cleanup): Clear the JIT TLS data when
	cleaning up a thread.  Fixes the new part of bug 77470.

2006-04-20  Geoff Norton  <gnorton@customerdna.com>

	* mini-ppc.c: Call mono_jit_thread_attach when transitioning a native
	to managed wrapper.
                     
2006-04-19  Zoltan Varga  <vargaz@gmail.com>

	* mini.h mini.c: Remove mono_type_to_ldind/stind () which are now in marshal.c.
	
	* mini.c (mono_runtime_install_handlers): Handle SIGABRT similarly to
	SIGSEGV. Fixes #78072.

	* mini-exceptions.c (mono_handle_native_sigsegv): Add a 'signal' argument,
	unregister our SIGABRT handler.

2006-04-19  Massimiliano Mantione  <massi@ximian.com>

        * mini.c: Disabled inline where it can alter the call stack in a
	way visible from managed code.
	* driver.c: enabled inline,consprop,copyprop,treeprop,deadce by
	default.

2006-04-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_prolog): Attach the thread to the runtime as it is done
	on other platforms. Fixes #78089.

2006-04-13  Martin Baulig  <martin@ximian.com>

	* driver.c: Also check a `MONO_INSIDE_MDB' environment variable to
	determine whether we're inside the debugger.

	* debug-debugger.h
	(MonoDebuggerMetadataInfo): Added all offsets from `MonoDefaults'.

2006-04-12  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Handle multiple LEAVE statements inside a single
	handler clauses. Fixes #78024.

	* mini-sparc.c (mono_arch_output_basic_block): Handle large offsets
	in the CALL_MEMBASE opcodes. Fixes #78088.
	(mono_arch_get_vcall_slot_addr): Ditto.

2006-04-10  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c: The thread handling code has now been moved
	into ../metadata/threads.c.

2006-04-10  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_main): Fix --with-gc=none build.

	* mini-codegen.c (mono_spillvar_offset): Improve alignment.
	(mono_spillvar_offset_float): Ditto.
	(mono_local_regalloc): Only do the OP_MOVE optimization if ins->dreg is a local
	hreg, not when its !global, since on ia64, there is a third category: stacked
	registers.	

Mon Apr 10 14:39:49 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: set MonoInst->klass for load field address and a few other
	places.

2006-04-10  Zoltan Varga  <vargaz@gmail.com>

	* helpers.c (mono_disassemble_code): Emit debug info on amd64 as well.

2006-04-07  Zoltan Varga  <vargaz@gmail.com>

	* dominators.c (compute_dominators): Fix yet another bug which surfaced after
	the branch opt changes.

2006-04-06  Dick Porter  <dick@ximian.com>

	* wapihandles.c (mini_wapi_semdel): Fix parameters in semctl () call.
	
	* wapihandles.c (mini_wapi_seminfo): 
	* driver.c (mono_main): Add semaphore info option

2006-04-05  Zoltan Varga  <vargaz@gmail.com>

	* dominators.c (compute_dominators): Fix a bug which surfaced after the recent
	branch optimization changes. Fixes #78009.

Wed Apr 5 16:40:33 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: ignore accessibility of methods in managed->native wrappers.

2006-04-04  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_cleanup): Call print_jit_stats () earlier since it accesses metadata.
	
	* mini.c (mini_cleanup): Free 'emul_opcode_map' as well.

2006-04-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Modify the branch optimizations to preserve the invariant that
	the entries inside the in_bb and out_bb arrays are unique.
	(mono_unlink_bblock): Avoid creation of new arrays.

2006-04-02  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_unlink_bblock): Fix regression caused by previous
	change (#77992).

2006-04-01  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (optimize_branches): Remove the "optimizations" in
	the cbranch1/cbranch2 -> branch cases which were causing several
	problems in the past. Fixes #77986.

2006-03-31  Chris Toshok  <toshok@ximian.com>

	* driver.c (DEFAULT_OPTIMIZATIONS): back out the new set of
	default optimizations :(

2006-03-31  Zoltan Varga  <vargaz@gmail.com>

	* inssel-x86.brg mini-codegen.c mini.c: Merge some changes/fixes from linear-il
	branch.

2006-03-31  Massimiliano Mantione  <massi@ximian.com>

        * local-propagation.c: Added comments to structs and removed
	"Mono" prefixes from local tree mover types.

2006-03-30  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (arch_sources): Define this for each architecture so 
	libmono_la_SOURCES is defined in one place.

Wed Mar 29 20:51:14 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c, wapihandles.c, Makefile.am: integrate the io-layer utils
	from handles/.

Wed Mar 29 17:16:57 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c: print the GC name supplied by configure.

2006-03-29  Massimiliano Mantione  <massi@ximian.com>

        * local-propagation.c: Added tree mover, and moved here all the
	local propagation code from mini.c
        * mini.c: Added support for treeprop, and moved all the	local
	propagation code to local-propagation.c
        * mini.h: Added support for treeprop
        * driver.c: Added support for treeprop, enabled consprop, copyprop,
	treeprop, inline and deadce by default
        * Makefile.am: Added local-propagation.c

2006-03-25  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-sparc.c: Applied patch from David S. Miller  <davem@sunset.davemloft.net>: Implement correct support for sparc/linux.

Fri Mar 24 20:07:19 CET 2006 Paolo Molaro <lupus@ximian.com>

	* debug-debugger.c: make it compile without the Boehm GC.

Wed Mar 22 18:25:18 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: fixed issue with mismatch when an icall is registered
	with multiple names but same address.

Tue Mar 21 15:59:57 CET 2006 Paolo Molaro <lupus@ximian.com>

	* declsec.c, mini-exceptions.c: use write barrier to set reference
	fields of managed objects.

2006-03-19  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_print_method_from_ip): Recognize JIT trampolines as well.
	(can_access_internals): Fix a warning.

	* mini.c (print_method_from_ip): Rename this to 
	mono_print_method_from_ip so it gets exported.

	* trace.c: Deal with strings inside StringBuilder's containing garbage
	and fix memory leaks. Fixes #77848.

2006-03-19  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_init): Disable the setting of GC_stackbottom on ia64. Hopefully
	fixes #77787.

2006-03-16 Neale Ferguson <neale@sinenomine.net>
	
	* mini-s390.c: Remove OP_X86_TEST_NULL.

Thu Mar 16 17:19:04 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: use the correct GetHashCode() for the moving collector.

2006-03-16  Massimiliano Mantione  <massi@ximian.com>

        * liveness.c: Regalloc spill cost tuning.

2006-03-15 Neale Ferguson <neale@sinenomine.net>
	
	* mini-s390x.h: Correct S390_LONG macro.

	* mini-s390x.c: Cleanup unused code.

2006-03-15  Zoltan Varga  <vargaz@gmail.com>

	* jit-icalls.h: New file.

	* Makefile.am mini.c jit-icalls.c: Use a proper include file for the jit
	icalls and include that instead of including jit-icalls.c.

	* mini-ppc.c (mono_arch_output_basic_block): Remove references to
	OP_X86 opcodes.

Tue Mar 14 20:23:53 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: when checking for member accessibility, also check for
	friend assemblies and for explicit interface implementations.

2006-03-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_local_regalloc): Remove incorrect g_free () calls.

	* cpu-arm.md cpu-g4.md: Remove x86_ opcodes.

	* mini-x86.h (MONO_ARCH_INST_FIXED_REG): Reorganize the comparisons so
	common cases are done first.	

	* mini-ops.h: Only define platform specific opcodes on the given platform.

	* mini.h regalloc.h mini-codegen.c: Merge optimizations from the linear-il
	branch.
	
2006-03-14  Martin Baulig  <martin@ximian.com>

	Revert Paolo's change from r57348:

	* mini.h: don't use gboolean for bitfields.
	* mini.c: verifier changes for fields and methods accessibility.

2006-03-13  Neale Ferguson <neale@sinenomine.net>

	* mini-s390.h, mini-s390x.h: Fix calls to mono_call_inst_add_outarg_reg.

	* mini-s390x.c: Fix conv_r_un.

	* cpu-s390, cpu-s390x.md: Fix lengths.

Sun Mar 12 17:31:22 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: nested types have access to all the nesting
	levels, not just the enclosing types.

Sun Mar 12 16:23:11 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: added a few more verification checks.

2006-03-12  Zoltan Varga  <vargaz@gmail.com>

	* liveness.c: Merge optimizations from the linear-il branch.

2006-03-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (emit_call): Add a comment.

	* tramp-ia64.c (mono_arch_patch_callsite): Handle indirect calls as well.

	* tramp-ia64.c: Fix some warnings.

Sat Mar 11 20:15:59 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h: don't use gboolean for bitfields.
	* mini.c: verifier changes for fields and methods accessibility.

2006-03-11  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_icall_get_wrapper): Fix an ia64 bug introduced by the
	lazy icall wrapper changes.

	* dominators.c: Replace all the dominator algorithms with faster
	ones from the linear-il branch.

	* inssel-*.brg: Allocate call->out_ireg_args and call->out_freg_args from
	the mempool.

	* mini-amd64.h (MONO_ARCH_INST_FIXED_REG): Reorganize the comparisons so
	common cases are done first.

	* mini-amd64.c: Fix some warnings.

	* mini-codegen.c mini-*.c: Allocate call->out_ireg_args and call->out_freg_args
	from the mempool.

	* mini.c (mono_jit_compile_method_with_opt): Fix a race in the newly
	added code.

	* mini.h: Add a missing prototype.

2006-03-10  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Compile icall wrappers lazily.

	* mini-codegen.c: Use printf instead of g_print since its much faster.

	* mini.h (mono_bitset_foreach_bit): Use the faster mono_bitset_find_start ()
	function.

	* mini.c (optimize_branches): Cache the negative result from 
	remove_block_if_useless ().

	* mini.c (optimize_branches): Avoid restarting the iteration after each change.	
	Also fix some bblock linking issues.

	* helpers.c (mono_disassemble_code): Reduce the size of the temporary
	assembly files.

	* mini.h: Define G_LIKELY/G_UNLIKELY macros for older glib versions.

	* mini.h (MonoBasicBlock): Reorganize the fields, putting more frequently
	accessed fields first, for better cache behavior.
	
Fri Mar 10 18:21:41 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: speedup IList<T> array accesses.

2006-03-09  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Handle large methods overflowing the 
	inline_costs counter. Fixes #77190.

2006-03-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c: Call mono_trace_is_enabled () before printing
	trace messages. Fixes #77706.

2006-03-04  Martin Baulig  <martin@ximian.com>

	* tramp-amd64.c, tramp-x86.c
	(mono_debugger_create_notification_function): Use
	mono_global_codeman_reserve() to allocate a buffer at runtime and
	return it.

	* debug-debugger.h (MonoDebuggerInfo): Added `initialize'.

	* debug-debugger.c (mono_debugger_init): Dynamically allocate the
	notification function at runtime and then call `initialize' in the
	`MONO_DEBUGGER__debugger_info' vtable.

2006-03-04  Zoltan Varga  <vargaz@gmail.com>

	* iltests.il: Fix a visibility problem.

Wed Mar 1 15:55:25 CET 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c, mini.c: add hooks for the counters API.

Wed Mar 1 12:28:04 CET 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c: show disabled options.

Wed Mar 1 12:18:51 CET 2006 Paolo Molaro <lupus@ximian.com>

	* linear-scan.c: always use cost-driven selection.

2006-02-28  Raja R Harinath  <rharinath@novell.com>

	* jit-icalls.c (helper_compile_generic_method): Revert change from
	2006-02-24.

Mon Feb 27 18:58:19 GMT 2006 Paolo Molaro <lupus@ximian.com>

	* cpu-arm.md, mini-arm.c: implemented MemoryBarrier.

Sat Feb 25 17:39:21 CET 2006 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: style fixes, mostly to force the updated monoburg
	to run for people using svn.

Sat Feb 25 17:07:42 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: match monoburg changes.

Sat Feb 25 16:04:33 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini.c, abcremoval.c, aliasing.c, liveness.c,
	ssapre.c, graph.c, ssa.c: put the mono_burg_arity[]
	declaration in the header file.

Sat Feb 25 14:19:31 CET 2006 Paolo Molaro <lupus@ximian.com>

	* helpers.c: reduce relocations and mem usage.

Sat Feb 25 11:58:16 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-codegen.c: disable logging features if
	requested by configure.

Sat Feb 25 11:54:49 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: tiny verifier changes.

Fri Feb 24 18:17:52 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ops.h, inssel-x86.brg, tramp-x86.c, mini-x86.c,
	cpu-pentium.md: stack alignment changes for osx/x86,
	partially from Geoff Norton <gnorton@customerdna.com>.

2006-02-24  Raja R Harinath  <harinath@gmail.com>

	* jit-icalls.c (helper_compile_generic_method): Update to changes
	in metadata/class.c.

2006-02-24  Zoltan Varga  <vargaz@gmail.com>
	
	* mini-amd64.c (mono_arch_get_vcall_slot_addr): Add a missing check.
	
	* mini-amd64.c (mono_arch_get_vcall_slot_addr): Add support for
	interface calls with large offsets.

2006-02-23  Raja R Harinath  <rharinath@novell.com>

	* jit-icalls.c (helper_compile_generic_method): Document the
	special-case we depend on so that we can inflate the method twice
	with the same context with no bad side-effects.

Thu Feb 23 13:45:46 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c, mini-amd64.c: fix for case when xen support
	is disabled.

Wed Feb 22 19:38:40 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c, mini-amd64.c: generate code to access tls items
	in a faster way for Xen systems.

Wed Feb 22 10:31:25 CET 2006 Paolo Molaro <lupus@ximian.com>

	* exceptions-x86.c, mini-x86.h, driver.c, mini-codegen.c:
	updates and compilation fixes for the OSX/x86 port, mostly from
	Geoff Norton <gnorton@customerdna.com>.

Tue Feb 21 19:56:55 CET 2006 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: faster interface call implementation
	to sync with the interface_offsets MonoVTable changes.

Mon Feb 20 10:37:57 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: more verification checks.

Fri Feb 17 19:47:29 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: added a few more verification checks.

2006-02-17	Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, mini-s390x.h: Check for presence of long displacement
	facility on the processor and use it if available.

Fri Feb 17 16:12:52 CET 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c, aot.c, mini.c: throw exception if the IL code is
	invalid or unverifiable.

2006-02-17  Raja R Harinath  <rharinath@novell.com>

	* generics.2.cs (test_0_ldfld_stfld_mro): Use m.struct_field, not
	m.StructField.

2006-02-16  Zoltan Varga  <vargaz@gmail.com>

	* generics.2.cs: Add some tests for generics ldfld/stfld wrappers.

Wed Feb 15 16:23:17 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-s390x.c, mini-s390.c, mini.c, mini-amd64.c, mini-arm.c,
	mini-ia64.c, mini-sparc.c, mini-x86.c, mini-ppc.c: fixed
	handling of instantiated generic valuetypes.

2006-02-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c mini-x86.h mini-x86.c: Get rid of 
	MONO_INIT_CONTEXT_FROM_CALLER, and use MONO_INIT_CONTEXT_FROM_FUNC
	instead.

	* generics.2.cs: Revert the nullable reftypes tests.

2006-02-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (MONO_INIT_CONTEXT_FROM_CALLER): Avoid
	using __builtin_frame_address (1) as it doesn't work in the presence
	of optimizations. Hopefully fixes #77273.

	* Makefile.am generics.cs generics.2.cs: Revert the generics.2.cs
	-> generics.cs change as it doesn't work with some automake versions.

Thu Feb 9 16:24:44 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: handle systems that sue a different way to
	retrieve the stack address of the current thread.

2006-02-09  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am generics.2.cs: Rename this to generics.cs and handle
	it specially in the makefile.

	* generics.2.cs: Add tests for nullable reference types.

Wed Feb 8 19:33:17 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: always handle the case when mono_jit_init()
	is called in a thread different from the main thread,
	confusing libgc (bug #77309).

Mon Feb 6 09:01:24 EST 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: fix handling of exceptions in large methods (bug #74932).

Fri Feb 3 18:51:35 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: change optimize_branches () to use a single loop
	and introduce a new optimization to simplify some range checks.

2006-02-03  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c (debugger_thread_manager_thread_created): Removed
	and merged with debugger_thread_manager_add_thread().
	(mono_debugger_main): Call debugger_thread_manager_add_thread() to
	inform the debugger about the main thread.

2006-02-03  Zoltan Varga  <vargaz@gmail.com>

	* basic.cs: Add test for div.un/rem.un constant folding.

2006-02-03  Neale Ferguson <neale@sinenomine.net>

	* cpu-s390x.md: correct int_xor_imm length

2006-02-03  Zoltan Varga  <vargaz@gmail.com>

	* generics.2.cs: New test for #77442.

	* jit-icalls.c (helper_compile_generic_method): Check for null. Fixes
	#77442.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* tramp-x86.c, tramp-amd64.c: It's now safe to #include
	<mono/metadata/mono-debug-debugger.h>	

	* debug-mini.c: Don't #define _IN_THE_MONO_DEBUGGER.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h: New header file for debug-debugger.c.

	* debug-debugger.c: Big API cleanup; don't run the managed Main()
	function is a separate thread anymore; add support for attaching.

2006-02-01  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c: Fix a warning.

2006-01-31  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_compute_omit_fp): Avoid hitting an assertion
	on very large methods.

	* aot.c (load_patch_info): Fix a warning.

Mon Jan 30 12:51:10 CET 2006 Paolo Molaro <lupus@ximian.com>

	* cpu-pentium.md, mini-x86.c, inssel.brg, inssel-x86.brg,
	mini-ops.h: alu membase optimizations.

Fri Jan 27 21:11:08 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ops.h, mini.c, inssel.brg, inssel-x86.brg: opcode
	to speedup StringBuilder.

2006-01-27  Zoltan Varga  <vargaz@gmail.com>

	* dominators.c (mono_compute_natural_loops): Fix detection of
	loop body start blocks.

	* mini-exceptions.c (mono_print_thread_dump): Fix non x86 builds.

2006-01-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.h mini.c mini-exceptions.c: Add thread dump support. Fixes
	#75145.

2006-01-25  Massimiliano Mantione  <massi@ximian.com>

        * aliasing.c: Fixed aliasing issue on 64 bit archs.

2006-01-25  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c: Moved the `MonoDebuggerManager' and
	`MonoDebuggerThread' typedefs here from mono-debug-debugger.h and
	started to cleanup this file a little bit.

Tue Jan 24 18:20:48 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: optimize a codepath frequently happening in generics code.

2006-01-23  Martin Baulig  <martin@ximian.com>

	* Makefile.am: Only compile debug-debugger.c on supported platforms.

	* debug-debugger.c: Kill the IO_LAYER() hack and use the io-layer
	functions directly.

	* driver.c: debug-debugger.c is only available if
	`MONO_DEBUGGER_SUPPORTED' is defined.	

2006-01-23  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c: Only enable this on platforms where the Mono
	Debugger is working (x86 and x86_64).

2006-01-21  Martin Baulig  <martin@ximian.com>

	The Mono Debugger is now using the normal `mono' instead of the
	`mono-debugger-mini-wrapper' when executing managed code.

	* debug-debugger.c: New file; previously known as
	debugger/wrapper/wrapper.c.

	* debug-mini.c (mono_init_debugger): Removed.

	* driver.c (mono_main): Added new `--inside-mdb' command line
	argument which is used when running inside the debugger.

2006-01-20  Zoltan Varga  <vargaz@gmail.com>

	* liveness.c (mono_analyze_liveness): Remove some unused data
	structures.

2006-01-17  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Move mono_bitset_test_fast macro to monobitset.h where it belongs.

2006-01-16  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (mono_bitset_test_fast): Disable the 'fast' implementation which
	depends on implementation details of monobitset.

	* mini.c (mini_get_ldelema_ins): Fix handling of 1 dimensional arrays.
	Fixes #77271.

2006-01-15  Zoltan Varga  <vargaz@gmail.com>

	* liveness.c: Update after monobitset changes.

2006-01-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_compute_omit_fp): Fix a leak.

2006-01-11 Neale Ferguson <neale@sinenomine.net>

	* inssel-s390x.brg: Fix reg: OP_LDADDR(OP_S390_LOADARG) register setting.

	* mini-s390x.c: Remove warning messages.

2006-01-11  Ben Maurer  <bmaurer@andrew.cmu.edu>

	* mini.c: pass the jitinfo to mono_profiler_method_end_jit.

2006-01-10  Zoltan Varga  <vargaz@gmail.com>

	* generics.2.cs: Add ldelem/stelem_any test.

2006-01-10 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c: Fix ATOMIC_ADD_I4 operation.

2006-01-07  Zoltan Varga  <vargaz@gmail.com>

	* inssel-long.brg: Fix int->long ovf conversion rules. Fixes #77172.
	
2006-01-06  Zoltan Varga  <vargaz@gmail.com>

	* generics.2.cs: Reenable vtype tests.

	* inssel-x86.brg: Remove an icorrect valuetype rule.

2006-01-06 Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, inssel-s390x.brg, cpu-s390x.md: Fix ATOMIC_I8 operations. Provide
	initial support for OP_ABS.

2006-01-05 Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c (emit_float_to_int): Correct r8 to unsigned int algorithm.

2006-01-05 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c, mini-s390.h, inssel-s390.brg, cpu-s390.md: Fix r8 to unsigned int 
	conversion and implement LADD/LSUB.

	* exceptions-s390.c: Standardize mono_arch_find_jit_info to match other
	architectures.

2006-01-05 Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, mini-s390x.h: Fix r8 to unsigned int conversion.

	* exceptions-s390x.c: Standardize mono_arch_find_jit_info to match other
	architectures.

2006-01-05 Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, mini-s390x.h, mini-s390.c, mini-s390.h: Fix lmf handling when 
	localloc is encountered.  Fixes crash in test-183.cs when using gmcs 
	(stack walk problem).

2006-01-04  Zoltan Varga  <vargaz@gmail.com>

	* aot.c (mono_aot_load_method): Fix a warning.

2006-01-03  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.h, exceptions-s390x.c, inssel-s390x.brg: Fix compiler warnings

2006-01-03  Zoltan Varga  <vargaz@gmail.com>

	* iltests.il: Add test for #77148.

	* mini.c (mini_get_ldelema_ins): Handle arrays with rank 1 too. Fixes
	#77148.

2006-01-03  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, inssel-s390x.brg: Remove debug statements

2006-01-03  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, mini-s390x.h, exceptions-s390x.c, tramp-s390x.c, inssel-s390x.brg,
	cpu-s390x.md, mini-codegen.c, Makefile.am: add 64-bit s390 support to JIT.

	* basic-long.cs: Add lconv-to-r4/r8 tests.

2006-01-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Fix DynamicMethod support in some opcodes.

	* mini-sparc.c (mono_arch_call_opcode): Use mono_class_value_size ()
	here as on other archs.

2005-12-29 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c (mono_arch_get_inst_for_method): Add memory_barrier support.

2005-12-29 Neale Ferguson <neale@sinenomine.net>

	* inssel-s390.brg: Correct register assignment; Rework L[ADD|SUB]_OVF[_UN] for s390.
	
	* cpu-s390.md: Fix lengths of a couple of long instructions; Add memory_barrier.

	* mini-s390.c: Fix long add/sub overflow instructions; Fix displacement handling in
	instrument_prolog; Add memory_barrier instruction.

2005-12-26  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c mini-x86.h: Fix solaris/x86 exception handling.

2005-12-23  Zoltan Varga  <vargaz@gmail.com>

	* tramp-ia64.c (mono_arch_get_unbox_trampoline): Flush icache.

	* aliasing.c inssel.brg: Fix warnings.

	* inssel-ia64.brg (OP_MEMSET): Fix an optimization which previously
	could skip initialization of some parts of memory.

	* mini.c mini-ia64.c: Fix warnings.

	* inssel-sparc.brg: Add an implementation of lneg which actually works.

2005-12-22  Zoltan Varga  <vargaz@gmail.com>

	* aliasing.c (mono_build_aliasing_information): Add a workaround for
	a crash seen on sparc.

	* mini-sparc.c: Add implementation of Thread.MemoryBarrier.
	
	* cpu-sparc.md: Add memory_barrier opcode. Remove unused opcodes.

2005-12-21 Neale Ferguson <neale@sinenomine.net>

	* mini-ops.h: Add s390_backchain instruction

	* inssel-s390.brg: Use backchaining instruction for LOADARG/STKARG operations.

	* cpu-s390.md: Add s390_backchain instruction

	* mini-s390.c: Significant ABI changes

	* mini-s390.h: Cater for zero length structures

2005-12-20 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c: ABI fixes

	* inssel-s390.brg: Remove debug statements

	* cpu-s390.md: Fix length of ATOMIC_xx operations

2005-12-19  Zoltan Varga  <vargaz@gmail.com>

	* basic-float.cs: Add float<->long conversion tests.

2005-12-16 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c: Fix LOCALLOC processing.

	* tramp-s390.c (s390_magic_trampoline): Fix base calculation.

2005-12-15  Zoltan Varga  <vargaz@gmail.com>

	* iltests.il: Add tests for some opcodes not covered by the other
	tests.

2005-12-15 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c: Fix ADDCC/SBB bug revealed by test_0_ulong_regress; Correct 
	register loading for Tail processing; Correct trace output.

	* inssel-s390.brg: Reimplement LSUB_OVF due to s390 implementation of signed math.

	* cpu-s390.md: Correct size of jmp instruction. 

2005-12-13 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c (mono_arch_emit_prolog): Remove some debugging bits.

2005-12-13 Neale Ferguson <neale@sinenomine.net>

	* inssel-s390.brg tramp-s390.c cpu-s390.md mini-s390.c mini-s390.h:
	  Bring s390 up to current level.

2005-12-12  Zltan Varga  <vargaz@gmail.com>

	* generics.2.cs: Disable the newly added tests as they do not work yet.
	
	* generics.2.cs: Add valuetype tests.

2005-12-09  Zoltan Varga  <vargaz@gmail.com>

	* basic-long.cs: Add i4->u8 test.

	* objects.cs: Add tests for JIT intrinsic.

	* mini.c (mini_get_inst_for_method): Resurrect the array Rank/Length
	optimizations lost by a mistake.

2005-12-07  Zoltan Varga  <vargaz@gmail.com>

	* basic-long.cs: Remove a test moved to objects.cs.

	* arrays.cs: Add more array tests.

2005-12-06  Zoltan Varga  <vargaz@gmail.com>

	* arrays.cs: Add new tests for multi-dimensional arrays.

2005-12-06  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (test_sources2): Add generics.2.cs.
	(EXTRA_DIST): Add test_sources2.

2005-12-05  Ben Maurer  <bmaurer@ximian.com>

	Support for boxing and unboxing nullable types as well as the
	isinst operation on nullables, per the CLI ammendment.

	* inssel.brg (CEE_ISINST): Special case for nullable

	* mini.c (handle_unbox_nullable): new method
	(handle_box): Special case for nullable types
	(mono_method_to_ir): Call handle_unbox_nullable in correct
	places.

	* generics.2.cs: New test suite

	* Makefile.am: Support for regression tests with generics.

2005-12-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (emit_load_volatile_arguments): Add loading of arguments
	allocated to registers. Fixes #76800.

Thu Dec 1 12:59:40 EST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, inssel-ppc.brg: fix ABI issue (pinvoke3.cs).

2005-11-30  Zoltan Varga  <vargaz@gmail.com>

	* exceptions.cs: Disable test_0_long_cast () test, since it fails on a lot 
	of platforms.

2005-11-29  Zoltan Varga  <vargaz@gmail.com>

	* objects.cs basic-calls.cs: Move a test depending on valuetypes to
	objects.cs.

	* inssel-long32.brg (CEE_CONV_I8): Remove unused labels.
	
	* inssel-long32.brg (CEE_CONV_I8): Convert this to a branchless version.
Tue Nov 29 05:41:34 EST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, cpu-g4.md: ensure a fp register is converted to
	single precision before storing to a single precision location.

2005-11-28  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (ILASM): Use profile-dependent location of ilasm.

2005-11-27  Zoltan Varga  <vargaz@gmail.com>

	* basic-long.cs basic-calls.cs objects.cs: Move some tests to the
	correct files.

	* basic.cs: Remove test_0_byte_compares test which was moved to
	objects.cs a long time ago.

2005-11-22  Massimiliano Mantione  <massi@ximian.com>

        * aliasing.c: Fixed aliasing issue on 64 bit archs.

2005-11-20  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c exceptions-ia64.c: Simplify the way filters/finally
	handlers are called.

	* mini-ia64.c (mono_arch_emit_exceptions): Optimize size of exception
	throwing code.

	 * mini-ia64.c: Add support for the throw->branch exception 
	optimization.	

	* driver.c (DEFAULT_OPTIMIZATIONS): Add MONO_OPT_EXCEPTION.

2005-11-18  Massimiliano Mantione  <massi@ximian.com>

	* mini.c: Enabled "fastpath" deadce :-)
	
2005-11-18  Massimiliano Mantione  <massi@ximian.com>

	* mini.c: Added "fastpath" deadce (deadce without SSA), and a simple
	alias analysis pass to support it.
	* mini.h: Likewise.
	* ssa.c: Likewise.
	* liveness.c: Likewise (liveness computation can use aliasing
	information to be more accurate).
	* driver.c: Added an "ssa" option go tell the JIT to use SSA, and
	moreover made so that "--compile-all" uses the given optimization
	flags and not the default ones.
	* aliasing.c: Alias analysis (new file).
	* aliasing.h: Likewise.
	* Makefile.am: added "aliasing.c" and "aliasing.h".
	
2005-11-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-ops.h: Add missing OP_I opcodes so it is in synch with the
	OP_L opcodes.

2005-11-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_exception_internal): Remove the 
	fp >= end_of_stack exit condition, as it is not needed, and it might
	become true for fp eliminated frames.

2005-11-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_emit_epilog): Use G_STRUCT_OFFSET instead of hard
	coded offsets.

Tue Nov 8 11:28:20 GMT 2005 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: fixed alignment of doubles/longs to match
	the C ABI (bug #76635).

Mon Nov 7 16:13:21 CET 2005 Paolo Molaro <lupus@ximian.com>

	* aot.c: fix compilation with --enable-minimal=aot.

Fri Nov 4 12:34:15 GMT 2005 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: fixed compatibility with the new
	floating point emulator package for compares.

2005-11-03  Atsushi Enomoto  <atsushi@ximian.com?

	* mini.c : reverted sig->pinvoke changes (r51396-51397).

2005-11-01  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (print_stack_frame): Output to stderr.
	(mono_handle_native_sigsegv): Ditto.

2005-10-30  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_output_basic_block): Remove unused
	OP_LCONV_TO_OVF_I implementation.

	* mini-amd64.c: Add support for the throw->branch exception 
	optimization.

	* branch-opts.c (mono_branch_optimize_exception_target): Allow the case
	when the catch clause catches a more general exception, i.e. Object.

2005-10-30  Zoltan Varga  <vargaz@gmail.com>

	* cpu-ia64.md: Remove unused opcodes.

	* mini.c (GET_CONTEXT): Simplify this somewhat by removing arch
	specific defines for architectures defining USE_SIGACTION.

	* mini-ia64.c: Fix some warnings.

	* exceptions-ia64.c (mono_arch_ip_from_context): Fix this, the previous
	version seemed to skip a frame.

2005-10-30  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c: Clean up the usage of sig->pinvoke flag. Now
	only calls which are made to native code use this flag.

2005-10-29  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_compute_omit_fp): Disable fp elimination for
	varargs methods as well.
	
	* mini-amd64.c exceptions-amd64.c: Allow fp elimination in methods
	which have save_lmf set. Reorganize methods prologs a bit.

	* mini-amd64.c (mono_arch_compute_omit_fp): Move the check for the
	debugger to the proper place.

2005-10-29  Martin Baulig  <martin@ximian.com>

	* mini-amd64.c (debug_omit_fp): Temporarily disable fp elimination
	when running inside the debugger until the debugger has support
	for it.

2005-10-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Fix a warning.

2005-10-24  Miguel de Icaza  <miguel@novell.com>

	* mini.c (mono_pmip): Just a wrapper for get_method_from_ip which
	we expose publicly, this returns the string.

2005-10-22  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-amd64.c (mono_arch_find_jit_info): Fix some corner cases
	with fp elimination.

2005-10-21  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_native_sigsegv): Try to print a
	native stacktrace using the glibc 'backtrace' function if available.

2005-10-20  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MonoDebugOptions): Remove 'abort_on_sigsegv' option.

	* mini-exceptions.c (mono_handle_native_sigsegv): New function to 
	handle SIGSEGVs received while in native code.

	* mini.c (sigsegv_signal_handler): If the SIGSEGV happened in native
	code, call mono_handle_native_sigsegv which will abort the runtime
	after printing some diagnostics, instead of converting it into a
	confusing NullReferenceException.

2005-10-18  Zoltan Varga  <vargaz@gmail.com>

	* cpu-pentium.md: Remove unused opcodes.

2005-10-18  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.h (MonoLMF): Add rsp field.

	* mini-amd64.c exceptions-amd64.c tramp-amd64.c: Save the sp reg into
	the lmf too.

2005-10-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (get_register_spilling): Fix some warnings.

2005-10-16  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.h mini-amd64.c exceptions-amd64.c: Add support for fp
	elimination during exception handling. Enable fp elimination by
	default.

	* mini-amd64.h mini-amd64.c: Add preliminary support for frame pointer
	elimination.

2005-10-16  Martin Baulig  <martin@ximian.com>

	* mini-exceptions.c
	(mono_debugger_run_finally): New public method for the debugger.

2005-10-10  Zoltan Varga  <vargaz@gmail.com>

	* debug-mini.c (mono_debug_init_method): Fix warning.

	* mini.h branch-opts.c (mono_branch_optimize_exception_target): Make
	the 'exname' parameter const to fix some warnings.

2005-10-09  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (mono_handle_exception_internal): Fix another bug
	introduced by the previous patch.

2005-10-08  Zoltan Varga  <vargaz@gmail.com>

	* basic-float.cs: Add test for precision of float arithmetic.

	* mini-ia64.c (mono_arch_output_basic_block): Convert to/from doubles
	when loading/storing single values from/to memory.

	* mini.c (mono_jit_compile_method_with_opt): Create the function
	pointers in the correct domain.

2005-10-08  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (mono_handle_exception_internal): Fix bug 
	introduced by previous patch.
	
	* mini-exceptions.c (mono_handle_exception_internal): Handle the case
	when out_filter_idx is NULL.

	* mini-exceptions.c: Don't run filter clauses twice during exception
	handling. Fixes #75755.

2005-10-07  Zoltan Varga  <vargaz@gmail.com>

	* aot.c: Add support for ldflda wrappers.

	* mini.c (mono_method_to_ir): Use ldflda wrappers for CEE_LDFLDA. Fixes
	#75902.

Tue Oct 4 20:23:25 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h: do not consider exception handlers blocks when
	setting up interface variables.

2005-10-04  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (emit_section_change): Fix emitting of sections on win32. Fixes #76322.

2005-10-03  Zoltan Varga  <vargaz@gmail.com>

	* liveness.c (mono_analyze_liveness): Revert parts of r51051 since it
	causes a regression.

	* mini.c (mini_thread_cleanup): Fix reading of freed memory.

2005-10-02  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h (OP_PCONST): Move the definition of OP_PCONST into the rest
	of the OP_P definitions.

	* TODO: Add a proposal for dealing with the CEE/OP mess.

	* mini-amd64.c (mono_arch_output_basic_block): Merge mul_imm 
	optimizations from the x86 port.

	* cpu-amd64.md: Ditto.

	* basic.cs basic-long.cs: Add tests.

Fri Sep 30 20:07:20 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, driver.c, mini-x86.c, mini.c, mini.h, branch-opts.c:
	Patrik Torstensson's implementation of my exception-handling
	optimization idea, when the exception object is not used
	(bug #62150).

Fri Sep 30 19:10:29 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c, cpu-pentium.md: Patrik Torstensson's port
	of the mul_imm optimizations from the old jit.

Fri Sep 30 11:37:51 EDT 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c, liveness.c: patch by Patrik Torstensson and
	Zoltan Varga to improve performance in methods with
	exception clauses.

2005-09-30  Zoltan Varga  <vargaz@gmail.com>

	* driver.c: Remove 'Globalization' entry from --version.

2005-09-28  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_compile_method_inner): Do not load AOT code when
	there is a profiler interested in JIT events.

	* aot.c: Load profile files produced by the AOT profiling module, and
	reorder methods based on the profiling info. Add a 'method_order' table
	to the AOT file to make mono_aot_find_jit_info work with the reordered
	methods.

	* mini.h: Bump AOT file version info.

Wed Sep 28 17:12:48 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-arm.h: work around what looks like a gcc bug when optimizations
	are enabled.

2005-09-28  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (AM_CFLAGS): Don't use += to append inside
	conditionals.  Use ...
	(PLATFORM_CFLAGS, ARCH_CFLAGS): ... these.

2005-09-27  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_call_opcode): Use mono_class_value_size ()
	to determine the amount of memory to copy when passing valuetypes.

	* inssel-amd64.brg: Remove PUSH(LDIND4) rules since they convert an
	4 byte load into a 8 byte load. Fix aligning of size in OP_OUTARG_VT.

2005-09-27  Zoltan Varga  <vargaz@gmail.com>

	* mini.h mini.c aot.c: Add infrastructure to collect pagefault 
	information about aot.

2005-09-27  Ben Maurer  <bmaurer@ximian.com>

	* *.c: Replace the use of {Enter,Leave}CriticalSection with
        macros. This will allow a deadlock debugger to easily be plugged
        in.

Tue Sep 27 09:32:11 EDT 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, cpu-g4.md: added memory barrier instruction.

2005-09-27  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (AM_CFLAGS): Rename from INCLUDES.
	(AM_CFLAGS) [PLATFORM_WIN32): Append to it, don't set it.
	(AM_CFLAGS) [ARM]: Add arch/arm directory from the build tree.
	($(arch_built)) [CROSS_COMPILING]: Error out.

2005-09-26  Zoltan Varga  <vargaz@gmail.com>

	* aot.c: Add support for the no_special_static flag for classes.

2005-09-24  Zoltan Varga  <vargaz@freemail.hu>

	* Reapply reverted patches.

	* *: Revert r50174 as well.

	* mini-amd64.c cpu-amd64.md inssel-amd64.brg: Revert r50170 as well.

2005-09-24  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c: Revert r50342 to see if this fixed buildbot.

2005-09-23  Miguel de Icaza  <miguel@novell.com>

	* mini.c (SIG_HANDLER_SIGNATURE): Only dereference info if it is
	part of the SIG_HANDLER_SIGNATURE.  

2005-09-23  Zoltan Varga  <vargaz@gmail.com>

	* mini.h mini.c: Add a new MONO_DEBUG option to collect metadata pagefault
	statistics.

	* mini-x86.c (mono_arch_call_opcode): Fix vararg calling convention 
	introduced by previous patch.

2005-09-21  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c (mono_arch_create_trampoline_code): Restore caller
	saved registers too.

	* mini-x86.c (mono_arch_allocate_vars): Rewrite this so it works based 
	upon the information returned by get_call_info ().
	
	* mini-x86.c (add_float): Fix stack size calculation.
	(mono_arch_call_opcode): Rewrite this so it works based up the
	information returned by get_call_info ().
	(mono_arch_get_this_vret_args): Ditto.

2005-09-21  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_emit_this_vret_args): Use the information
	in cinfo to determine the registers which need to be used.

2005-09-20  Miguel de Icaza  <miguel@novell.com>

	* driver.c (mono_main): Add --server and --desktop flags. 

2005-09-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.h: Make register masks 64 bit. Don't treat argument
	registers as global registers.

	* inssel-ia64.brg (stmt): Remove OP_OUTARG_REG () rules which are no 
	longer needed with the new register allocator.

	* mini-ia64.c: Use OP_MOVE instead of OP_SETREG for reg-reg moves.

	* cpu-ia64.md: Remove unused opcodes.
	
	* regalloc.c mini-codegen.c: Make register masks 64 bit on ia64.
	
2005-09-16  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-amd64.md: Remove unused opcodes.

	* inssel-amd64.brg: Remove OP_OUTARG_REG () rules which are no longer
	needed with the new register allocator.

